2013-11-27 Alex Wood <awood45@gmail.com>

  * doc-src/EC2/V20131001.yml, lib/aws/api_config/EC2-2013-10-01.yml: Amazon
  EC2 API Update

  Added support for pagination of the describe_instances and describe_tags
  operations to the Amazon EC2 client.

  Added support for the new C3 instance types and the g2.2xlarge instance
  type to the Amazon EC2 client.

  Added support for enabling Single Root I/O Virtualization (SR-IOV)
  support for the new C3 instance types to the Amazon EC2 client.

2013-11-26 Sean McCann <sean@seanmccann.ca>

  * lib/aws/sns/topic.rb: Fix spelling error in comment
  * features/cloud_formation/stacks.feature,
  features/cloud_formation/step_definitions/stacks.rb,
  lib/aws/cloud_formation/stack_collection.rb,
  spec/aws/cloud_formation/stack_collection_spec.rb: Resolved an issue where
  the `AWS::CloudFormation::Stacks#with_status` would not apply the filter.

  Updated the unit tests and added an integration test that
  exercises this feature.

  Fixes #419

2013-11-23 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/version.rb: Bump version to 1.28.1

2013-11-22 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core.rb: Replaced autoload relative paths with expanded paths.

  This eliminates load order issues with aws-sdk-core.

  See (https://github.com/aws/aws-sdk-core-ruby/issues/15)

2013-11-21 Alex Wood <awood45@gmail.com>

  * README.md: Update README

  Include new Amazon RDS API version in README file.

  * ChangeLog, lib/aws/version.rb: Bump version to 1.28.0

  * doc-src/RDS/V20130909.yml, lib/aws/api_config/RDS-2013-09-09.yml,
  lib/aws/rds/client.rb: Add New API Version for Amazon RDS 2013-09-09

  This release of the Amazon Relational Database Service (RDS) introduces
  support
  for copying DB snapshots from one AWS region to another. The release also
  includes a new Amazon RDS API version, 2013-09-09.

  * features/s3/high_level/step_definitions/urls.rb,
  features/s3/high_level/urls.feature, lib/aws/s3/s3_object.rb: Added support
  for canned ACLs to S3 presigned urls.

  Example:

      bucket.objects['target-key'].url_for(:write, :acl => :public_read)

  Fixes #412

2013-11-20 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/s3/s3_object.rb, spec/aws/s3/s3_object_encrypt_spec.rb,
  spec/aws/s3/s3_object_spec.rb: A fix/workaround for streaming encrypted IO
  objects via S3.

  The `AWS::S3::CipherIO` class has a bug that causes it to report
  `#eof?` before reaching the end of the stream if `#read` is called
  with a number of bytes not divisible by 16.

  This patch works around this limitation by causing the multipart
  uploader to always use part sizes evenly divisible by 16.  CipherIO
  is a private/undocumented class, but this is a shim.  CipherIO
  should be updated to properly work when `#read` is called on the
  non-final chunk with an odd number of bytes.

  The underlying cause is the internal encryption cipher
  buffers internally and only returns values 16 bytes at a time.
  Using an internal buffer in CipherIO could solve this problem.

  Fixes #414

  * lib/aws/core/rest_request_builder.rb, lib/aws/s3/data_options.rb: Fixed a
  bug with Ruby 1.8 and how StringIO#path.

  It was assumed that IO objects responding to `#path` could be
  given to `File.size`.  This is incorrect for Ruby 1.8.7, where
  `StringIO` responds to `#path`, returning `nil`.

  This check has been expanded to responds to path and path not nil.

2013-11-19 Trevor Rowe <trevorrowe@gmail.com>

  * Gemfile: Added a nokogiri dependendency to the Gemfile for local
  development.

  This allows the travis-ci build for 1.8.7 to install Nokogiri < 1.6
  which is required for unit tests.

  * lib/aws/cloud_watch/request.rb: Updating AWS::CloudWatch to use sigv4.

  * lib/aws/core/rest_request_builder.rb, lib/aws/s3/data_options.rb: Now
  using File.size to determine file size for File/Tempfile objects.

  It is possible for a File/Tempfile to report an incorrect value
  from `#size`.  This change causes the SDK to prefer the response
  from `File.size(file.path)` over `file.size`.

  See https://github.com/thoughtbot/paperclip/issues/751

  * lib/aws/version.rb: Bump version to 1.27.0

2013-11-14 Alex Wood <awood45@gmail.com>

  * README.md, lib/aws/core/region.rb: Add AWS CloudTrail to README and Region
  File

  * ChangeLog, lib/aws/version.rb: Bump version to 1.26.0

  * doc-src/CloudTrail/V20131101.yml, endpoints.json,
  features/cloud_trail/client.feature,
  features/cloud_trail/step_definitions/client.rb,
  features/cloud_trail/step_definitions/cloud_trail.rb,
  lib/aws/api_config/CloudTrail-2013-11-01.yml, lib/aws/cloud_trail.rb,
  lib/aws/cloud_trail/client.rb, lib/aws/cloud_trail/config.rb,
  lib/aws/cloud_trail/errors.rb, lib/aws/cloud_trail/request.rb,
  lib/aws/core.rb, spec/aws/cloud_trail_spec.rb: Initial Support for AWS
  CloudTrail

  AWS CloudTrail is a web service that records AWS API calls for your account
  and
  delivers log files to you. The recorded information includes the identity of
  the
  API caller, the time of the API call, the source IP address of the API
  caller,
  the request parameters, and the response elements returned by the AWS
  service.

2013-11-13 Alex Wood <awood45@gmail.com>

  * doc-src/IAM/V20100508.yml, lib/aws/api_config/IAM-2010-05-08.yml: API
  Updates to AWS Identity and Access Management

  With this release of AWS Identity and Access Management (IAM), you can
  enable
  identity federation using SAML 2.0 (Security Assertion Markup Language 2.0),
  an
  open standard. This feature enables federated single sign-on, or SSO, which
  lets
  users log into the AWS Management Console or make programmatic calls to AWS
  APIs
  using authentication responses (assertions) from a SAML-compliant identity
  provider.

  * doc-src/STS/V20110615.yml, lib/aws/api_config/STS-2011-06-15.yml: Add SAML
  support for AWS Security Token Service

  Includes a new AWS Security Token Service (STS) API action called
  AssumeRoleWithSAML that returns a set of temporary security credentials for
  users who have been authenticated via a SAML authentication response.

  * doc-src/Redshift/V20121201.yml,
  lib/aws/api_config/Redshift-2012-12-01.yml: API Updates to Amazon Redshift

  This release for Amazon Redshift includes several new features related to
  event
  notifications, encryption, audit logging, data load from external hosts, WLM
  configuration, and database distribution styles and functions.

2013-11-12 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core/response.rb: Rewinding the body before re-signing.  This
  affects sigv4 signed retries.

2013-11-11 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/dynamo_db/table.rb: Removed a documentation note about reducing
  provisioned capacity that was incorrect.

  Fixes #406

2013-11-08 Alex Wood <awood45@gmail.com>

  * README.md: Update README

  Add new AWS Storage Gateway API version to README.

  * ChangeLog, lib/aws/version.rb: Bump version to 1.25.0

  * doc-src/CloudFormation/V20100515.yml,
  lib/aws/api_config/CloudFormation-2010-05-15.yml: API Updates for AWS
  CloudFormation

  * doc-src/ElasticTranscoder/V20120925.yml,
  lib/aws/api_config/ElasticTranscoder-2012-09-25.yml: API Updates for Amazon
  Elastic Transcoder

  * doc-src/ELB/V20120601.yml, lib/aws/api_config/ELB-2012-06-01.yml: Add
  Cross-Zone Balancing to Elastic Load Balancing

  Updates AWS::ELB::Client.

  * doc-src/StorageGateway/V20130630.yml,
  features/storage_gateway/client.feature,
  lib/aws/api_config/StorageGateway-2013-06-30.yml,
  lib/aws/storage_gateway/client.rb: New API Version 2013-06-30 for AWS
  Storage Gateway

  AWS Storage Gateway now supports Gateway-VTL.

  AWS::StorageGateway::Client supports the '2012-06-30' and '2013-06-30' API
  versions, this change defaults users to the '2013-06-30' version and updates
  tests to handle this version.

  * lib/aws/core.rb, lib/aws/core/configuration.rb: Updating documentation
  about :max_retries to include information about throttling errors.

2013-11-06 Torsten Becker <torsten.becker@gmail.com>

  * lib/aws/sns/subscription.rb, spec/aws/sns/subscription_spec.rb: Support
  RawMessageDelivery on SNS subscriptions.

2013-11-03 Kyle VanderBeek <kylev@kylev.com>

  * README.md, aws-sdk.gemspec: Remove Nokogiri < 1.6 restriction and explain
  in the README how to get things working on Ruby 1.8.x.

2013-11-02 osamu1203 <osamuintz@gmail.com>

  * lib/aws/s3/uploaded_part.rb: Fixed raise message
2013-10-31 Alex Wood <awood45@gmail.com>

  * doc-src/ElastiCache/V20121115.yml: Remove Unused Amazon ElastiCache
  Documentation

  An older client doc source was causing the AWS::ElastiCache::Client docs
  to be out of date. This change deletes the offending file.

  * lib/aws/auto_scaling/scheduled_action.rb,
  lib/aws/auto_scaling/scheduled_action_collection.rb,
  spec/aws/auto_scaling/scheduled_action_collection_spec.rb,
  spec/aws/auto_scaling/scheduled_action_spec.rb: Fixed a bug with AutoScaling
  scheduled actions.

  The `AWS::AutoScaling::ScheduledAction` class incorrectly assumed that their
  group names were unique and suffient to identify the action.  In order to
  correct
  this bug, it was required to add a new positional required argument to the
  `ScheduledAction` constructor.  This affects two code paths.

  First, the scheduled action collection must now be scoped by a group:

      # now raises an error, must scope to a group first
      auto_scaling.scheduled_actions['name']

      # this works
      auto_scaling.groups['group-name'].scheduled_actions['name']

      # this also works
      auto_scaling.scheduled_actions.filter(:group => 'group-name')['name']

  Also the constructor now requires a group:

      # no longer works, raises error
      AWS::AutoScaling::ScheduledAction.new('name')

      # this works
      group = AWS::AutoScaling::Group.new('group-name')
      AWS::AutoScaling::ScheduledAction.new(group, 'name')

  * lib/aws/ec2/elastic_ip.rb: Allow the ability to supply private IP to the
  associate method and use a particular secondary IP on an ENI

  * ChangeLog, lib/aws/version.rb: Bump version to 1.24.0

2013-10-30 Alex Wood <awood45@gmail.com>

  * doc-src/ElastiCache/V20130615.yml,
  lib/aws/api_config/ElastiCache-2013-06-15.yml: Amazon ElastiCache Updates

  Update ElastiCache docs to latest version, adds an optional parameter and
  makes
  some required parameters optional.

  * lib/aws/ec2/volume_collection.rb: Update volume_collection.rb

  VolumeCollection#each docs says that the method yields on the Instance. It
  actually yields on the Volume. Update docs to reflect clode
2013-10-28 Alex Wood <awood45@gmail.com>

  * doc-src/EMR/V20090331.yml, lib/aws/api_config/EMR-2009-03-31.yml: API
  Updates for Amazon Elastic MapReduce

  * lib/aws/s3/client.rb, spec/aws/s3/client_spec.rb: Support S3 GET Object
  torrent

2013-01-28 Bernat Foj Capell <bfcapell@gmail.com>

  * lib/aws/api_config/EC2-2013-08-15.yml,
  lib/aws/api_config/EC2-2013-10-01.yml: Updated API definition of Monitoring
  field in request_spot_instances method

  * ChangeLog, lib/aws/version.rb: Bump version to 1.8.1.1

  * .travis.yml: Removed REE from travis configuration, currently broken on
  travis-ci.org.

  * aws-sdk.gemspec: Removed HTTParty from gem specification.

  * ChangeLog, lib/aws/version.rb: Bump version to 1.8.1

  * features/elastic_transcoder/client.feature,
  features/elastic_transcoder/step_definitions/client.rb,
  features/elastic_transcoder/step_definitions/elastic_transcoder.rb,
  features/iam/step_definitions/iam.rb,
  features/iam/step_definitions/roles.rb,
  lib/aws/elastic_transcoder/client.rb: Added support for Elastic Transcoding
  errors and some integration tests.

2013-10-26 Michael H. Oshita <ijinpublic+github@gmail.com>

  * lib/aws/core/credential_providers.rb: fixed typo

  cashed -> cached
2013-10-24 Alex Wood <awood45@gmail.com>

  * README.md: Add all supported CloudFront API versions to README

  * ChangeLog, lib/aws/version.rb: Bump version to 1.23.0

  * features/direct_connect/step_definitions/client.rb: Update AWS
  DirectConnect Integration Test

  Cucumber test points to a method now removed, change test to
  point to a new function.

  * README.md: Fix README Tables

  * doc-src/DirectConnect/V20121025.yml,
  lib/aws/api_config/DirectConnect-2012-10-25.yml: Update AWS DirectConnect to
  latest API Version

2013-10-22 Jason LaPier <jasonlp@elementaltechnologies.com>

  * lib/aws/ec2/instance_collection.rb: delete the associate_public_ip_address
  option from create instance params whether it is true or false

2013-10-20 Joel Van Horn <joel@joelvanhorn.com>

  * lib/aws/s3/s3_object.rb: Fixed link
  * lib/aws/s3/tree.rb: fix documentation typo from 20011 to 2011

2013-10-18 Alex Wood <awood45@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.22.1

  * lib/aws/core/json_parser.rb: Handle Null Values in JSON Parser

  * lib/aws/ec2/instance_collection.rb: adds public IP option to instances in
  VPC

  allows you to pass :associate_public_ip_address to
  InstanceCollection#create,
  and applies this value to the network interface options.
  NOTE: in order for this to work, a couple of other options have to be moved
  out of the base and into the network interface:
  private_ip_address, subnet, and security_group_ids

  * lib/aws/s3/s3_object.rb: S3Object#url_for docummentation update

2013-10-17 Alex Wood <awood45@gmail.com>

  * lib/aws/cloud_front/client.rb: Support Older CloudFront Clients

  * README.md: Fix Amazon CloudFront Version in README

  * ChangeLog, lib/aws/version.rb: Bump version to 1.22.0

  * doc-src/ElasticTranscoder/V20120925.yml,
  lib/aws/api_config/ElasticTranscoder-2012-09-25.yml: Audio-Only Support for
  Amazon Elastic Transcoder.

  Adds support for audio-only transcoding features in Amazon Elastic
  Transcoder.

  * doc-src/CloudFront/V20130927.yml,
  lib/aws/api_config/CloudFront-2013-09-27.yml, lib/aws/cloud_front/client.rb:
  Amazon CloudFront API Version Bump to 2013-09-27

  * spec/aws/dynamo_db/client_versions_spec.rb: Fixed spec that was using 1.9+
  syntax to work with 1.8

  * lib/aws/core/xml/frame_stack.rb,
  lib/aws/core/xml/sax_handlers/nokogiri.rb,
  lib/aws/core/xml/sax_handlers/rexml.rb: Fixed the REXML xml parser.

  Fixes #318

  * lib/aws/core/client.rb, spec/aws/dynamo_db/client_versions_spec.rb: When
  constructing a client, the API version can be specified via the :config
  option.

  Here is an example of the behavior that was fixed:

       config = AWS.config.with(dynamo_db: { api_version: '2012-08-10' })
       AWS::DynamoDB::Client.new(config: config)
       #=> #<AWS::DynamoDB::Client::V20120810>

  Fixed #355

  * features/dynamo_db/scan.feature,
  features/dynamo_db/step_definitions/dynamo_db.rb,
  features/dynamo_db/step_definitions/scan.rb,
  lib/aws/dynamo_db/item_collection.rb: Fixed a bug in
  AWS::DynamoDB::ItemCollection#first

  When calling `#first` on a collection with a where collection,
  the `:limit` param was incorrectly being used, causing many
  extra requets.

  Fixes #385

  * lib/aws/s3/object_collection.rb: Corrected the documentation for
  AWS::S3::ObjectCollection#create.

  Fixes #368

  * lib/aws/simple_db/item_collection.rb,
  spec/aws/simple_db/item_collection_spec.rb: Fixed issue with
  SimpleDB::ItemCollection#where.

  If a placeholder received a substituted value that looked
  like another placeholder, then an `ArgumentError` was
  raised.

  Now placeholders in the final string are checked against the
  original to see if they are actual placeholders that were
  not replaced before raising.

  Fixes #386

  * README.md: Updated the list of supported AWS API versions in the README.

  * lib/aws/core/rest_request_builder.rb: Fixed an issue with uploading files
  to Glacier in Ruby 1.8.

2013-10-10 Dan Fried <daniel.k.fried@gmail.com>

  * lib/aws/sts/config.rb: Add conditional to STS to work with both govcloud
  and commercial API endpoints

2013-10-09 Trevor Rowe <trevorrowe@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.21.0

  * doc-src/EC2/V20131001.yml, lib/aws/api_config/EC2-2013-10-01.yml,
  lib/aws/ec2/client.rb: Added support for Reserved Instance instance type
  modifications in Amazon EC2 (API version 2013-10-01).

  * doc-src/OpsWorks/V20130218.yml,
  lib/aws/api_config/OpsWorks-2013-02-18.yml: Added support for new resource
  management features in AWS OpsWorks.

2013-10-04 Andy Brody <andy@stripe.com>

  * spec/aws/iam/signing_certificate_spec.rb: Add test for signing cert
  upload_date.

  * lib/aws/iam/signing_certificate.rb: Expose upload_date attribute on
  certificates.

  * spec/aws/iam/access_key_spec.rb: Add test of create_date.

  * lib/aws/iam/access_key.rb: Expose the create_date attribute of access
  keys.

  * samples/sns/publish.rb: Update publish.rb
2013-10-03 Bouke van der Bijl <boukevanderbijl@gmail.com>

  * lib/aws/s3/data_options.rb, spec/aws/s3/s3_object_spec.rb: Duplicate
  frozen strings before forcing the encoding to prevent a RuntimeError

2013-10-01 Alex Wood <awood45@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.20.0

  * doc-src/CloudFront/V20130826.yml,
  lib/aws/api_config/CloudFront-2013-08-26.yml, lib/aws/cloud_front/client.rb:
  Update API version for Amazon CloudFront.

2013-09-27 Volker Tietz <volker.tietz@gmail.com>

  * lib/aws/auto_scaling/launch_configuration.rb,
  lib/aws/auto_scaling/launch_configuration_collection.rb,
  spec/aws/auto_scaling/launch_configuration_collection_spec.rb,
  spec/aws/auto_scaling/launch_configuration_spec.rb: Added support for
  AssociatePublicIpAddress option in LaunchConfiguration. Fixes Issue #372

2013-09-24 Dan Fried <daniel.k.fried@gmail.com>

  * endpoints.json, lib/aws/sts/config.rb: Add Simple Token Service API
  support for Govcloud region, which has a different API endpoint

2013-09-20 Alex Wood <awood45@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.19.0

  * doc-src/AutoScaling/V20110101.yml,
  lib/aws/api_config/AutoScaling-2011-01-01.yml: API Updates for Auto Scaling

  * lib/aws/s3/s3_object.rb: Add documentation for setting Content-Disposition
  in copy_from

  #66 added support for setting the Content-Disposition header in `copy_from`,
  but the documentation didn't reflect that this new option was available.
2013-09-19 Markus Krogemann <markus@krogemann.de>

  * lib/aws/route_53/change_info.rb: fix documentation: replace 'alarm' with
  'change'

2013-09-16 Loren Segal <lsegal@amazon.com>

  * aws-sdk.gemspec: Give Bundler a hint about which Nokogiri version to use.

  Bundler seems to have problems resolving version conflicts with
  less-than constraints (as per bundler/bundler#2593), so provide a
  greater-or-equal-to constraint as well to give Bundler a hint.

  Closes #361

  * tasks/docs.rake: Add SITEMAP_BASEURL to docs task

2013-09-14 Loren Segal <lsegal@soen.ca>

  * Gemfile: Use 1.8 syntax in Gemfile
  * .yardopts: Use yard-sitemap plugin when generating documentation
  * Gemfile: Add yard-sitemap to Gemfile, update rdiscount gem location
2013-09-13 Alex Wood <awood45@gmail.com>

  * lib/aws/s3/client.rb: Add parameter validation to put_bucket_cors

  Adds validation that two required parameters in
  AWS::S3::Client#put_bucket_cors
  are present and match the type requirements.

  Resolves Issue #357

2013-09-11 Alex Wood <awood45@gmail.com>

  * README.md: Update EC2 Version in README

  * ChangeLog, lib/aws/version.rb: Bump version to 1.18.0

  * doc-src/EC2/V20130201.yml, doc-src/EC2/V20130815.yml,
  lib/aws/api_config/EC2-2013-07-15.yml,
  lib/aws/api_config/EC2-2013-08-15.yml, lib/aws/ec2/client.rb: Upgrade
  AWS::EC2::Client to latest API version.

  Upgrades AWS::EC2::Client to 2013-08-15 API version. Includes modifications
  to
  Amazon EC2 Reserved Instances API.

2013-09-10 Trevor Rowe <trevorrowe@gmail.com>

  * features/glacier/step_definitions/vaults.rb,
  features/glacier/vaults.feature, lib/aws/glacier/vault.rb: Fixed a bug with
  Glacier::Vault attributes.

2013-09-09 Alex Wood <awood45@gmail.com>

  * doc-src/OpsWorks/V20130218.yml,
  lib/aws/api_config/OpsWorks-2013-02-18.yml: Update AWS OpsWorks to latest
  API version.

  Adds VPC support to AWS OpsWorks.

2013-09-06 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/s3/client.rb: Moved code from the s3 versioned client into the
  base client class.

  This fixes a few broken specs.

2013-09-05 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core/client.rb, lib/aws/s3/client.rb: Resolved an issue where
  service client classes returned an empty list from .operations

  The versioned client classes correctly return the list of operations
  they support.  The service client class now proxies the call to the
  versioned client class.

2013-09-04 Alex Wood <awood45@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.17.0

  * README.md, doc-src/ElastiCache/V20130615.yml,
  lib/aws/api_config/ElastiCache-2012-11-15.yml,
  lib/aws/api_config/ElastiCache-2013-06-15.yml,
  lib/aws/elasticache/client.rb: Add Redis support to Amazon ElastiCache

  Updates the AWS::ElastiCache::Client class to the latest API version.

  * lib/aws/simple_workflow.rb: fix AWS::SimpleWorkflow documentation example.

2013-09-03 Kyle Dayton <kyle@graphicflash.com>

  * lib/aws/simple_email_service.rb, spec/aws/simple_email_service_spec.rb:
  Updated Spec for simple email service

  * lib/aws/simple_email_service.rb: Updated SimpleEmailService#send_email and
  #send_raw_email to return Message ID instead of nil

  * README.md: Bump EC2 API version in README

2013-08-30 Alex Wood <awood45@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.16.1

  * lib/aws/api_config/EC2-2013-02-01.yml,
  lib/aws/api_config/EC2-2013-07-15.yml, lib/aws/ec2/client.rb: Correct EC2
  Client Version to 2013-07-15

2013-08-29 Alex Wood <awood45@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.16.0

2013-08-28 Alex Wood <awood45@gmail.com>

  * lib/aws/simple_workflow/request.rb: Upgrade AWS::SimpleWorkflow to SigV4

  * doc-src/EC2/V20130201.yml, lib/aws/api_config/EC2-2013-02-01.yml: API
  Update for Amazon EC2

  Updates AWS::EC2::Client to support public IPs in VPC, and an optional
  dry run flag.

  * lib/aws/core/configuration.rb, spec/aws/dynamo_db_spec.rb: Test failure
  fixes for DynamoDB.

  The way we dealt with the configuration in the previous change on
  DynamoDB clients had knock on effects to clients of, for example,
  Simple Email Service. Fixed those, and updated tests for DynamoDB
  to handle the different way we instantiate its client.

  * features/dynamo_db/step_definitions/versioning.rb,
  features/dynamo_db/versioning.feature, lib/aws/core/configuration.rb,
  lib/aws/dynamo_db.rb: Make AWS::DynamoDB use legacy client.

  The higher level abstractions provided for DynamoDB only work fully with
  the legacy version of the low-level client. This change forces the higher
  level abstractions to fall back to the legacy client API, but allows use of
  the new client-level API directly.

2013-08-26 Alex Wood <awood45@gmail.com>

  * lib/aws/s3/object_metadata.rb, lib/aws/s3/s3_object.rb: Deprecated
  AWS::S3::ObjectMetadata#[]=

  Marked AWS::S3::ObjectMetadata#[]= as deprecated and updated documentation
  to include a warning note on unexpected changes to metadata and values it
  does not set. Updated AWS::S3::S3Object#copy_from documentation to explain
  risks of setting metadata hash without copying previous values.

  Resolves Issue #325

2013-08-23 Alex Wood <awood45@gmail.com>

  * spec/aws/dynamo_db/table_spec.rb: Make AWS::DynamoDB::Table tests support
  1.8.7

  Ruby 1.8.7 doesn't support Time.new with parameters. Using Time.now
  instead since that is sufficient for the cases covered.

  * features/dynamo_db/step_definitions/tables.rb,
  features/dynamo_db/tables.feature, lib/aws/dynamo_db/table.rb,
  spec/aws/dynamo_db/table_spec.rb: Add high level methods to
  AWS::DynamoDB::Table

  Adds item_count and size_bytes to the Amazon DynamoDB high level
  abstraction layer. Relevant Cucumber and RSpec tests included to
  make the process of adding these for later releases a little easier.

2013-08-22 Jon <jonathan.j.mason@gmail.com>

  * lib/aws/sqs/errors.rb: Update documentation for BatchSendError.

  Note that the previous documentation was copied from
  BatchChangeVisibilityError and contained inaccuracies.

  * lib/aws/sqs/queue.rb, spec/aws/sqs/queue_spec.rb: Add body and index to
  BatchSendError.failures

  * Add :message_body and :batch_index to entries in BatchSendError.failures.

  * Updates specs to reflect this

  Updates specs to reflect the changes.

  * lib/aws/core/xml/sax_handlers/nokogiri.rb, lib/aws/s3/client.rb,
  lib/aws/s3/client/xml.rb, spec/aws/s3/client_spec.rb: Add AWS::S3::Client
  Bucket Logging Methods

  Adds the following methods and associated tests:
  AWS::S3::Client#get_bucket_logging
  AWS::S3::Client#put_bucket_logging

  Also adds a method to the Nokogiri Sax Handler to handle comments
  in XML by ignoring them.

  * spec/aws/s3/client_spec.rb, spec/aws/simple_email_service_spec.rb,
  spec/aws/sqs/queue_spec.rb, spec/shared/aws_client_examples.rb: Replaced
  #stub! calls with #stub to silence rspec deprecation warnings.

  * lib/aws/core/configuration.rb, spec/aws_spec.rb: Resolved an issue where
  config might get stuck in a recursive loop.

  When building a service endpoint, the region is used to construct the
  default endpoint.  When attempting to determine the region, the endpoint
  is is parsed (recursive loop).

  The recent patch to make endpoint use the svc region instead of the global
  region uncovered this bug.  This patch stops the loops by changing the logic
  in #svc_endpoint to used only the explicitly configured regions, and never
  a region guessed from the endpoint.

  * lib/aws/core/configuration.rb, spec/aws_spec.rb: Fixed an issue around
  configuring endpoints by service region.

  * Gemfile: Loosened the rspec version dependency.

2013-08-13 Trevor Rowe <trevorrowe@gmail.com>

  * spec/aws/s3/s3_object_encrypt_spec.rb, spec/spec_helper.rb: Updated a spec
  to work with a newer version of rspec.

  * lib/aws/sqs/errors.rb, lib/aws/sqs/queue.rb, spec/aws/sqs/queue_spec.rb:
  Add MD5 validation for Amazon SQS.

  When available, validates SQS operations against MD5 checksums,
  raising errors when there are mismatches.

2013-08-14 Alex Wood <awood45@gmail.com>

  * lib/aws/core/configuration.rb: Remove SQS checksum verification from
  global config.

  Accidentally left the old location of :sqs_validate_checksums
  out of the pull request. Removing the old version, tests still
  pass.

  * lib/aws/core.rb, lib/aws/core/configuration.rb, lib/aws/sqs/config.rb,
  lib/aws/sqs/queue.rb: Configuration toggle for SQS MD5 check.

  Adds :sqs_verify_checksums to the AWS config. True by default,
  setting this value to false will skip the validation of MD5
  checksums for SQS operations.

2013-08-12 Alex Wood <awood45@gmail.com>

  * lib/aws/version.rb: Bump version to 1.15.0

  * ChangeLog, spec/aws/emr/instance_group_collection_spec.rb,
  spec/aws/emr/instance_group_spec.rb: Fix EMR spec stubbing.

  JSON stubbing is not as sophisticated as XML stubbing, added missing
  values to spec tests.

  * doc-src/SNS/V20100331.yml, lib/aws/api_config/SNS-2010-03-31.yml: Update
  AWS::SNS::Client API to latest version.

  SNS now supports mobile push.

  * doc-src/Redshift/V20121201.yml,
  lib/aws/api_config/Redshift-2012-12-01.yml: API updates for Amazon Redshift.

  Adds cluster snapshot identifiers to CopyClusterSnapshot and
  DeleteClusterSnapshot. Enables better status reporting for
  restoring from snapshots.

  * lib/aws/api_config/EMR-2009-03-31.yml, lib/aws/emr/client.rb,
  lib/aws/emr/request.rb: Updated EMR to use SigV4 and AWS JSON protocol.

2013-08-11 Loren Segal <lsegal@amazon.com>

  * lib/aws/s3/client.rb, spec/aws/s3/client_spec.rb: Fix
  S3::Client#get_object with exclusive Range

  Fixes #326

2013-08-01 Anatoly Mikhailov <mikhailov.anatoly@gmail.com>

  * lib/aws/rails.rb: Make possible to use without ActionMailer

  I use aws-sdk with background uploading queue, so it makes sense to turn off
  any unused Rails libraries. It's possible to turn off every Rails specific
  libraries except ActionMailer, so it works:


  ```ruby
  config.frameworks -= [ :active_record, :active_resource, :action_controller,
  :action_view]
  ```

  But it doesn't work

  ```ruby
  config.frameworks -= [:action_mailer]
  ```

  The fix makes sure that you load ActionMailer to use it with SNS
2013-07-30 Alex Wood <awood45@gmail.com>

  * lib/aws/core/configuration.rb: Update AWS::Core::Configuration
  documentation.

  Document the verify_response_body_content_length parameter.

  * lib/aws/dynamo_db.rb: Update AWS::DynamoDB documentation example.

  Example of table creation in docs did not work, added missing
  parameters.

2013-07-29 Alex Wood <awood45@gmail.com>

  * lib/aws/core/configuration.rb, lib/aws/core/http/net_http_handler.rb,
  spec/aws/core/http/net_http_handler_spec.rb: Verify content-length for
  Net::HTTP responses.

  Some downloads from Amazon S3 can be truncated, and Net::HTTP
  does not check response body size against the content-length
  specified in the response header. This change adds such a check,
  which can be toggled on or off (on by default) in the AWS.config.

  * lib/aws/sns/message.rb: Add accessors for Token and SubscribeURL

  * lib/aws/sns/message.rb: Support SubscriptionConfirmation and
  UnsubscribeConfirmation messages

  * spec/aws/sns/message_spec.rb: Validate that a properly signed message is
  authentic

  * .yardopts, Gemfile: Use --hide-api private instead of --no-api

  * lib/aws/core/configuration.rb, lib/aws/core/http/net_http_handler.rb,
  spec/aws/core/http/net_http_handler_spec.rb: Verify content-length for
  Net::HTTP responses.

  Some downloads from Amazon S3 can be truncated, and Net::HTTP
  does not check response body size against the content-length
  specified in the response header. This change adds such a check,
  which can be toggled on or off (on by default) in the AWS.config.

2013-07-25 Alex Wood <awood45@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.14.1

  * features/cloud_front/step_definitions/client.rb: Fixed broken
  AWS::CloudFront integration tests.

  * lib/aws/cloud_front/request.rb: Updated CloudFront to use signature v4

  Fixes #317

2013-07-24 Trevor Rowe <trevorrowe@gmail.com>

  * README.md: Removed GitHub style code blocks from README, they were causing
  issues in the YARD documentation.

  * ChangeLog, lib/aws/version.rb: Bump version to 1.14.0

  * doc-src/OpsWorks/V20130218.yml,
  lib/aws/api_config/OpsWorks-2013-02-18.yml: Updated AWS::OpsWorks::Client to
  latest API version.

  * doc-src/templates/default/layout/html/footer.erb: Fix SiteCatalyst link

  * lib/aws/dynamo_db/client.rb: Added back missing zlib statement.

2013-07-23 Landon Clark <landon.clark@wildflowerhealth.com>

  * lib/aws/ec2/tag_collection.rb: Fixed example for creating a tag collection
  for an ec2 instance.

  * .yardopts, doc-src/CloudSearch/V20110201.yml,
  doc-src/CloudWatch/V20100801.yml, doc-src/DataPipeline/V20121029.yml,
  doc-src/DynamoDB/V20111205.yml, doc-src/DynamoDB/V20120810.yml,
  doc-src/EC2/V20130201.yml, doc-src/ELB/V20120601.yml,
  doc-src/EMR/V20090331.yml, doc-src/ElastiCache/V20121115.yml,
  doc-src/IAM/V20100508.yml, doc-src/OpsWorks/V20130218.yml,
  doc-src/RDS/V20130515.yml, doc-src/Redshift/V20121201.yml,
  doc-src/Route53/V20121212.yml, doc-src/SNS/V20100331.yml,
  doc-src/SQS/V20121105.yml, doc-src/STS/V20110615.yml,
  doc-src/SimpleDB/V20090415.yml, doc-src/SimpleEmailService/V20101201.yml,
  doc-src/SimpleWorkflow/V20120125.yml: Moved API doc src from client classes
  into YAML files.

  * lib/aws/api_config/SNS-2010-03-31.yml,
  lib/aws/api_config/SimpleWorkflow-2012-01-25.yml: Updated SWF and SNS api
  configurations.

2013-07-22 Trevor Rowe <trevorrowe@gmail.com>

  * doc-src/AutoScaling/V20110101.yml, doc-src/CloudFormation/V20100515.yml,
  doc-src/CloudFront/V20130512.yml, doc-src/CloudSearch/V20110201.yml,
  doc-src/CloudWatch/V20100801.yml, doc-src/DataPipeline/V20121029.yml,
  doc-src/DirectConnect/V20121025.yml, doc-src/DynamoDB/V20111205.yml,
  doc-src/DynamoDB/V20120810.yml, doc-src/EC2/V20130201.yml,
  doc-src/ELB/V20120601.yml, doc-src/EMR/V20090331.yml,
  doc-src/ElastiCache/V20121115.yml, doc-src/ElasticBeanstalk/V20101201.yml,
  doc-src/ElasticTranscoder/V20120925.yml, doc-src/Glacier/V20120601.yml,
  doc-src/OpsWorks/V20130218.yml, doc-src/RDS/V20130515.yml,
  doc-src/Redshift/V20121201.yml, doc-src/Route53/V20121212.yml,
  doc-src/SNS/V20100331.yml, doc-src/SQS/V20121105.yml,
  doc-src/SimpleDB/V20090415.yml, doc-src/SimpleEmailService/V20101201.yml,
  doc-src/SimpleWorkflow/V20120125.yml, doc-src/StorageGateway/V20120630.yml,
  doc-src/Support/V20130415.yml: Fixed faultly formatting of api docs.

  * lib/aws/dynamo_db/client_v2.rb: Replaces @api private with @deprecated for
  AWS::DynamoDB::ClientV2.

  * lib/aws/dynamo_db.rb, lib/aws/dynamo_db/client.rb,
  lib/aws/dynamo_db/client_base.rb: Removed the no-longer-needed
  DynamoDB::ClientBase class.

  * .yardopts, doc-src/AutoScaling/V20110101.yml,
  doc-src/CloudFormation/V20100515.yml, doc-src/CloudFront/V20130512.yml,
  doc-src/CloudSearch/V20110201.yml, doc-src/CloudWatch/V20100801.yml,
  doc-src/DataPipeline/V20121029.yml, doc-src/DirectConnect/V20121025.yml,
  doc-src/DynamoDB/V20111205.yml, doc-src/DynamoDB/V20120810.yml,
  doc-src/EC2/V20130201.yml, doc-src/ELB/V20120601.yml,
  doc-src/EMR/V20090331.yml, doc-src/ElastiCache/V20121115.yml,
  doc-src/ElasticBeanstalk/V20101201.yml,
  doc-src/ElasticTranscoder/V20120925.yml, doc-src/Glacier/V20120601.yml,
  doc-src/IAM/V20100508.yml, doc-src/ImportExport/V20100601.yml,
  doc-src/OpsWorks/V20130218.yml, doc-src/RDS/V20130515.yml,
  doc-src/Redshift/V20121201.yml, doc-src/Route53/V20121212.yml,
  doc-src/SNS/V20100331.yml, doc-src/SQS/V20121105.yml,
  doc-src/STS/V20110615.yml, doc-src/SimpleDB/V20090415.yml,
  doc-src/SimpleEmailService/V20101201.yml,
  doc-src/SimpleWorkflow/V20120125.yml, doc-src/StorageGateway/V20120630.yml,
  doc-src/Support/V20130415.yml, doc-src/api_docs_plugin.rb: Moved Client
  class API documentation into yaml files inside doc-src.

  These are now applied to the client classes as well as the parent Client
  class.

  * lib/aws/sns/message.rb: Minor yard doc tag fix.

2013-07-19 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/auto_scaling/client.rb, lib/aws/cloud_formation/client.rb,
  lib/aws/cloud_front/client.rb, lib/aws/cloud_search/client.rb,
  lib/aws/cloud_watch/client.rb, lib/aws/data_pipeline/client.rb,
  lib/aws/direct_connect/client.rb, lib/aws/ec2/client.rb,
  lib/aws/elastic_beanstalk/client.rb, lib/aws/elastic_transcoder/client.rb,
  lib/aws/elasticache/client.rb, lib/aws/elb/client.rb, lib/aws/emr/client.rb,
  lib/aws/glacier/client.rb, lib/aws/iam/client.rb,
  lib/aws/import_export/client.rb, lib/aws/ops_works/client.rb,
  lib/aws/rds/client.rb, lib/aws/redshift/client.rb,
  lib/aws/route_53/client.rb, lib/aws/simple_db/client.rb,
  lib/aws/simple_email_service/client.rb, lib/aws/simple_workflow/client.rb,
  lib/aws/sns/client.rb, lib/aws/sqs/client.rb,
  lib/aws/storage_gateway/client.rb, lib/aws/sts/client.rb,
  lib/aws/support/client.rb: Removed static API documentation from client
  classes.

  * .yardopts, Gemfile: Configured yard to use rdiscount instead of redcarpet.

  * features/ec2/reserved_instances.feature,
  features/ec2/step_definitions/reserved_instances.rb,
  lib/aws/ec2/reserved_instances_offering_collection.rb: Added support for
  paging Amazon EC2 reserved instances offerings.

2013-07-18 Alex Wood <awood45@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.13.0

  * lib/aws/api_config/Redshift-2012-12-01.yml, lib/aws/redshift/client.rb:
  Updated AWS::Redshift::Client to latest API version.

2013-07-15 Trevor Rowe <trevorrowe@gmail.com>

  * spec/shared/aws_client_examples.rb: Disabed aync test.

  * lib/aws/s3/client.rb, spec/aws/s3/client_spec.rb:
  AWS::S3::Client#put_bucket_website now omits empty routing rules.

  This resolves an issue where passing `:routing_rules => []` to the
  client would result in an error returned from Amazon S3.  S3 does
  not accept `<RoutingRules/>`.

  Fixes #308

  * lib/aws/core.rb: Update documentation for AWS.memoize.

  AWS.memoize documentation incorrectly stated that memoize was
  only supported for EC2, when in fact it is supported for classes
  which inherit from Resource.

  * README.md: Updated list of supported API versions in the README.

2013-07-11 Alex Wood <awood45@gmail.com>

  * lib/aws/api_config/STS-2011-06-15.yml, lib/aws/sts/client.rb: Added
  AWS::STS::Client#decode_authorization_message

  * spec/aws/simple_email_service/identity_spec.rb: Updated indentation of
  simple_email_service/identity_spec.rb

2013-07-10 Loren Segal <lsegal@soen.ca>

  * tasks/docs.rake: Update docs.rake
  * .travis.yml: Ignore some Gemfile groups in Travis tests.
  * spec/aws/simple_email_service/identity_spec.rb: Updated
  simple_email_service/identity_spec.rb with tests for #verify_dkim

  * lib/aws/simple_email_service/identity.rb: Fix typo in
  SimpleEmailService::Identity

  * lib/aws/route_53/hosted_zone.rb, lib/aws/route_53/resource_record_set.rb:
  resource_identifiers should be protected

  * lib/aws/cloud_front/client.rb: Bumped CloudFront API client.

  * spec/aws/rds/client_spec.rb: Updated RDS client spec for the new api
  version.

  * lib/aws/rds/client.rb: Bumped EC2 API version in the client class.

  * lib/aws/api_config/RDS-2013-02-12.yml,
  lib/aws/api_config/RDS-2013-05-15.yml, lib/aws/rds/client.rb: Updated
  AWS::RDS::Client to the latest API version.

  * lib/aws/api_config/CloudFront-2012-07-01.yml,
  lib/aws/api_config/CloudFront-2013-05-12.yml, lib/aws/cloud_front/client.rb:
  Updated to the 2013-05-12 API version for AWS::CloudFront::Client.

  * lib/aws/dynamo_db/client.rb: Removed duplicate code from DynamoDB::Client.

  * features/record/hash_model.feature: Fixed an integration test for
  AWS::Record::HashModel.

  * lib/aws/record/abstract_base.rb, lib/aws/record/hash_model.rb,
  lib/aws/record/model.rb: Moved one other reference for id out of record
  abstract base.

  * lib/aws/record/abstract_base.rb, lib/aws/record/attributes.rb,
  spec/aws/record/model/instance_methods_spec.rb,
  spec/shared/record/instance_examples.rb: AWS::Record now accepts default
  values set via a proc.

  By using a Proc, you can ensure every record has a different default value.
  For example:

      class Book < AWS::Record::HashModel
        string_attr :isbn, :default_value => lambda {
  SecureRandom.uuid }
      end

  * lib/aws/record/abstract_base.rb, lib/aws/record/hash_model.rb,
  lib/aws/record/validator.rb,
  spec/aws/record/hash_model/class_methods_spec.rb: AWS::Record::HashModel now
  accepts mutable hash keys.

  The default behavior for a class extending `AWS::Record::HashModel` is to
  have a managed `#id` attribute.  This attribute is auto-generated before
  creation.  It is set to a random UUID.

  You can now override this behavior with the `:hash_key` option.  When you do
  this,
  the HashModel's hash key will no longer be managed (no default values).

  * lib/aws/record/abstract_base.rb, lib/aws/record/model.rb: Moved the static
  #id attribute logic from AWS::Record::AbstractBase into Model.

  In order to allow a dynamic hash key, we don't want the extra baggage of
  a fixed attribute name.

2013-07-09 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/auto_scaling/client.rb, lib/aws/cloud_formation/client.rb,
  lib/aws/cloud_front/client.rb, lib/aws/cloud_search/client.rb,
  lib/aws/cloud_watch/client.rb, lib/aws/core/client.rb,
  lib/aws/data_pipeline/client.rb, lib/aws/direct_connect/client.rb,
  lib/aws/ec2/client.rb, lib/aws/elastic_beanstalk/client.rb,
  lib/aws/elastic_transcoder/client.rb, lib/aws/elasticache/client.rb,
  lib/aws/elb/client.rb, lib/aws/emr/client.rb, lib/aws/glacier/client.rb,
  lib/aws/iam/client.rb, lib/aws/import_export/client.rb,
  lib/aws/ops_works/client.rb, lib/aws/rds/client.rb,
  lib/aws/redshift/client.rb, lib/aws/route_53/client.rb,
  lib/aws/s3/client.rb, lib/aws/simple_db/client.rb,
  lib/aws/simple_email_service/client.rb, lib/aws/simple_workflow/client.rb,
  lib/aws/sns/client.rb, lib/aws/sqs/client.rb,
  lib/aws/storage_gateway/client.rb, lib/aws/sts/client.rb,
  lib/aws/support/client.rb, spec/aws/core/client_spec.rb,
  spec/aws/ec2/client/xml_spec.rb: Minimal refactor so services support
  versioned clients.

  * lib/aws/core/client.rb: Moved logic for versioned clients from
  AWS::DynamoDB::Client to AWS::Core::Client.

  * lib/aws/record/hash_model.rb,
  spec/aws/record/hash_model/class_methods_spec.rb:
  AWS::Record::HashModel.create_table now observes the assignable hash key.

  This was previously hard-coded to 'id', it now uses the specified
  hash key:

      class Book < AWS::Record::HashModel
        string_attr :isbn, :hash_key => true
      end

      Book.create_table(10, 5) # table hash key becomes 'isbn'

  * spec/aws/core/credential_providers_spec.rb: Fix bug in
  CredentialFileProvider test.

  * lib/aws/core/credential_providers.rb,
  spec/aws/core/credential_providers_spec.rb: Implements
  AWS::Core::CredentialProviders::CredentialFileProvider

  * spec/aws/core/region_collection_spec.rb: Fix tests for 1.8.7 syntax
  * lib/aws/core/region_collection.rb,
  spec/aws/core/region_collection_spec.rb: Refinements to proxies in region
  collection.

  Additionally, fixed the URI usage within load_data to
  support ports.

  Fixes #300

  * lib/aws/core/region_collection.rb: Add proxy support to AWS regions
  enumeration.

  region_collection.rb did not attempt to use proxies even when
  specified in the AWS config. This change adds a proxy check,
  and uses a proxy when available.

  * lib/aws/dynamo_db/client.rb: Udpated documentation reference to the
  DynamoDB constructor.

  * bin/aws-rb: Now joining execute options for aws-rb

  * bin/aws-rb: Passing the -e flag to aws-rb now defaults quiet mode.

  * lib/aws/core/credential_providers.rb,
  spec/aws/core/credential_providers_spec.rb, spec/mock-credential-file.txt:
  Read credentials from AWS_CREDENTIAL_FILE environment variable.

  * bin/aws-rb: Added a -e option to aws-rb.

  You can now execute commands using aws-rb.  Passing commands
  with the -e option will prevent the REPL from launching and will
  exit instead.  You can pass multiple -e options.

      aws-rb -q -e "puts AWS.s3.buckets.map(&:name)"

  The script above would put the name of each bucket to STDOUT and
  then exit.  The -q flag (quiet) disables logging.

2013-07-08 Alex Wood <awood45@gmail.com>

  * lib/aws/s3/presigned_post.rb: Remove unnecessary field name
  transformation.

  In my previous change, forgot the removal of one field name
  function call. This was inconsistent but didn't break tests.
  Cleaning that up with this change.

  * ChangeLog, lib/aws/version.rb: Bump version to 1.12.0

  * lib/aws/sns/originators/from_auto_scaling.rb,
  spec/aws/sns/originators/from_auto_scaling_spec.rb: Fixed the copyright
  dates in two files.

  * lib/aws/api_config/ElasticTranscoder-2012-09-25.yml,
  lib/aws/elastic_transcoder/client.rb: Added support for watermarks to
  AWS::ElasticTranscoder::Client.

2013-07-03 Alex Wood <awood45@gmail.com>

  * lib/aws/s3/presigned_post.rb: Minor adjustment to previous presigned post
  change.

  Had integration test regressions regarding some option types.
  This change addresses that regression.

  * lib/aws/s3/presigned_post.rb, spec/aws/s3/presigned_post_spec.rb: Allow
  arbitrary options for presigned post.

  Presigned Posts to S3 previously hard coded a set of allowable
  parameters, this change permits users to send arbitrary params
  which are then passed on to S3.

  Resolves #250

  * lib/aws/core.rb, lib/aws/core/region.rb, tasks/docs.rake: Updated
  documentation for service helpers.

  * lib/aws/core.rb, lib/aws/core/configuration.rb, lib/aws/core/region.rb,
  tasks/docs.rake: Renamed helper methods for AWS::SimpleEmailService and
  AWS::SimpleWorkflow.

  To be consistent with other services that use the official service
  abbreviation,
  the helper methods on `AWS` and `AWS::Core::Region` now use the short names
  for
  `AWS::SimpleEmailService` and `AWS::SimpleWorkflow`.

      # new methods
      AWS.ses
      AWS.swf
      AWS.regions['us-west-2'].ses
      AWS.regions['us-west-2'].swf

      # deprecated methods
      AWS.simple_email_service
      AWS.simple_workflow
      AWS.regions['us-west-2'].simple_email_service
      AWS.regions['us-west-2'].simple_workflow

  Additionally global configuration options use the short name.

      AWS.config(:ses => {...})
      AWS.config(:swf => {...})

  * lib/aws/core/configuration.rb, spec/aws/core/client_spec.rb: You can now
  specify endpoint, region and port per service via AWS.config(:svc => { ...
  })

  You can specify global options per service now using the new configuration
  options.
  Example:

      AWS.config(:s3 => { :region => 'us-west-2' })

      AWS::S3.new.config.s3_region
      #=> 'us-west-2'

  * lib/aws/core/configuration.rb, spec/aws/config_spec.rb: Each service now
  hash a top-level configuration entry.

  Each service now has a config option, for example:

      AWS.config.s3
      #=> {}

  You can specify the value like any other configuration option:

      AWS.config(:s3 => { 'abc' => 'xyz' })

  These values are not yet used anywhere.  They will eventually
  be merged with the root level configuration options when building
  a client.

  * lib/aws/route_53/resource_record_set.rb: Don't nuke attributes on
  ResourceRecordSet update

  Previously, if you were not changing the name, type, or set identifier, they
  would be destructively removed from the ResourceRecordSet on update.

  * lib/aws/route_53/resource_record_set.rb: Add failover and health check
  attributes

  * features/sns/message.feature, features/sqs/step_definitions/messages.rb:
  Added integration tests for AWS::SNS::Message#authentic?

  References #61

  * spec/aws/sns/message_spec.rb: Made the pending test for
  AWS::SNS::Message#authentic? pass.

  References #61

  * lib/aws/sns/message.rb: AWS::SNS::Message now uses Net::HTTP instead of
  HTTParty.

  HTTParty is no longer a dependency of the SDK.

  References #61

  * lib/aws/s3/encryption_utils.rb: Minor changes to address feedback in #259.

  * lib/aws/core/http/net_http_handler.rb,
  spec/aws/core/http/net_http_handler_spec.rb: Disable retries as soon as any
  data has been yielded
  * spec/require_test_3.rb: Replaced usage of === with == when checking for
  nil.

  * lib/aws/core.rb: Updated the documentation for eager_autoload! to a void
  return.

2013-07-05 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/dynamo_db/client.rb, spec/aws/dynamo_db/client_versions_spec.rb:
  You can now configure a global default API version.

  If you want to specify the default API version, you can do so
  using AWS.config:

      # normally defaults to 2011-12-05
      AWS::DynamoDB::Client.new
      #=> AWS::DyanmoDB::Client::V20111205

      AWS.config(:dynamo_db => { :api_version => '2012-08-10')

      # now defaults to 2012-08-10
      AWS::DynamoDB::Client.new
      #=> AWS::DyanmoDB::Client::V20120810

  * lib/aws/dynamo_db/client.rb, spec/aws/dynamo_db/client_versions_spec.rb:
  Fixed an issue constructing clients from their versioned class.

  * lib/aws/dynamo_db/client.rb: Documented the DynamoDB client with
  instructions on using the :api_version option.

  * lib/aws/dynamo_db/client.rb, lib/aws/dynamo_db/client/v20111205.rb,
  lib/aws/dynamo_db/client/v20120810.rb: Added documentation to the versioned
  DynamoDB::Clients.

  * lib/aws/core/client.rb, lib/aws/dynamo_db/client.rb,
  lib/aws/dynamo_db/client/v20111205.rb,
  lib/aws/dynamo_db/client/v20120810.rb, lib/aws/dynamo_db/client_base.rb,
  lib/aws/dynamo_db/client_v2.rb, spec/aws/dynamo_db/client_versions_spec.rb:
  AWS::DynamoDB::Client now supports both Amazon DynamoDB API versions.

  `AWS::DynamoDB::ClientV2` is now deprecated.  Instead of using this class,
  you can
  construct a client of a specific version like so:

      ddb = AWS::DynamoDB::Client.new(:api_version => '2012-08-10')

  Constructing a client without an API version returns a client of the oldest
  version.  This ensures existing users of AWS::DynamoDB::Client will not
  experience
  runtime errors from the differences.

  This works by turning AWS::DynamoDB::Client.new into a factory method.  It
  returns
  an instance of Client::V20111005 or Client::V20120810 based on the
  :api_version
  option.

  * spec/aws/config_spec.rb, spec/aws/core/client_spec.rb,
  spec/aws/core/region_spec.rb: Updated specs to use the new AWS::SERVICES
  format.

  * lib/aws/dynamo_db/client.rb, lib/aws/dynamo_db/client_v2.rb: Updated
  client API documentation for both Amazon DynamoDB clients.

  * lib/aws/dynamo_db/client.rb: Added whitespace in client documentation to
  ensure nested lists render correctly.

2013-07-06 Vann-Campbell <vanncamp@040cced84d10.ant.amazon.com>

  * lib/aws/record/hash_model.rb, spec/aws/record/hash_model_spec.rb: Fix bug
  with hash_key

  * lib/aws/record/hash_model.rb: Allow setting hash_key

  When creating the dynamo_db_table instance the hash_key defaults to id.
  This patch allows assigning a string attribute as the id.

  * spec/aws/record/hash_model_spec.rb: Allow setting hash_key to values other
  than id

2013-07-04 Tung Nguyen <tongueroo@gmail.com>

  * lib/aws/core.rb: add AWS.reset_memoization method

  * lib/aws/sns/message.rb, spec/aws/sns/message_spec.rb:
  AWS::SNS::Message#authentic? no longer flattens errors.

  Errors raised when trying to validate the SNS message were
  getting replaced with a generic message and a StandardError.
  If it fails 3 times, the original error will now raise through.

  * lib/aws/sns/message.rb: Resolved an issue with AWS::SNS::Mesage and Ruby
  versions < 2.0.

2013-06-27 Gustav Munkby <grddev@gmail.com>

  * spec/aws/core/http/net_http_handler_spec.rb: Pending specs for more
  reasonable streaming behaviour

  Previously, errors in subsequent chunks were caught and then the whole
  request was retried, yielding (possibly) repeated chunks to the
  read_block, without any indication (in the block) of this being done.

  The outer client method would also not report any errors for a consumer
  to check.

  * spec/aws/core/http/net_http_handler_spec.rb: Add specs for streaming http
  responses

2013-07-02 Trevor Rowe <trevorrowe@gmail.com>

  * spec/aws_spec.rb: Updated unit tests to not rely on return value from
  `eager_autoload!`.

  * Gemfile: Use HTTPS when talking to rubygems.org.

  * lib/aws/route_53/change_batch.rb: Expose failover + health check id in
  ChangeRequest

  * lib/aws/core.rb, spec/require_test_3.rb: Reverted the return value from
  AWS.eager_autoload!

  * lib/aws/iam/virtual_mfa_device.rb,
  spec/aws/iam/virtual_mfa_device_spec.rb: Resolved an issue with
  AWS::IAM::VirtualMFADevice#enable.

  Passing in string values for a code like '099999' were raising
  runtime errors from sprintf.  This change prevents string values
  from getting passed through sprintf.  Added a test to cover this
  behavior.

  Fixes #288

  * lib/aws/core/http/net_http_handler.rb,
  spec/aws/core/http/net_http_handler_spec.rb: Capture OpenSSL errors, to
  allow retry for those as well
2013-07-01 Katie Zhu <kzhu91@gmail.com>

  * samples/sqs/get_queue_list.rb: Adds simple example to list SQS queues.

  * samples/sqs/add_queue_message.rb: Fixes LoadError. Properly load AWS
  config.

  * lib/aws/cloud_watch/metric_collection.rb,
  spec/aws/cloud_watch/metric_collection_spec.rb: Fixed issue with
  AWS::CloudWatch::MetricCollection#with_dimensions.

  Dimensions were getting lost before being passed to #filter.
  Added specs for this feature as well.

  Fixes #286.

2013-06-28 Bob Potter <bobby.potter@gmail.com>

  * lib/aws/core/http/curb_handler.rb: Curb Performance: Use an array of
  strings instead of a StringIO object.

  * lib/aws/core/http/curb_handler.rb: Remove Request#proxy_uri references
  from CurbHandler. #proxy_uri is no longer defined on Request

2013-06-26 Gustav Munkby <grddev@gmail.com>

  * lib/aws/core/http/net_http_handler.rb: Change HTTP handler to whitelist
  network errors

  Instead of (dangerously) whitelisting errors to reraise, this changes
  the HTTP handler to explicitly list the raised exceptions for which the
  exceptions should be swallowed.

  Fundamentally, this changes handling of unknown errors (such as any Java
  error in JRuby) to not be swallowed.

  * lib/aws/simple_email_service.rb, spec/aws/simple_email_service_spec.rb:
  Added test for setting message id on raw messages.

  When calling `AWS::SimpleEmailService#send_raw_message` with an
  object that responds to `#message_id=`, then the message ID
  from the SES response will be set on the raw message.

  Added a missing test and corrected the `#responds_to?` check.

  Fixes #261

2013-06-25 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core.rb, spec/aws_spec.rb, spec/fixtures/autoload_target.rb,
  spec/fixtures/nested_autoload_target.rb, spec/require_test_3.rb: Removed the
  need to specify modules by crawling all constants when eager autoloading.

  * lib/aws/core.rb, spec/require_test_3.rb, tasks/rspec.rake:
  AWS.eager_autoload! now autolaods all of AWS::Core.

  Fixes #279

2013-06-24 Trevor Rowe <trevorrowe@gmail.com>

  * features/extra/common.rb: Running integration tests without a config now
  marks affected tests as pending.

  Previously these would fail with an unhelpful message.  They now are skipped
  as pending with a message about what test configuration option needs to
  be set.

  * lib/aws/core/configuration.rb: doc typo
2013-06-21 Alex Wood <awood45@gmail.com>

  * lib/aws/auto_scaling/group.rb: Fix missing attribute for
  termination_options

  * features/auto_scaling/step_definitions/groups.rb,
  features/ec2/snapshots.feature, features/ec2/volume_attributes.feature,
  features/ec2/volumes.feature, features/ec2/zones.feature,
  features/elb/availability_zones.feature,
  features/elb/load_balancers.feature,
  features/elb/step_definitions/load_balancers.rb: Make Cucumber tests work
  for users unable to use us-east-1a

  Some AWS users cannot access the AZ us-east-1a, making them
  unable to run our full Cucumber test suite. This change
  removes us-east-1a from the Cucumber integration tests, replacing
  with us-east-1b or other AZs as appropriate.

  * features/auto_scaling/step_definitions/groups.rb,
  lib/aws/auto_scaling/group_options.rb,
  spec/aws/auto_scaling/group_collection_spec.rb: Add termination_options to
  Auto Scaling group creation.

  Adds the optional parameter :termination_options to
  AWS::AutoScaling::GroupCollection "create" method.
  Includes documentation of the parameter, integration
  tests, and a spec test.

  Fixes #275

2013-06-19 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/s3/client.rb, spec/aws/s3/client_spec.rb: AWS::S3::Client now
  retries 400 RequestTimeout errors.

  * lib/aws/core/configuration.rb, spec/aws/config_spec.rb: Reduced
  :http_idle_timeout default from 60 to 5 seconds.

  * features/s3/high_level/objects.feature,
  features/s3/high_level/step_definitions/objects.rb,
  lib/aws/s3/object_collection.rb, spec/aws/s3/object_collection_spec.rb,
  spec/shared/s3/paginated_collection_examples.rb: Fixed issue with pagination
  in S3.

  The next_markers method in object_collection.rb for S3 did not reference the
  "next_marker" property, causing issues when the contents.last value was
  missing.

  Added Cucumber/RSpec tests to cover this case, added a check for next_marker
  to object_collection.rb, and refactored the marker selection logic to be
  more
  readable.

  Fixes #247

2013-06-18 Trevor Rowe <trevorrowe@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.11.3

  * spec/aws/sns/request_spec.rb: Removed v2 specs from SNS client, now using
  v4 signer.

  * lib/aws/sns/request.rb: Moved the SNS client from sigv2 to sigv4.

2013-06-14 Trevor Rowe <trevorrowe@gmail.com>

  * spec/aws/s3/access_control_list_spec.rb,
  spec/aws/s3/presigned_post_spec.rb, spec/spec_helper.rb, tasks/rspec.rake:
  Added a task to run each spec file in its own process.

  Updated a few specs that were failing when run directly.

  * spec/require_test_1.rb, spec/require_test_2.rb, tasks/rspec.rake: Added
  addition tests around loading the SDK.

  Because the SDK uses autoload, it is necessary to run these
  tests in separate processes.

  * lib/aws/ec2/instance.rb, spec/aws/ec2/instance_spec.rb: Resolved an issue
  with AWS::EC2::Instance#console_output

  When the output xml element is missing from the response to
  GetConsoleOutput then this method was raising an error.  This
  now returns +nil+ indicating the output is not available.

  Fixes #272

2013-06-12 Trevor Rowe <trevorrowe@gmail.com>

  * aws-sdk.gemspec, bin/aws-rb, bin/aws-sdk-repl: Renamed the aws-sdk-repl to
  aws-rb.

  * Renamed the script
  * Updated the gem specification executables
  * Renamed the ENV prefix from AWS_SDK_REPL to AWSRB

  * bin/aws-sdk-repl: Changed the usage banner to match the (current)
  executable name.

  * bin/aws-sdk-repl: Modified the repl include and require options.

  * Now requiring the aws-sdk gem after the $LOAD_PATH
    has been amended.  This allows the user to point
    the repl to a different version of the SDK.

  * Now requiring any files specified via -r. This happens
    after the SDK has been loaded and configured.  This
    alows the required library to make use of the SDK.

  * bin/aws-sdk-repl: Corrected spelling error in comment.

  * .gitignore, Gemfile, aws-sdk.gemspec, bin/aws-sdk-repl: Added a basic repl
  executable as aws-sdk-repl.

  This repl will default to pry when available, but will
  fall back to irb when not available.  It accepts a number
  of runtime configuration options and defaults can be exported
  to ENV.

  By default client requests are logged (in color).  A quick
  example:

      aws-sdk-repl
      AWS> s3.buckets['aws-sdk'].objects['key'].content_length
      [AWS S3 200 0.875184 0 retries]
  head_object(:bucket_name=>"aws-sdk",:key=>"key")
      => 5242881

  You can use all methods of the AWS module directly when using Pry.

2013-06-10 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/auto_scaling/client.rb, lib/aws/cloud_formation/client.rb,
  lib/aws/cloud_front/client.rb, lib/aws/cloud_search/client.rb,
  lib/aws/cloud_watch/client.rb, lib/aws/data_pipeline/client.rb,
  lib/aws/direct_connect/client.rb, lib/aws/ec2/client.rb,
  lib/aws/elastic_beanstalk/client.rb, lib/aws/elastic_transcoder/client.rb,
  lib/aws/elasticache/client.rb, lib/aws/elb/client.rb, lib/aws/emr/client.rb,
  lib/aws/glacier/client.rb, lib/aws/iam/client.rb,
  lib/aws/import_export/client.rb, lib/aws/ops_works/client.rb,
  lib/aws/rds/client.rb, lib/aws/redshift/client.rb,
  lib/aws/route_53/client.rb, lib/aws/simple_db/client.rb,
  lib/aws/simple_email_service/client.rb, lib/aws/simple_workflow/client.rb,
  lib/aws/sns/client.rb, lib/aws/sqs/client.rb,
  lib/aws/storage_gateway/client.rb, lib/aws/sts/client.rb,
  lib/aws/support/client.rb: Reformatted client API documentation to fix
  rendered html for nested params.

2013-06-11 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/s3/s3_object.rb: Removed incorrect documentation about SSE and
  Amazon S3.

  Fixes #269
  * spec/aws/s3/client_spec.rb: Fix indentation.
  * lib/aws/s3/client.rb, spec/aws/s3/client_spec.rb: Resolved an issue with
  errors with empty response bodies.

  When the response body was the empty string, instead of nil, we would not
  properly map to helpful error types. This change fixes the empty string
  case.

  Fixes #260

2013-06-09 Trevor Rowe <trevorrowe@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.11.2

2013-06-08 Trevor Rowe <trevorrowe@gmail.com>

  * aws-sdk.gemspec: Updated nokogiri dependency (< 1.6) so we can continue to
  support Ruby 1.8.7

  * ChangeLog, lib/aws/version.rb: Bump version to 1.11.1

2013-06-07 Lane LaRue <llarue@ssx-dev-llarue-01.sea14.amazon.com>

  * lib/aws/sqs/queue.rb: update dcos on max message delay

2013-06-06 James Smith <james@loopj.com>

  * lib/aws/simple_email_service.rb: Make sure raw_message responds to
  message_id before setting it

2013-06-04 James Smith <james@loopj.com>

  * lib/aws/simple_email_service.rb: Add compatibility with deliver!

  * lib/aws/simple_email_service.rb: Add suffix to message_id

  * lib/aws/simple_email_service.rb: Add the AWS-generated message_id to the
  ruby message object

2013-06-01 Kevin Butler <haqkrs@gmail.com>

  * spec/aws/s3/s3_object_encrypt_spec.rb: Cleaned up encryption keys in the
  tests so there are no warning when running tests

  * lib/aws/s3/encryption_utils.rb, spec/aws/s3/s3_object_encrypt_spec.rb:
  Added warning when calling EncryptionUtils.encrypt with data longer than
  keylength

2013-05-30 Trevor Rowe <trevorrowe@gmail.com>

  * spec/aws/core/http/net_http_handler_spec.rb: Fixed unit test for the net
  http handler.

  * features/dynamo_db/step_definitions/crc32.rb,
  lib/aws/core/http/net_http_handler.rb: Resolved issue with crc32 checks and
  Ruby 2.0.0

  Fixes #243

  * lib/aws/core/configuration.rb: The ":region" attribute is a bit out of
  place, as
  none of the other attributes are referred to by
  symbol. I've corrected this.

  * lib/aws/dynamo_db/item_collection.rb,
  spec/aws/dynamo_db/item_collection_spec.rb:
  AWS::DynamoDB::ItemCollection#query now accepts :attributes_to_get.

  Fixes #252

2013-05-29 Eron Hennessey <eronh@amazon.com>

  * lib/aws/simple_workflow/activity_task.rb: Added documentation for
  ActivityTask#respond

2013-05-28 Trevor Rowe <trevorrowe@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.11.0

  * lib/aws/ec2/instance_collection.rb: Fix example for instance collection to
  correspond documentation

2013-05-24 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core/option_grammar.rb: Fixed a spelling error.

2013-05-23 Trevor Rowe <trevorrowe@gmail.com>

  * features/cloud_search/client.feature,
  features/cloud_search/step_definitions/client.rb,
  features/cloud_search/step_definitions/cloud_search.rb,
  features/sqs/queues.feature, features/sqs/step_definitions/queues.rb,
  lib/aws/api_config/SQS-2012-11-05.yml, lib/aws/core/option_grammar.rb: Added
  support for non-flattened maps for query requests.

  * features/direct_connect/client.feature: Removed a superfluous tag.

2013-05-16 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/rds/request.rb: Moved AWS::RDS to signature version 4.

2013-05-15 Trevor Rowe <trevorrowe@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.10.0

  * lib/aws/api_config/ElasticTranscoder-2012-09-25.yml,
  lib/aws/elastic_transcoder/client.rb: AWS Elastic Transcoder update.

2013-05-14 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/api_config/OpsWorks-2013-02-18.yml, lib/aws/ops_works/client.rb:
  Added support for ELBs to AWS::OpsWorks::Client

  * lib/aws/api_config/STS-2011-06-15.yml, lib/aws/sts/client.rb: Add
  AWS::STS::Client#assume_role_with_web_identity

  * lib/aws/api_config/DynamoDB-2012-08-10.yml,
  lib/aws/dynamo_db/client_v2.rb: Added parallel scan to
  AWS::DynamoDB::Client#scan

  * features/s3/high_level/multipart_copy.feature: Reformatted whitespace in
  test scenario.

  * features/s3/high_level/multipart_copy.feature,
  features/s3/high_level/step_definitions/multipart_copy.rb: Renamed a test
  step definition for clarity.

  * features/s3/high_level/multipart_copy.feature,
  features/s3/high_level/step_definitions/multipart_copy.rb,
  lib/aws/s3/s3_object.rb: Added integration tests for multipart copy.

  References #187

  * lib/aws/api_config/EC2-2013-02-01.yml: Fixed an issue in
  RequestSpotInstances

  Fixes #248

2013-05-13 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core.rb: Fixed an issue with service-specific configuration
  options.

  Resolved an issue where service-specific configuration options
  where not getting defined until the service class was autoloaded.
  For example:

      require 'aws-sdk'
      AWS.config(:dynamo_db_crc_32_check => false) # oops, wont apply

      AWS::DynamoDB # autoload dynamo db service interface

      AWS.config(:dynamo_db_crc_32_check => false) # now it works

  All service configurations are loaded up front now.

  References #243

  * features/s3/high_level/step_definitions/urls.rb,
  features/s3/high_level/urls.feature, lib/aws/s3/s3_object.rb: Added support
  for :content_type and :content_md5 to AWS:S3::S3Object#url_for.

  The S3 signature requries the content-md5 and content-type headers to be
  signed.  The #url_for helper method previously did not accept these two
  values and therefore was only good for requests where these values
  were not specified.

  You can now specify them like so:

      s3.buckets['bucket-name'].objects['key'].url_for(:write, {
        # both of these are optional
        :content_type => 'text/plain',
        :content_md5 => '...',
      })

  Fixes #207

  * lib/aws/ec2/security_group.rb: Fixed documentation typo.
2013-05-09 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core/configuration.rb, spec/aws/core/configuration_spec.rb,
  spec/spec_helper.rb: Added support for configuring region via
  ENV['AWS_REGION'].

  * lib/aws/s3/client.rb: Removed documentation for deprecated interface for
  AWS::S3::Client#put_object.

  * lib/aws/ec2.rb, lib/aws/ec2/instance.rb, lib/aws/s3.rb,
  lib/aws/s3/s3_object.rb: Updated documentation examples to open files in
  binary mode.

2013-05-07 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/s3/multipart_upload.rb, lib/aws/s3/uploaded_part.rb,
  lib/aws/s3/uploaded_part_collection.rb,
  spec/aws/s3/multipart_upload_spec.rb,
  spec/aws/s3/uploaded_part_collection_spec.rb: Fixed an issue multipart
  uploads to S3 > 5GB.

  Resolved an issue where `AWS::S3::MultipartUpload#complete` would only
  send the first 1k parts in the request to complete the upload.  This
  only happened when the `:remote_parts` flag was set.

  * lib/aws/dynamo_db/client_v2.rb: Reverted changed to DynamoDBV2 client.

  * lib/aws/ec2/instance.rb: Added documentation for
  AWS::EC2::Instance#source_dest_check.

  * lib/aws/auto_scaling/client.rb, lib/aws/cloud_formation/client.rb,
  lib/aws/cloud_front/client.rb, lib/aws/cloud_search/client.rb,
  lib/aws/cloud_watch/client.rb, lib/aws/data_pipeline/client.rb,
  lib/aws/direct_connect/client.rb, lib/aws/dynamo_db/client.rb,
  lib/aws/dynamo_db/client_v2.rb, lib/aws/ec2/client.rb,
  lib/aws/elastic_beanstalk/client.rb, lib/aws/elastic_transcoder/client.rb,
  lib/aws/elasticache/client.rb, lib/aws/elb/client.rb, lib/aws/emr/client.rb,
  lib/aws/glacier/client.rb, lib/aws/iam/client.rb,
  lib/aws/import_export/client.rb, lib/aws/ops_works/client.rb,
  lib/aws/rds/client.rb, lib/aws/redshift/client.rb,
  lib/aws/route_53/client.rb, lib/aws/simple_db/client.rb,
  lib/aws/simple_email_service/client.rb, lib/aws/simple_workflow/client.rb,
  lib/aws/sns/client.rb, lib/aws/sqs/client.rb,
  lib/aws/storage_gateway/client.rb, lib/aws/sts/client.rb: Corrected an issue
  with markdown structure in docs.

  The client response method were not getting formatted
  because the bulleted list was not spaced or indented.
  Added a blank line to each client method to correct this.

2013-05-06 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/s3/s3_object.rb: Fixed formatting for S3Object class-level docs.

2013-05-01 Loren Segal <lsegal@amazon.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.9.5

  * lib/aws/support/client.rb: Fix documentation formatting

  * README.md, endpoints.json, features/extra/common.rb,
  features/support/client.feature, features/support/common.rb,
  features/support/step_definitions/client.rb,
  features/support/step_definitions/support.rb,
  lib/aws/api_config/Support-2013-04-15.yml, lib/aws/core.rb,
  lib/aws/support.rb, lib/aws/support/client.rb, lib/aws/support/config.rb,
  lib/aws/support/errors.rb, lib/aws/support/request.rb: Add support for AWS
  Support (AWS::Support)

2013-04-30 Manuel Meurer <manuel.meurer@gmail.com>

  * README.md: Add missing apostrophe

2013-04-29 Trevor Rowe <trevorrowe@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.9.3

2013-04-28 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/route_53/hosted_zone_collection.rb,
  spec/aws/route_53/hosted_zone_collection_spec.rb: Resolved an issue with
  AWS::Route53::HostedZoneCollection#create.

  The comment option was getting duplicated before getting
  passed to the client create method.

  Fixes #240

2013-04-26 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/record.rb, lib/aws/record/exceptions.rb: Resolved an
  eager_autoload! bug.

  Fixes #237

  * lib/aws/glacier/client.rb, lib/aws/glacier/request.rb: Removed
  customizations from AWS::Glacier::Request.

  * lib/aws/core/client.rb, lib/aws/sqs/client.rb, lib/aws/sqs/request.rb,
  spec/aws/sqs/queue_spec.rb, spec/aws/sqs/received_message_spec.rb,
  spec/aws/sqs/request_spec.rb: Removed customizations from AWS::SQS::Request.

  This is the next step in removing service specific
  hooks from the http request classes.

2013-04-25 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core/client.rb, lib/aws/core/http/request.rb,
  lib/aws/simple_workflow/client.rb, lib/aws/simple_workflow/request.rb:
  Simplified how http read timeouts are handled.

  Deprecated #default_read_timeout on AWS::Core::Http::Request.
  SWF is the only service that (currently) needs to modify
  the read timeout (for long polling operations).  Now using
  the #read_timeout attribute exclusively to deal with this.

  * lib/aws/cloud_watch.rb: fix interface name in documentation

2013-04-24 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core.rb, tasks/apis.rake: Added a rake task that lists the
  supported API versions.

  * aws-sdk.gemspec: Fixed the gemspec (was referencing README.rdoc which is
  now README.md).

  * ChangeLog, lib/aws/version.rb: Bump version to 1.9.2

  * lib/aws/core/deprecations.rb: Deprecated methods now only issue a single
  warning instead of one per call.

  * lib/aws/ec2/subnet.rb: Fixed an issue with
  AWS::EC2::Subnet#network_acl_association

  The #network_acl_association had a bug that caused it to always
  return the first association from the vpc the subnet belongs to.

2013-04-23 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core/client.rb: Deprecated AWS::Core::Client#http_read_timeout.

  The #http_read_timeout is a property of the configuration
  and is not consumed by the client.  It should instead
  be retrieved from the client configuration is needed.
  Example:

      # given
      ec2 = AWS::EC2::Client.new

      # deprecated
      ec2.http_read_timeout

      # prefered
      ec2.config.http_read_timeout

  * lib/aws/core.rb, lib/aws/core/deprecations.rb: Added a module for marking
  methods as deprecated.

2013-04-22 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/elastic_beanstalk.rb, lib/aws/elastic_transcoder.rb,
  spec/aws/core/region_spec.rb: Fixed a few test issues with the new service
  shortcuts.

  * lib/aws/core.rb, tasks/docs.rake: Added service shortcuts from AWS.

  You can now create service interfaces directly from AWS like so:

      ec2 = AWS.ec2

  You can pass configuration options to this instance as well:

      ec2 = AWS.ec2(:region => 'us-west-2')

  Updated docs rake task to document these magic methods.

  * README.md: Updated README examples.

  * lib/aws/core.rb, tasks/docs.rake: Added additional rake tasks for updating
  docs.

  The API documentation contains lists of supported
  services and service classes.  A pair of rake tasks
  have been added that will update these lists when
  docs are built to ensure they do not get stale.

  * README.md, README.rdoc: Translated README from rdoc to markdown,
  restructured content.

2013-04-18 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws-sdk.rb, lib/aws/core.rb, lib/aws/core/configuration.rb,
  lib/aws/core/region.rb: DRY'd code that had to be done for each service.

  * Registering autoloads for service interfaces
  * Adding service helper methods to Region

  * lib/aws/api_config/CloudFront-2012-05-05.yml,
  lib/aws/api_config/ElastiCache-2012-03-09.yml,
  lib/aws/api_config/RDS-2012-09-17.yml,
  lib/aws/api_config/Route53-2012-02-29.yml: Removed some older/unused API
  versions for four different services.

  * ChangeLog, lib/aws/version.rb: Bump version to 1.9.1

  * lib/aws/core/http/connection_pool.rb,
  lib/aws/core/http/net_http_handler.rb: Fixed a bug introduced in 1.9.0
  related to http continue timeouts.

  Ruby < 1.9.3 does not support setting the continue timeout on
  a `Net::HTTP session`.  Now guarding that attribute assignment
  with a `responds_to?` check.

  Fixes #232

  * .yardopts, Gemfile, lib/aws/auto_scaling/activity.rb,
  lib/aws/auto_scaling/activity_collection.rb, lib/aws/auto_scaling/client.rb,
  lib/aws/auto_scaling/group_options.rb, lib/aws/auto_scaling/instance.rb,
  lib/aws/auto_scaling/launch_configuration.rb,
  lib/aws/auto_scaling/notification_configuration.rb,
  lib/aws/auto_scaling/notification_configuration_collection.rb,
  lib/aws/auto_scaling/request.rb, lib/aws/auto_scaling/scaling_policy.rb,
  lib/aws/auto_scaling/scaling_policy_options.rb,
  lib/aws/auto_scaling/scheduled_action.rb,
  lib/aws/auto_scaling/scheduled_action_collection.rb,
  lib/aws/auto_scaling/tag.rb, lib/aws/auto_scaling/tag_collection.rb,
  lib/aws/cloud_formation/client.rb, lib/aws/cloud_formation/request.rb,
  lib/aws/cloud_formation/stack.rb,
  lib/aws/cloud_formation/stack_collection.rb,
  lib/aws/cloud_formation/stack_event.rb,
  lib/aws/cloud_formation/stack_options.rb,
  lib/aws/cloud_formation/stack_output.rb,
  lib/aws/cloud_formation/stack_resource.rb,
  lib/aws/cloud_formation/stack_summary_collection.rb,
  lib/aws/cloud_front/client.rb, lib/aws/cloud_front/request.rb,
  lib/aws/cloud_search/client.rb, lib/aws/cloud_search/request.rb,
  lib/aws/cloud_watch/alarm.rb, lib/aws/cloud_watch/alarm_history_item.rb,
  lib/aws/cloud_watch/alarm_history_item_collection.rb,
  lib/aws/cloud_watch/client.rb,
  lib/aws/cloud_watch/metric_alarm_collection.rb,
  lib/aws/cloud_watch/metric_collection.rb, lib/aws/cloud_watch/request.rb,
  lib/aws/core.rb, lib/aws/core/cacheable.rb, lib/aws/core/client.rb,
  lib/aws/core/configuration.rb, lib/aws/core/credential_providers.rb,
  lib/aws/core/data.rb, lib/aws/core/http/connection_pool.rb,
  lib/aws/core/http/curb_handler.rb, lib/aws/core/http/handler.rb,
  lib/aws/core/http/net_http_handler.rb, lib/aws/core/http/patch.rb,
  lib/aws/core/http/request.rb, lib/aws/core/indifferent_hash.rb,
  lib/aws/core/inflection.rb, lib/aws/core/json_parser.rb,
  lib/aws/core/json_request_builder.rb, lib/aws/core/json_response_parser.rb,
  lib/aws/core/lazy_error_classes.rb, lib/aws/core/log_formatter.rb,
  lib/aws/core/managed_file.rb, lib/aws/core/meta_utils.rb,
  lib/aws/core/model.rb, lib/aws/core/naming.rb,
  lib/aws/core/option_grammar.rb, lib/aws/core/policy.rb,
  lib/aws/core/query_error_parser.rb, lib/aws/core/query_request_builder.rb,
  lib/aws/core/query_response_parser.rb, lib/aws/core/region_collection.rb,
  lib/aws/core/resource.rb, lib/aws/core/resource_cache.rb,
  lib/aws/core/response.rb, lib/aws/core/response_cache.rb,
  lib/aws/core/rest_error_parser.rb, lib/aws/core/rest_request_builder.rb,
  lib/aws/core/rest_response_parser.rb, lib/aws/core/service_interface.rb,
  lib/aws/core/xml/frame_stack.rb, lib/aws/data_pipeline/client.rb,
  lib/aws/data_pipeline/request.rb, lib/aws/direct_connect/client.rb,
  lib/aws/direct_connect/errors.rb, lib/aws/direct_connect/request.rb,
  lib/aws/dynamo_db/attribute_collection.rb, lib/aws/dynamo_db/item.rb,
  lib/aws/dynamo_db/item_collection.rb, lib/aws/dynamo_db/keys.rb,
  lib/aws/dynamo_db/request.rb, lib/aws/dynamo_db/resource.rb,
  lib/aws/dynamo_db/table.rb, lib/aws/dynamo_db/table_collection.rb,
  lib/aws/dynamo_db/types.rb, lib/aws/ec2/attachment.rb,
  lib/aws/ec2/attachment_collection.rb,
  lib/aws/ec2/availability_zone_collection.rb,
  lib/aws/ec2/block_device_mappings.rb, lib/aws/ec2/client.rb,
  lib/aws/ec2/config_transform.rb, lib/aws/ec2/customer_gateway.rb,
  lib/aws/ec2/dhcp_options.rb, lib/aws/ec2/elastic_ip.rb,
  lib/aws/ec2/errors.rb, lib/aws/ec2/export_task.rb,
  lib/aws/ec2/filtered_collection.rb, lib/aws/ec2/image.rb,
  lib/aws/ec2/image_collection.rb, lib/aws/ec2/instance.rb,
  lib/aws/ec2/instance_collection.rb,
  lib/aws/ec2/internet_gateway/attachment.rb,
  lib/aws/ec2/key_pair_collection.rb, lib/aws/ec2/permission_collection.rb,
  lib/aws/ec2/region_collection.rb, lib/aws/ec2/request.rb,
  lib/aws/ec2/resource.rb, lib/aws/ec2/resource_tag_collection.rb,
  lib/aws/ec2/route_table/association.rb, lib/aws/ec2/security_group.rb,
  lib/aws/ec2/snapshot.rb, lib/aws/ec2/snapshot_collection.rb,
  lib/aws/ec2/tag.rb, lib/aws/ec2/tag_collection.rb,
  lib/aws/ec2/tagged_item.rb, lib/aws/ec2/volume.rb,
  lib/aws/ec2/volume_collection.rb, lib/aws/ec2/vpn_connection.rb,
  lib/aws/ec2/vpn_gateway/attachment.rb, lib/aws/elastic_beanstalk/client.rb,
  lib/aws/elastic_beanstalk/request.rb, lib/aws/elastic_transcoder/client.rb,
  lib/aws/elastic_transcoder/request.rb, lib/aws/elasticache/client.rb,
  lib/aws/elasticache/request.rb, lib/aws/elb/client.rb,
  lib/aws/elb/listener.rb, lib/aws/elb/listener_opts.rb,
  lib/aws/elb/load_balancer_policy.rb, lib/aws/elb/request.rb,
  lib/aws/emr/client.rb, lib/aws/emr/instance_group.rb,
  lib/aws/emr/instance_group_collection.rb, lib/aws/emr/job_flow.rb,
  lib/aws/emr/job_flow_collection.rb, lib/aws/emr/request.rb,
  lib/aws/errors.rb, lib/aws/glacier/client.rb, lib/aws/glacier/request.rb,
  lib/aws/glacier/resource.rb, lib/aws/iam.rb, lib/aws/iam/access_key.rb,
  lib/aws/iam/access_key_collection.rb,
  lib/aws/iam/account_alias_collection.rb, lib/aws/iam/client.rb,
  lib/aws/iam/collection.rb, lib/aws/iam/group.rb,
  lib/aws/iam/group_collection.rb, lib/aws/iam/group_policy_collection.rb,
  lib/aws/iam/group_user_collection.rb, lib/aws/iam/login_profile.rb,
  lib/aws/iam/mfa_device_collection.rb, lib/aws/iam/request.rb,
  lib/aws/iam/resource.rb, lib/aws/iam/server_certificate.rb,
  lib/aws/iam/server_certificate_collection.rb,
  lib/aws/iam/signing_certificate.rb,
  lib/aws/iam/signing_certificate_collection.rb, lib/aws/iam/user.rb,
  lib/aws/iam/user_collection.rb, lib/aws/iam/user_group_collection.rb,
  lib/aws/iam/user_policy.rb, lib/aws/iam/virtual_mfa_device.rb,
  lib/aws/import_export/client.rb, lib/aws/import_export/request.rb,
  lib/aws/ops_works/client.rb, lib/aws/ops_works/request.rb, lib/aws/rails.rb,
  lib/aws/rds/client.rb, lib/aws/rds/db_snapshot_collection.rb,
  lib/aws/rds/request.rb, lib/aws/record.rb, lib/aws/record/abstract_base.rb,
  lib/aws/record/attributes.rb, lib/aws/record/conversion.rb,
  lib/aws/record/dirty_tracking.rb, lib/aws/record/exceptions.rb,
  lib/aws/record/hash_model.rb, lib/aws/record/model.rb,
  lib/aws/record/model/scope.rb, lib/aws/record/naming.rb,
  lib/aws/record/scope.rb, lib/aws/record/validations.rb,
  lib/aws/record/validator.rb, lib/aws/record/validators/acceptance.rb,
  lib/aws/record/validators/block.rb,
  lib/aws/record/validators/confirmation.rb,
  lib/aws/record/validators/count.rb, lib/aws/record/validators/exclusion.rb,
  lib/aws/record/validators/format.rb, lib/aws/record/validators/inclusion.rb,
  lib/aws/record/validators/length.rb, lib/aws/record/validators/method.rb,
  lib/aws/record/validators/numericality.rb,
  lib/aws/record/validators/presence.rb, lib/aws/redshift/client.rb,
  lib/aws/redshift/request.rb, lib/aws/route_53/change_batch.rb,
  lib/aws/route_53/change_info.rb, lib/aws/route_53/client.rb,
  lib/aws/route_53/hosted_zone.rb, lib/aws/route_53/hosted_zone_collection.rb,
  lib/aws/route_53/request.rb, lib/aws/route_53/resource_record_set.rb,
  lib/aws/route_53/resource_record_set_collection.rb,
  lib/aws/s3/access_control_list.rb, lib/aws/s3/acl_object.rb,
  lib/aws/s3/acl_options.rb, lib/aws/s3/bucket.rb,
  lib/aws/s3/bucket_collection.rb,
  lib/aws/s3/bucket_lifecycle_configuration.rb,
  lib/aws/s3/bucket_tag_collection.rb,
  lib/aws/s3/bucket_version_collection.rb, lib/aws/s3/cipher_io.rb,
  lib/aws/s3/client.rb, lib/aws/s3/client/xml.rb, lib/aws/s3/data_options.rb,
  lib/aws/s3/encryption_utils.rb, lib/aws/s3/errors.rb,
  lib/aws/s3/multipart_upload.rb, lib/aws/s3/multipart_upload_collection.rb,
  lib/aws/s3/object_collection.rb, lib/aws/s3/object_upload_collection.rb,
  lib/aws/s3/object_version.rb, lib/aws/s3/paginated_collection.rb,
  lib/aws/s3/prefix_and_delimiter_collection.rb,
  lib/aws/s3/prefixed_collection.rb, lib/aws/s3/presigned_post.rb,
  lib/aws/s3/request.rb, lib/aws/s3/s3_object.rb,
  lib/aws/s3/tree/branch_node.rb, lib/aws/s3/tree/child_collection.rb,
  lib/aws/s3/tree/leaf_node.rb, lib/aws/s3/tree/node.rb,
  lib/aws/s3/tree/parent.rb, lib/aws/s3/uploaded_part.rb,
  lib/aws/s3/uploaded_part_collection.rb, lib/aws/s3/website_configuration.rb,
  lib/aws/simple_db.rb, lib/aws/simple_db/attribute.rb,
  lib/aws/simple_db/client.rb, lib/aws/simple_db/consistent_read_option.rb,
  lib/aws/simple_db/delete_attributes.rb, lib/aws/simple_db/domain.rb,
  lib/aws/simple_db/domain_metadata.rb, lib/aws/simple_db/errors.rb,
  lib/aws/simple_db/expect_condition_option.rb,
  lib/aws/simple_db/item_collection.rb, lib/aws/simple_db/item_data.rb,
  lib/aws/simple_db/put_attributes.rb, lib/aws/simple_db/request.rb,
  lib/aws/simple_email_service.rb, lib/aws/simple_email_service/client.rb,
  lib/aws/simple_email_service/identity.rb,
  lib/aws/simple_email_service/identity_collection.rb,
  lib/aws/simple_email_service/quotas.rb,
  lib/aws/simple_email_service/request.rb,
  lib/aws/simple_workflow/activity_task.rb,
  lib/aws/simple_workflow/activity_task_collection.rb,
  lib/aws/simple_workflow/client.rb, lib/aws/simple_workflow/count.rb,
  lib/aws/simple_workflow/decision_task.rb,
  lib/aws/simple_workflow/decision_task_collection.rb,
  lib/aws/simple_workflow/domain.rb, lib/aws/simple_workflow/history_event.rb,
  lib/aws/simple_workflow/option_formatters.rb,
  lib/aws/simple_workflow/request.rb, lib/aws/simple_workflow/resource.rb,
  lib/aws/simple_workflow/type_collection.rb,
  lib/aws/simple_workflow/workflow_execution_collection.rb,
  lib/aws/sns/client.rb, lib/aws/sns/request.rb, lib/aws/sns/subscription.rb,
  lib/aws/sns/topic.rb, lib/aws/sns/topic_subscription_collection.rb,
  lib/aws/sqs/client.rb, lib/aws/sqs/errors.rb, lib/aws/sqs/queue.rb,
  lib/aws/sqs/queue_collection.rb, lib/aws/sqs/received_message.rb,
  lib/aws/sqs/request.rb, lib/aws/storage_gateway/client.rb,
  lib/aws/storage_gateway/request.rb, lib/aws/sts/client.rb,
  lib/aws/sts/federated_session.rb, lib/aws/sts/request.rb,
  lib/aws/sts/session.rb: Switched from yard @private tags to @api private
  tags.

2013-04-17 Loren Segal <lsegal@amazon.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.9.0

2013-04-05 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/api_config/DynamoDB-2012-08-10.yml, lib/aws/core/client.rb,
  lib/aws/dynamo_db.rb, lib/aws/dynamo_db/client.rb,
  lib/aws/dynamo_db/client_base.rb, lib/aws/dynamo_db/client_v2.rb: Added a
  second client to AWS::DyanmoDB to support the new API version.

  * lib/aws/core.rb: Added a few missing services to the list of supported AWS
  services in the API documentation.

  * lib/aws/core.rb: Added a few missing services to the list of supported AWS
  services in the API documentation.

2013-04-16 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core/client.rb: Loosened expired credential error matching to
  catch both ExpiredToken and RequestExpired.

  * lib/aws/core/http/patch.rb: Fixed namespace bug in http patch (after
  move).

  * features/direct_connect/client.feature,
  features/direct_connect/step_definitions/client.rb,
  features/direct_connect/step_definitions/direct_connect.rb,
  features/s3/100_continue.feature, lib/aws-sdk.rb,
  lib/aws/api_config/DirectConnect-2012-10-25.yml, lib/aws/core.rb,
  lib/aws/direct_connect.rb, lib/aws/direct_connect/client.rb,
  lib/aws/direct_connect/config.rb, lib/aws/direct_connect/errors.rb,
  lib/aws/direct_connect/request.rb, lib/aws/import_export.rb: Added support
  for AWS Direct Connect (2012-10-25).

  * lib/aws/data_pipeline/client.rb: Updated some documentation in
  AWS::DataPipeline::Client.

  * lib/aws/ec2/network_interface.rb: Added
  AWS::EC2::NetworkInterface#private_ip_addresses.

  Resolves #230

  * lib/aws/core/client.rb: Improved retry logic for throttling errors and
  expired credentials.

  * Added additional error types to the list of throttling errors.
  * Added invalid credential errors to those that need to be
    retried as expired creds

  When account credentials are rotated they (the old/invalid) credentials
  return a different error than when session credentials expire.  Now
  catching invalid account credential errors and retrying them once
  (after asking the credential provider to refresh).

2013-04-15 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core.rb, lib/aws/core/client.rb, lib/aws/core/configuration.rb,
  lib/aws/core/http/connection_pool.rb, lib/aws/core/http/net_http_handler.rb,
  lib/aws/core/http/patch.rb, lib/aws/core/http/request.rb,
  lib/aws/core/log_formatter.rb, lib/aws/core/response.rb,
  lib/net/http/connection_pool.rb, lib/net/http/connection_pool/connection.rb,
  lib/net/http/connection_pool/session.rb, spec/aws/config_spec.rb,
  spec/aws/core/http/connection_pool_spec.rb,
  spec/aws/core/http/net_http_handler_spec.rb,
  spec/aws/core/log_formatter_spec.rb, spec/dummy_server.rb,
  spec/net/http/connection_pool/connection_spec.rb,
  spec/net/http/connection_pool/live_tests_spec.rb,
  spec/net/http/connection_pool/session_spec.rb,
  spec/net/http/connection_pool_spec.rb, spec/shared/aws_client_examples.rb:
  Simplified the connection pool and addressed a few issues.

  The default http handler (AWS::Core::Http::NetHttpHandler) used
  internally a Net::Http::ConnectionPool class.  This was refactored
  (and renamed to AWS::Core::Http::ConnectionPool).

  * ConnectionPool.new will now return a previously build (shared)
    pool for the same options.

  * ConnectionPool.new now tracks all pools, and you can get a list
    of them from ConnectionPool.pools.

  * Moved Net::HTTP patch into aws/core/http/patch (this fixes
    100-continue bug in 1.9.3 and 2.0.0)

  As part of this refactor a handful of configuration options were
  removed from AWS::Core::Http::Request (e.g. ssl_ca_file, proxy_uri,
  etc).  These attributes are now passed to the ConnectionPool
  constructor instead and not tracked on each http request.

2013-04-12 Trevor Rowe <trevorrowe@gmail.com>

  * spec/aws/s3/client_spec.rb: Fixed xml matching in S3 client spec.

  * lib/aws/rails.rb: Simplified Rails version detection.

  * lib/aws/s3/client.rb: Now using Nokogiri::XML::Builder instead of REXML in
  AWS::S3::Client.

  Converted a few final locations in the S3 client that built XML
  incorrectly using REXML (now using the nokogiri xml builder).  These
  locations did not correctly escape xml values in all situations.

  Fixes #118

  * features/cloud_front/client.feature,
  features/cloud_front/step_definitions/client.rb,
  lib/aws/cloud_front/request.rb: Added support for session credentials to
  AWS::CloudFront.

  The AWS::CloudFront::Request class was ignoring session
  tokens when signing the request.  This caused Cloud Front
  to return cyrptic errors.  Now setting the 'x-amz-session-token'
  header when the credentials contain a session token.

  Fixes #227

  * lib/aws/ec2/instance_collection.rb,
  spec/aws/ec2/instance_collection_spec.rb:
  AWS::EC2::InstanceCollection#create now accepts :block_device_mappings in
  the same format aws AWS::EC2::Client#run_instances.

  Previously it expected a hash option and then it would
  create the array of hashes required by #run_instances.  It
  now only translates when a hash is given and it passes arrays
  along un-modified.

  Fixes #210

  * lib/aws/api_config/CloudFront-2012-07-01.yml,
  lib/aws/cloud_front/client.rb: Updated AWS::CloudFront::Client to the
  2012-07-01 api version.

  Fixes #217

2013-03-05 Trevor Rowe <trevorrowe@gmail.com>

  * features/s3/100_continue.feature,
  features/s3/high_level/step_definitions.rb, lib/aws/core.rb,
  lib/aws/core/client.rb, lib/aws/core/configuration.rb,
  lib/aws/core/http/net_http_handler.rb, lib/aws/core/http/request.rb,
  lib/net/http/connection_pool.rb, lib/net/http/connection_pool/connection.rb,
  lib/net/http/connection_pool/session.rb,
  spec/aws/core/http/net_http_handler_spec.rb: Added support for sending
  "expect" and waiting for 100-continue.

  Added two new configuration options to AWS.config:

  * :http_continue_timeout (time in seconds, defaults to 1)
  * :http_continue_threshold (size in bytes, defaults false)

  If a request body exceeds the :http_continue_threshold, then the
  "Expect" header will be set to "100-continue".  The http client will
  then wait for a "100 Continue" response or :http_continue_timeout
  seconds before sending the body.

  By default the :http_continue_timeout is set to 1 seconds and the
  :http_continue_threshold is disabled (set to false).

  To enable 100-continues you need to do 2 things:

  * Call `AWS.patch_net_http_100_continue!`
  * Set `:http_continue_threshold` to a positive integer (number of bytes)

  References #172

2013-04-11 LeeGraber <lee@highspot.com>

  * lib/aws/s3/s3_object.rb: forgot to remove debug statement

  * lib/aws/s3/client.rb, lib/aws/s3/client/xml.rb, lib/aws/s3/config.rb,
  lib/aws/s3/multipart_upload.rb, lib/aws/s3/s3_object.rb: Adjustments as per
  feedback from AWS developer

  * lib/aws/s3/client.rb: Removed a bucket name validation from
  AWS::S3::Client#put_bucket_website.

  This validation method was intended only to be called when creating a
  bucket.

  * lib/aws/elb/load_balancer_collection.rb: Corrected documentation for
  AWS::ELB::LoadBalancerCollection#create.

  Fixes #216

  * lib/aws/ec2/image.rb, spec/aws/ec2/image_spec.rb: Added
  AWS::EC2::Image#image_id as an alias to #id.

  References #223

  * spec/aws/core/region_collection_spec.rb: Fixed a broken 1.8.7 spec (caused
  by hash key ordering).

  * lib/aws/auto_scaling.rb, lib/aws/cloud_formation.rb,
  lib/aws/cloud_front.rb, lib/aws/cloud_search.rb, lib/aws/cloud_watch.rb,
  lib/aws/core/configuration.rb, lib/aws/core/region_collection.rb,
  lib/aws/core/service_interface.rb, lib/aws/data_pipeline.rb,
  lib/aws/dynamo_db.rb, lib/aws/ec2.rb, lib/aws/elastic_beanstalk.rb,
  lib/aws/elastic_transcoder.rb, lib/aws/elasticache.rb, lib/aws/elb.rb,
  lib/aws/emr.rb, lib/aws/glacier.rb, lib/aws/iam.rb,
  lib/aws/import_export.rb, lib/aws/ops_works.rb, lib/aws/rds.rb,
  lib/aws/redshift.rb, lib/aws/route_53.rb, lib/aws/s3.rb,
  lib/aws/simple_db.rb, lib/aws/simple_email_service.rb,
  lib/aws/simple_workflow.rb, lib/aws/sns.rb, lib/aws/sqs.rb,
  lib/aws/storage_gateway.rb, lib/aws/sts.rb, lib/aws/version.rb,
  spec/aws/core/client_spec.rb, spec/aws/core/region_collection_spec.rb,
  spec/aws/core/region_spec.rb: Added a regions method to each service
  interface.

  You can now enumerate the regions a specific service
  is available in.

      # generate a list of tables per region
      AWS::DynamoDB.regions.each do |region|
        puts regions.name
        puts region.dynamo_db.tables.map(&:name)
        puts ''
      end

2013-04-10 Mike Attili <attili@amaxo.com>

  * features/s3/low_level/buckets.feature: Add mixed case bucket name test
  scenario.

2013-04-09 Trevor Rowe <trevorrowe@gmail.com>

  * endpoints.json, lib/aws/core.rb, lib/aws/core/configuration.rb,
  lib/aws/core/region.rb, lib/aws/core/region_collection.rb,
  spec/aws/core/region_collection_spec.rb, spec/aws/core/region_spec.rb: Added
  Region and RegionCollection and related helpers.

  You can get a region object using AWS.regions.  This region
  can be used as a shortcut for getting region specific clients.

      east = AWS.regions['us-east-1']
      west = AWS.regions['us-west-1']

      east.ec2.instances.map(&:id)
      west.ec2.instances.map(&:id)

  You can also explore available regions using AWS.regions:

      # makes a single (cached) http request to get a complete list of regions
      AWS.regions.each do |region|
        puts region.name
      end

2013-04-08 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/auto_scaling/config.rb, lib/aws/cloud_formation/config.rb,
  lib/aws/cloud_search/config.rb, lib/aws/cloud_watch/config.rb,
  lib/aws/core.rb, lib/aws/core/cacheable.rb, lib/aws/core/configuration.rb,
  lib/aws/data_pipeline/config.rb, lib/aws/dynamo_db/config.rb,
  lib/aws/ec2.rb, lib/aws/ec2/config.rb, lib/aws/elastic_beanstalk/config.rb,
  lib/aws/elastic_transcoder/config.rb, lib/aws/elasticache/config.rb,
  lib/aws/elb/config.rb, lib/aws/emr/config.rb, lib/aws/glacier/config.rb,
  lib/aws/ops_works/config.rb, lib/aws/rds/config.rb,
  lib/aws/redshift/config.rb, lib/aws/s3/bucket_collection.rb,
  lib/aws/s3/config.rb, lib/aws/s3/s3_object.rb, lib/aws/simple_db/config.rb,
  lib/aws/simple_email_service/config.rb, lib/aws/simple_workflow/config.rb,
  lib/aws/sns/config.rb, lib/aws/sqs/config.rb,
  lib/aws/storage_gateway/config.rb, spec/aws/core/cacheable_spec.rb: Added
  support for a single configurable region.

  You can now specify what AWS region you want to connect to:

      AWS.config(:region => 'us-west-2')

  The individual configuration options for each service endpoints are
  now deprecated.  If you want to override the endpoint for a service
  you can do so in the constructor:

      AWS::S3.new(:region => 'us-east-1')

      # this also works
      AWS::S3.new(:endpoint => 's3-us-east-1.amazonaws.com')

  Documentation changes were made to remove mention of the now
  deprecated options.

  * lib/aws/cloud_search.rb: Correct copy pasted documentation

  * spec/aws/cloud_search_spec.rb: Add spec for CloudSearch

2013-04-07 Mike Attili <attili@amaxo.com>

  * lib/aws/s3/client.rb, spec/aws/s3/client_spec.rb: Align bucket naming
  rules with S3 2006-03-01 API rules.

  Permit bucket names that follow the less restrictive naming rules specified
  in
  http://docs.aws.amazon.com/AmazonS3/2006-03-01/dev/BucketRestrictions.html
  but restrict dns compatible names to the more restrictive rules in the same
  document.

2013-04-06 Rafael Rosa Fu <rafaelrosafu@gmail.com>

  * .gitignore: Added bin directory to .gitignore, avoid problems with
  binstubs

  * spec/spec_helper.rb: Grouping coverage report by service

2013-04-04 Trevor Rowe <trevorrowe@gmail.com>

  * .yardopts: Added a --markup option to the yardopts to use markdown.

  * lib/aws/auto_scaling.rb, lib/aws/auto_scaling/activity_collection.rb,
  lib/aws/auto_scaling/group.rb, lib/aws/auto_scaling/group_collection.rb,
  lib/aws/auto_scaling/group_options.rb, lib/aws/auto_scaling/instance.rb,
  lib/aws/auto_scaling/instance_collection.rb,
  lib/aws/auto_scaling/launch_configuration_collection.rb,
  lib/aws/auto_scaling/notification_configuration.rb,
  lib/aws/auto_scaling/notification_configuration_collection.rb,
  lib/aws/auto_scaling/scaling_policy_options.rb,
  lib/aws/auto_scaling/scheduled_action_collection.rb,
  lib/aws/auto_scaling/tag_collection.rb, lib/aws/cloud_formation.rb,
  lib/aws/cloud_formation/stack.rb,
  lib/aws/cloud_formation/stack_collection.rb,
  lib/aws/cloud_formation/stack_event.rb,
  lib/aws/cloud_formation/stack_resource_collection.rb,
  lib/aws/cloud_formation/stack_resource_summary_collection.rb,
  lib/aws/cloud_formation/stack_summary_collection.rb, lib/aws/cloud_front.rb,
  lib/aws/cloud_search.rb, lib/aws/cloud_watch.rb,
  lib/aws/cloud_watch/alarm.rb, lib/aws/cloud_watch/alarm_collection.rb,
  lib/aws/cloud_watch/metric.rb,
  lib/aws/cloud_watch/metric_alarm_collection.rb,
  lib/aws/cloud_watch/metric_collection.rb,
  lib/aws/cloud_watch/metric_statistics.rb, lib/aws/core.rb,
  lib/aws/core/async_handle.rb, lib/aws/core/client.rb,
  lib/aws/core/collection.rb, lib/aws/core/configuration.rb,
  lib/aws/core/data.rb, lib/aws/core/lazy_error_classes.rb,
  lib/aws/core/log_formatter.rb, lib/aws/core/options/validator.rb,
  lib/aws/core/policy.rb, lib/aws/core/resource.rb, lib/aws/core/response.rb,
  lib/aws/core/rest_request_builder.rb, lib/aws/core/service_interface.rb,
  lib/aws/data_pipeline.rb, lib/aws/dynamo_db.rb,
  lib/aws/dynamo_db/attribute_collection.rb, lib/aws/dynamo_db/batch_get.rb,
  lib/aws/dynamo_db/batch_write.rb, lib/aws/dynamo_db/binary.rb,
  lib/aws/dynamo_db/item.rb, lib/aws/dynamo_db/item_collection.rb,
  lib/aws/dynamo_db/table.rb, lib/aws/dynamo_db/table_collection.rb,
  lib/aws/ec2.rb, lib/aws/ec2/attachment.rb, lib/aws/ec2/elastic_ip.rb,
  lib/aws/ec2/elastic_ip_collection.rb, lib/aws/ec2/export_task_collection.rb,
  lib/aws/ec2/filtered_collection.rb, lib/aws/ec2/image.rb,
  lib/aws/ec2/image_collection.rb, lib/aws/ec2/instance.rb,
  lib/aws/ec2/instance_collection.rb, lib/aws/ec2/internet_gateway.rb,
  lib/aws/ec2/internet_gateway/attachment.rb, lib/aws/ec2/network_acl.rb,
  lib/aws/ec2/network_interface/attachment.rb, lib/aws/ec2/region.rb,
  lib/aws/ec2/resource_tag_collection.rb,
  lib/aws/ec2/route_table/association.rb, lib/aws/ec2/route_table/route.rb,
  lib/aws/ec2/security_group.rb, lib/aws/ec2/security_group_collection.rb,
  lib/aws/ec2/snapshot.rb, lib/aws/ec2/snapshot_collection.rb,
  lib/aws/ec2/subnet_collection.rb, lib/aws/ec2/tagged_collection.rb,
  lib/aws/ec2/tagged_item.rb, lib/aws/ec2/volume.rb,
  lib/aws/ec2/volume_collection.rb, lib/aws/ec2/vpc_collection.rb,
  lib/aws/ec2/vpn_connection_collection.rb, lib/aws/elastic_beanstalk.rb,
  lib/aws/elasticache.rb, lib/aws/elb.rb,
  lib/aws/elb/availability_zone_collection.rb,
  lib/aws/elb/backend_server_policy_collection.rb,
  lib/aws/elb/instance_collection.rb, lib/aws/elb/listener.rb,
  lib/aws/elb/load_balancer.rb, lib/aws/elb/load_balancer_collection.rb,
  lib/aws/elb/load_balancer_policy.rb,
  lib/aws/elb/load_balancer_policy_collection.rb, lib/aws/emr.rb,
  lib/aws/emr/job_flow.rb, lib/aws/emr/job_flow_collection.rb,
  lib/aws/glacier.rb, lib/aws/iam.rb, lib/aws/iam/access_key.rb,
  lib/aws/iam/access_key_collection.rb,
  lib/aws/iam/account_alias_collection.rb, lib/aws/iam/group.rb,
  lib/aws/iam/group_collection.rb, lib/aws/iam/group_policy_collection.rb,
  lib/aws/iam/group_user_collection.rb, lib/aws/iam/server_certificate.rb,
  lib/aws/iam/server_certificate_collection.rb,
  lib/aws/iam/signing_certificate.rb,
  lib/aws/iam/signing_certificate_collection.rb, lib/aws/iam/user.rb,
  lib/aws/iam/user_collection.rb, lib/aws/iam/user_group_collection.rb,
  lib/aws/iam/user_policy_collection.rb, lib/aws/import_export.rb,
  lib/aws/rails.rb, lib/aws/rds.rb, lib/aws/record.rb,
  lib/aws/record/abstract_base.rb, lib/aws/record/attributes.rb,
  lib/aws/record/dirty_tracking.rb, lib/aws/record/errors.rb,
  lib/aws/record/hash_model.rb, lib/aws/record/hash_model/attributes.rb,
  lib/aws/record/hash_model/finder_methods.rb,
  lib/aws/record/hash_model/scope.rb, lib/aws/record/model.rb,
  lib/aws/record/model/attributes.rb, lib/aws/record/model/finder_methods.rb,
  lib/aws/record/model/scope.rb, lib/aws/record/scope.rb,
  lib/aws/record/validations.rb, lib/aws/redshift.rb, lib/aws/route_53.rb,
  lib/aws/route_53/change_batch.rb, lib/aws/route_53/hosted_zone.rb,
  lib/aws/route_53/hosted_zone_collection.rb,
  lib/aws/route_53/resource_record_set.rb,
  lib/aws/route_53/resource_record_set_collection.rb, lib/aws/s3.rb,
  lib/aws/s3/access_control_list.rb, lib/aws/s3/acl_options.rb,
  lib/aws/s3/bucket.rb, lib/aws/s3/bucket_collection.rb,
  lib/aws/s3/bucket_lifecycle_configuration.rb,
  lib/aws/s3/bucket_tag_collection.rb, lib/aws/s3/client.rb,
  lib/aws/s3/cors_rule.rb, lib/aws/s3/cors_rule_collection.rb,
  lib/aws/s3/errors.rb, lib/aws/s3/multipart_upload.rb,
  lib/aws/s3/multipart_upload_collection.rb, lib/aws/s3/object_collection.rb,
  lib/aws/s3/object_metadata.rb, lib/aws/s3/object_version_collection.rb,
  lib/aws/s3/prefixed_collection.rb, lib/aws/s3/presigned_post.rb,
  lib/aws/s3/request.rb, lib/aws/s3/s3_object.rb, lib/aws/s3/tree.rb,
  lib/aws/simple_db.rb, lib/aws/simple_db/attribute.rb,
  lib/aws/simple_db/attribute_collection.rb, lib/aws/simple_db/domain.rb,
  lib/aws/simple_db/errors.rb, lib/aws/simple_db/item.rb,
  lib/aws/simple_db/item_collection.rb, lib/aws/simple_db/item_data.rb,
  lib/aws/simple_email_service.rb, lib/aws/simple_email_service/quotas.rb,
  lib/aws/simple_workflow.rb, lib/aws/simple_workflow/activity_task.rb,
  lib/aws/simple_workflow/activity_task_collection.rb,
  lib/aws/simple_workflow/activity_type.rb,
  lib/aws/simple_workflow/decision_task.rb,
  lib/aws/simple_workflow/decision_task_collection.rb,
  lib/aws/simple_workflow/domain_collection.rb,
  lib/aws/simple_workflow/history_event.rb,
  lib/aws/simple_workflow/type_collection.rb,
  lib/aws/simple_workflow/workflow_execution.rb,
  lib/aws/simple_workflow/workflow_execution_collection.rb,
  lib/aws/simple_workflow/workflow_type.rb, lib/aws/sns.rb,
  lib/aws/sns/subscription_collection.rb, lib/aws/sns/topic.rb,
  lib/aws/sns/topic_collection.rb,
  lib/aws/sns/topic_subscription_collection.rb, lib/aws/sqs.rb,
  lib/aws/sqs/queue.rb, lib/aws/sqs/queue_collection.rb,
  lib/aws/sqs/received_message.rb, lib/aws/storage_gateway.rb, lib/aws/sts.rb,
  lib/net/http/connection_pool.rb, lib/net/http/connection_pool/connection.rb,
  lib/net/http/connection_pool/session.rb: Converted documentation code
  snippets to markdown format (using 4 spaces).

  * lib/aws/api_config/DynamoDB-2011-12-05.yml: Added NumberOfDecreasesToday
  to DynamoDB API configuration.

2013-04-01 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/auto_scaling.rb, lib/aws/auto_scaling/client.rb,
  lib/aws/auto_scaling/group.rb, lib/aws/auto_scaling/group_options.rb,
  lib/aws/auto_scaling/instance.rb,
  lib/aws/auto_scaling/notification_configuration_collection.rb,
  lib/aws/auto_scaling/scaling_policy_options.rb,
  lib/aws/auto_scaling/scheduled_action_collection.rb,
  lib/aws/auto_scaling/tag_collection.rb, lib/aws/cloud_formation.rb,
  lib/aws/cloud_formation/client.rb, lib/aws/cloud_formation/stack.rb,
  lib/aws/cloud_formation/stack_collection.rb,
  lib/aws/cloud_formation/stack_event.rb,
  lib/aws/cloud_formation/stack_resource_collection.rb,
  lib/aws/cloud_formation/stack_resource_summary_collection.rb,
  lib/aws/cloud_formation/stack_summary_collection.rb, lib/aws/cloud_front.rb,
  lib/aws/cloud_front/client.rb, lib/aws/cloud_search.rb,
  lib/aws/cloud_search/client.rb, lib/aws/cloud_watch.rb,
  lib/aws/cloud_watch/alarm_collection.rb, lib/aws/cloud_watch/client.rb,
  lib/aws/cloud_watch/metric.rb,
  lib/aws/cloud_watch/metric_alarm_collection.rb,
  lib/aws/cloud_watch/metric_collection.rb,
  lib/aws/cloud_watch/metric_statistics.rb, lib/aws/core.rb,
  lib/aws/core/client.rb, lib/aws/core/collection.rb,
  lib/aws/core/collection/with_limit_and_next_token.rb,
  lib/aws/core/collection/with_next_token.rb, lib/aws/core/configuration.rb,
  lib/aws/core/credential_providers.rb, lib/aws/core/data.rb,
  lib/aws/core/http/net_http_handler.rb, lib/aws/core/http/request.rb,
  lib/aws/core/http/response.rb, lib/aws/core/log_formatter.rb,
  lib/aws/core/page_result.rb, lib/aws/core/policy.rb,
  lib/aws/core/response.rb, lib/aws/core/service_interface.rb,
  lib/aws/core/xml/grammar.rb, lib/aws/data_pipeline.rb,
  lib/aws/data_pipeline/client.rb, lib/aws/dynamo_db.rb,
  lib/aws/dynamo_db/attribute_collection.rb, lib/aws/dynamo_db/batch_get.rb,
  lib/aws/dynamo_db/client.rb, lib/aws/dynamo_db/item.rb,
  lib/aws/dynamo_db/item_collection.rb, lib/aws/dynamo_db/table.rb,
  lib/aws/dynamo_db/table_collection.rb, lib/aws/ec2.rb,
  lib/aws/ec2/attachment.rb, lib/aws/ec2/availability_zone.rb,
  lib/aws/ec2/client.rb, lib/aws/ec2/elastic_ip.rb,
  lib/aws/ec2/elastic_ip_collection.rb, lib/aws/ec2/export_task_collection.rb,
  lib/aws/ec2/image.rb, lib/aws/ec2/image_collection.rb,
  lib/aws/ec2/instance.rb, lib/aws/ec2/instance_collection.rb,
  lib/aws/ec2/internet_gateway/attachment.rb,
  lib/aws/ec2/key_pair_collection.rb, lib/aws/ec2/route_table/association.rb,
  lib/aws/ec2/security_group.rb, lib/aws/ec2/security_group_collection.rb,
  lib/aws/ec2/snapshot.rb, lib/aws/ec2/snapshot_collection.rb,
  lib/aws/ec2/subnet_collection.rb, lib/aws/ec2/volume.rb,
  lib/aws/ec2/volume_collection.rb, lib/aws/ec2/vpc_collection.rb,
  lib/aws/elastic_beanstalk.rb, lib/aws/elastic_beanstalk/client.rb,
  lib/aws/elastic_transcoder/client.rb, lib/aws/elasticache.rb,
  lib/aws/elasticache/client.rb, lib/aws/elb.rb,
  lib/aws/elb/backend_server_policy_collection.rb, lib/aws/elb/client.rb,
  lib/aws/elb/instance_collection.rb, lib/aws/elb/listener_collection.rb,
  lib/aws/elb/load_balancer.rb, lib/aws/elb/load_balancer_collection.rb,
  lib/aws/elb/load_balancer_policy_collection.rb, lib/aws/emr.rb,
  lib/aws/emr/client.rb, lib/aws/emr/instance_group.rb,
  lib/aws/emr/job_flow.rb, lib/aws/emr/job_flow_collection.rb,
  lib/aws/errors.rb, lib/aws/glacier.rb,
  lib/aws/glacier/archive_collection.rb, lib/aws/glacier/client.rb,
  lib/aws/glacier/vault.rb, lib/aws/iam.rb, lib/aws/iam/access_key.rb,
  lib/aws/iam/access_key_collection.rb, lib/aws/iam/client.rb,
  lib/aws/iam/group_collection.rb, lib/aws/iam/mfa_device_collection.rb,
  lib/aws/iam/policy_collection.rb, lib/aws/iam/resource.rb,
  lib/aws/iam/server_certificate_collection.rb,
  lib/aws/iam/signing_certificate.rb,
  lib/aws/iam/signing_certificate_collection.rb, lib/aws/iam/user.rb,
  lib/aws/iam/user_collection.rb, lib/aws/import_export.rb,
  lib/aws/import_export/client.rb, lib/aws/ops_works/client.rb,
  lib/aws/rails.rb, lib/aws/rds.rb, lib/aws/rds/client.rb,
  lib/aws/rds/db_instance.rb, lib/aws/rds/db_snapshot.rb,
  lib/aws/record/abstract_base.rb, lib/aws/record/attributes.rb,
  lib/aws/record/dirty_tracking.rb, lib/aws/record/errors.rb,
  lib/aws/record/hash_model/attributes.rb,
  lib/aws/record/hash_model/finder_methods.rb,
  lib/aws/record/hash_model/scope.rb, lib/aws/record/model.rb,
  lib/aws/record/model/attributes.rb, lib/aws/record/model/finder_methods.rb,
  lib/aws/record/model/scope.rb, lib/aws/record/scope.rb,
  lib/aws/record/validations.rb, lib/aws/redshift.rb,
  lib/aws/redshift/client.rb, lib/aws/route_53.rb,
  lib/aws/route_53/change_batch.rb, lib/aws/route_53/client.rb,
  lib/aws/route_53/hosted_zone.rb, lib/aws/route_53/hosted_zone_collection.rb,
  lib/aws/route_53/resource_record_set.rb,
  lib/aws/route_53/resource_record_set_collection.rb, lib/aws/s3.rb,
  lib/aws/s3/access_control_list.rb, lib/aws/s3/acl_options.rb,
  lib/aws/s3/bucket.rb, lib/aws/s3/bucket_collection.rb,
  lib/aws/s3/bucket_lifecycle_configuration.rb,
  lib/aws/s3/bucket_tag_collection.rb, lib/aws/s3/cipher_io.rb,
  lib/aws/s3/client.rb, lib/aws/s3/cors_rule_collection.rb,
  lib/aws/s3/data_options.rb, lib/aws/s3/encryption_utils.rb,
  lib/aws/s3/multipart_upload.rb, lib/aws/s3/object_collection.rb,
  lib/aws/s3/prefixed_collection.rb, lib/aws/s3/presigned_post.rb,
  lib/aws/s3/request.rb, lib/aws/s3/s3_object.rb, lib/aws/s3/tree.rb,
  lib/aws/s3/tree/parent.rb, lib/aws/s3/website_configuration.rb,
  lib/aws/simple_db.rb, lib/aws/simple_db/attribute_collection.rb,
  lib/aws/simple_db/client.rb, lib/aws/simple_db/consistent_read_option.rb,
  lib/aws/simple_db/errors.rb, lib/aws/simple_db/item_collection.rb,
  lib/aws/simple_db/item_data.rb, lib/aws/simple_email_service.rb,
  lib/aws/simple_email_service/client.rb,
  lib/aws/simple_email_service/email_address_collection.rb,
  lib/aws/simple_email_service/identity.rb, lib/aws/simple_workflow.rb,
  lib/aws/simple_workflow/activity_task.rb,
  lib/aws/simple_workflow/activity_task_collection.rb,
  lib/aws/simple_workflow/activity_type.rb,
  lib/aws/simple_workflow/activity_type_collection.rb,
  lib/aws/simple_workflow/client.rb, lib/aws/simple_workflow/decision_task.rb,
  lib/aws/simple_workflow/decision_task_collection.rb,
  lib/aws/simple_workflow/domain.rb,
  lib/aws/simple_workflow/domain_collection.rb,
  lib/aws/simple_workflow/history_event.rb,
  lib/aws/simple_workflow/workflow_execution.rb,
  lib/aws/simple_workflow/workflow_execution_collection.rb,
  lib/aws/simple_workflow/workflow_type.rb,
  lib/aws/simple_workflow/workflow_type_collection.rb, lib/aws/sns.rb,
  lib/aws/sns/client.rb, lib/aws/sns/subscription.rb, lib/aws/sns/topic.rb,
  lib/aws/sqs.rb, lib/aws/sqs/client.rb, lib/aws/sqs/errors.rb,
  lib/aws/sqs/queue.rb, lib/aws/sqs/received_message.rb,
  lib/aws/storage_gateway.rb, lib/aws/storage_gateway/client.rb,
  lib/aws/sts/client.rb, lib/aws/sts/session.rb,
  lib/net/http/connection_pool.rb, lib/net/http/connection_pool/connection.rb:
  Initial pass for converting RDoc formatted comments into Markdown.

  * Gemfile, features/s3/high_level/step_definitions/post.rb,
  features/s3/high_level/step_definitions/urls.rb,
  features/s3/low_level/step_definitions/uploads.rb: Updated S3 integration
  test scenarios to work with Ruby 2.0

  * lib/aws/s3/cipher_io.rb, lib/aws/s3/data_options.rb: Fixed an issue with
  AWS::S3::S3Object#write and Ruby 2.0

  Resolved an issue in #write for regular and client-side encrypted
  objects that passed in IO-like objects (Net::HTTP now passes
  in an output buffer to #read).

  Fixes #215
  Fixes #192

2013-04-03 LeeGraber <lee@highspot.com>

  * lib/aws/s3/client.rb, lib/aws/s3/config.rb,
  lib/aws/s3/multipart_upload.rb, lib/aws/s3/s3_object.rb: Added support for
  copy on multipart_upload

  as per
  http://docs.aws.amazon.com/AmazonS3/latest/API/mpUploadUploadPartCopy.ht
  ml, this adds an explicit api on the multipart_upload object
  (copy_part) as well as auto-detection and handling of file > 5GB for
  copy method on an s3_object

2013-03-26 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/ec2.rb, lib/aws/ec2/image_collection.rb,
  lib/aws/ec2/snapshot_collection.rb, lib/aws/ec2/volume_collection.rb,
  lib/aws/sqs/queue.rb, lib/aws/sqs/received_message.rb: Reformatted a few
  rdoc links to make it easier to transition to markdown.

  * lib/aws/ec2/attachment.rb: Refactor duplicate attachment code in EC2

2013-03-25 Trevor Rowe <trevorrowe@gmail.com>

  * ChangeLog: Removed lengthy change log in favor of links to release notes
  in README.

  * README.rdoc: Added links of interest to the top of the README.

  * recipebook/.gitignore, recipebook/Gemfile, recipebook/Gemfile.lock,
  recipebook/README, recipebook/Rakefile,
  recipebook/app/controllers/application_controller.rb,
  recipebook/app/controllers/index_controller.rb,
  recipebook/app/controllers/recipes_controller.rb,
  recipebook/app/helpers/application_helper.rb,
  recipebook/app/helpers/recipes_helper.rb, recipebook/app/models/recipe.rb,
  recipebook/app/views/index/index.rhtml,
  recipebook/app/views/layouts/application.html.erb,
  recipebook/app/views/layouts/application.html.haml,
  recipebook/app/views/recipes/_form.html.haml,
  recipebook/app/views/recipes/edit.html.haml,
  recipebook/app/views/recipes/index.html.haml,
  recipebook/app/views/recipes/new.html.haml,
  recipebook/app/views/recipes/show.html.haml, recipebook/config.ru,
  recipebook/config/application.rb, recipebook/config/boot.rb,
  recipebook/config/cucumber.yml, recipebook/config/database.yml,
  recipebook/config/environment.rb,
  recipebook/config/environments/development.rb,
  recipebook/config/environments/production.rb,
  recipebook/config/environments/test.rb,
  recipebook/config/initializers/aws.rb,
  recipebook/config/initializers/backtrace_silencers.rb,
  recipebook/config/initializers/form_wow.rb,
  recipebook/config/initializers/inflections.rb,
  recipebook/config/initializers/mime_types.rb,
  recipebook/config/initializers/monkey_patch.rb,
  recipebook/config/initializers/secret_token.rb,
  recipebook/config/initializers/session_store.rb,
  recipebook/config/locales/en.yml, recipebook/config/routes.rb,
  recipebook/db/schema.rb, recipebook/db/seeds.rb,
  recipebook/features/recipes/crud.feature,
  recipebook/features/recipes/step_definitions/crud.rb,
  recipebook/features/step_definitions/more_web_steps.rb,
  recipebook/features/step_definitions/web_steps.rb,
  recipebook/features/support/cleanup.rb, recipebook/features/support/env.rb,
  recipebook/features/support/paths.rb, recipebook/lib/tasks/cucumber.rake,
  recipebook/public/404.html, recipebook/public/422.html,
  recipebook/public/500.html, recipebook/public/favicon.ico,
  recipebook/public/images/rails.png,
  recipebook/public/javascripts/application.js,
  recipebook/public/javascripts/controls.js,
  recipebook/public/javascripts/dragdrop.js,
  recipebook/public/javascripts/effects.js,
  recipebook/public/javascripts/jquery-ui.js,
  recipebook/public/javascripts/jquery-ui.min.js,
  recipebook/public/javascripts/jquery.js,
  recipebook/public/javascripts/jquery.min.js,
  recipebook/public/javascripts/prototype.js,
  recipebook/public/javascripts/rails.js, recipebook/public/robots.txt,
  recipebook/public/stylesheets/application.css,
  recipebook/public/stylesheets/sass/application.sass,
  recipebook/script/cucumber, recipebook/script/rails,
  recipebook/spec/spec_helper.rb,
  recipebook/test/performance/browsing_test.rb,
  recipebook/test/test_helper.rb, recipebook/vendor/plugins/form_wow/init.rb,
  recipebook/vendor/plugins/form_wow/lib/form_wow.rb,
  recipebook/vendor/plugins/form_wow/lib/form_wow/builder.rb,
  recipebook/vendor/plugins/form_wow/lib/form_wow/helpers.rb: Removed (stale)
  example rails application.

  * features/auto_scaling/launch_configurations.feature,
  features/auto_scaling/step_definitions/auto_scaling.rb,
  features/auto_scaling/step_definitions/notification_configurations.rb,
  features/auto_scaling/step_definitions/scaling_policies.rb,
  features/cloud_formation/step_definitions/stacks.rb,
  features/cloud_formation/templates.feature,
  features/cloud_front/step_definitions/client.rb,
  features/cloud_watch/step_definitions/metrics.rb,
  features/dynamo_db/step_definitions/tables.rb,
  features/ec2/customer_gateways.feature, features/ec2/images.feature,
  features/ec2/internet_gateways.feature, features/ec2/route_tables.feature,
  features/ec2/security_groups.feature, features/ec2/step_definitions/ec2.rb,
  features/ec2/step_definitions/network_interfaces.rb,
  features/ec2/step_definitions/route_tables.rb,
  features/ec2/step_definitions/security_groups.rb,
  features/ec2/step_definitions/snapshot_attributes.rb,
  features/ec2/subnets.feature, features/ec2/vpn_gateways.feature,
  features/elb/backend_server_policies.feature,
  features/elb/listeners.feature, features/elb/load_balancers.feature,
  features/elb/step_definitions/backend_server_policies.rb,
  features/elb/step_definitions/instances.rb,
  features/elb/step_definitions/listeners.rb,
  features/elb/step_definitions/load_balancers.rb,
  features/elb/step_definitions/policies.rb,
  features/iam/account_aliases.feature,
  features/iam/signing_certificates.feature,
  features/iam/step_definitions/iam.rb,
  features/iam/step_definitions/signing_certificates.rb,
  features/iam/users.feature, features/record/count.feature,
  features/record/find.feature, features/record/optimistic_locking.feature,
  features/record/scope.feature, features/record/validations.feature,
  features/s3/high_level/lifecycle_configuration.feature,
  features/s3/high_level/step_definitions/lifecycle_configuration.rb,
  features/s3/high_level/step_definitions/post.rb,
  features/s3/high_level/tree.feature,
  features/s3/low_level/step_definitions/versions.rb,
  features/simple_db/high_level/items.feature,
  features/simple_db/high_level/step_definitions/items.rb,
  features/simple_db/high_level/step_definitions/select.rb,
  features/simple_email_service/email_addresses.feature,
  features/simple_email_service/send.feature,
  features/simple_email_service/step_definitions/send.rb,
  features/simple_email_service/step_definitions/ses.rb,
  features/simple_workflow/activity_types.feature,
  features/simple_workflow/step_definitions/activity_types.rb,
  features/simple_workflow/step_definitions/decision_tasks.rb,
  features/simple_workflow/step_definitions/workflow_executions.rb,
  features/simple_workflow/step_definitions/workflow_types.rb,
  features/simple_workflow/workflow_types.feature,
  features/sns/step_definitions/topics.rb, features/sns/topics.feature,
  features/sqs/queues.feature, features/sqs/step_definitions/policies.rb,
  features/step_definitions.rb, features/support/common.rb,
  lib/aws/auto_scaling/activity.rb,
  lib/aws/auto_scaling/activity_collection.rb, lib/aws/auto_scaling/group.rb,
  lib/aws/auto_scaling/group_collection.rb,
  lib/aws/auto_scaling/group_options.rb, lib/aws/auto_scaling/instance.rb,
  lib/aws/auto_scaling/instance_collection.rb,
  lib/aws/auto_scaling/launch_configuration.rb,
  lib/aws/auto_scaling/notification_configuration_collection.rb,
  lib/aws/auto_scaling/scaling_policy.rb,
  lib/aws/auto_scaling/scaling_policy_collection.rb,
  lib/aws/auto_scaling/scaling_policy_options.rb,
  lib/aws/auto_scaling/scheduled_action.rb,
  lib/aws/auto_scaling/scheduled_action_collection.rb,
  lib/aws/auto_scaling/tag_collection.rb, lib/aws/cloud_formation.rb,
  lib/aws/cloud_formation/stack.rb, lib/aws/cloud_formation/stack_event.rb,
  lib/aws/cloud_formation/stack_output.rb,
  lib/aws/cloud_formation/stack_resource.rb,
  lib/aws/cloud_formation/stack_resource_collection.rb,
  lib/aws/cloud_watch/alarm.rb, lib/aws/cloud_watch/alarm_collection.rb,
  lib/aws/cloud_watch/alarm_history_item_collection.rb,
  lib/aws/cloud_watch/metric.rb,
  lib/aws/cloud_watch/metric_alarm_collection.rb,
  lib/aws/cloud_watch/metric_collection.rb,
  lib/aws/cloud_watch/metric_statistics.rb, lib/aws/core/async_handle.rb,
  lib/aws/core/cacheable.rb, lib/aws/core/http/response.rb,
  lib/aws/core/lazy_error_classes.rb, lib/aws/core/options/json_serializer.rb,
  lib/aws/core/page_result.rb, lib/aws/core/signature/version_3.rb,
  lib/aws/core/uri_escape.rb, lib/aws/core/xml/frame_stack.rb,
  lib/aws/core/xml/sax_handlers/libxml.rb,
  lib/aws/core/xml/sax_handlers/nokogiri.rb,
  lib/aws/core/xml/sax_handlers/rexml.rb, lib/aws/core/xml/stub.rb,
  lib/aws/dynamo_db/batch_write.rb, lib/aws/dynamo_db/item.rb, lib/aws/ec2.rb,
  lib/aws/ec2/attachment.rb, lib/aws/ec2/attachment_collection.rb,
  lib/aws/ec2/availability_zone.rb, lib/aws/ec2/customer_gateway.rb,
  lib/aws/ec2/customer_gateway_collection.rb, lib/aws/ec2/dhcp_options.rb,
  lib/aws/ec2/dhcp_options_collection.rb, lib/aws/ec2/elastic_ip.rb,
  lib/aws/ec2/elastic_ip_collection.rb, lib/aws/ec2/export_task.rb,
  lib/aws/ec2/export_task_collection.rb, lib/aws/ec2/image.rb,
  lib/aws/ec2/instance_collection.rb, lib/aws/ec2/internet_gateway.rb,
  lib/aws/ec2/internet_gateway_collection.rb, lib/aws/ec2/key_pair.rb,
  lib/aws/ec2/key_pair_collection.rb, lib/aws/ec2/network_acl.rb,
  lib/aws/ec2/network_acl/association.rb, lib/aws/ec2/network_acl/entry.rb,
  lib/aws/ec2/network_acl_collection.rb, lib/aws/ec2/network_interface.rb,
  lib/aws/ec2/network_interface/attachment.rb,
  lib/aws/ec2/network_interface_collection.rb,
  lib/aws/ec2/permission_collection.rb,
  lib/aws/ec2/reserved_instances_collection.rb,
  lib/aws/ec2/reserved_instances_offering_collection.rb,
  lib/aws/ec2/route_table.rb, lib/aws/ec2/route_table/association.rb,
  lib/aws/ec2/route_table/route.rb, lib/aws/ec2/route_table_collection.rb,
  lib/aws/ec2/security_group_collection.rb, lib/aws/ec2/subnet.rb,
  lib/aws/ec2/subnet_collection.rb, lib/aws/ec2/tag_collection.rb,
  lib/aws/ec2/tagged_collection.rb, lib/aws/ec2/tagged_item.rb,
  lib/aws/ec2/volume.rb, lib/aws/ec2/volume_collection.rb, lib/aws/ec2/vpc.rb,
  lib/aws/ec2/vpc_collection.rb, lib/aws/ec2/vpn_connection.rb,
  lib/aws/ec2/vpn_connection/telemetry.rb,
  lib/aws/ec2/vpn_connection_collection.rb, lib/aws/ec2/vpn_gateway.rb,
  lib/aws/ec2/vpn_gateway_collection.rb, lib/aws/elb.rb,
  lib/aws/elb/availability_zone_collection.rb, lib/aws/elb/errors.rb,
  lib/aws/elb/load_balancer.rb, lib/aws/elb/load_balancer_collection.rb,
  lib/aws/emr/instance_group_collection.rb, lib/aws/emr/job_flow.rb,
  lib/aws/errors.rb, lib/aws/glacier/vault_collection.rb, lib/aws/iam.rb,
  lib/aws/iam/access_key.rb, lib/aws/iam/access_key_collection.rb,
  lib/aws/iam/config.rb, lib/aws/iam/mfa_device.rb,
  lib/aws/iam/mfa_device_collection.rb, lib/aws/iam/resource.rb,
  lib/aws/iam/server_certificate_collection.rb,
  lib/aws/iam/signing_certificate.rb,
  lib/aws/iam/signing_certificate_collection.rb, lib/aws/iam/user.rb,
  lib/aws/iam/user_collection.rb, lib/aws/iam/virtual_mfa_device.rb,
  lib/aws/iam/virtual_mfa_device_collection.rb, lib/aws/record.rb,
  lib/aws/record/attributes.rb, lib/aws/record/conversion.rb,
  lib/aws/record/dirty_tracking.rb, lib/aws/record/errors.rb,
  lib/aws/record/exceptions.rb, lib/aws/record/hash_model.rb,
  lib/aws/record/hash_model/finder_methods.rb,
  lib/aws/record/hash_model/scope.rb, lib/aws/record/model.rb,
  lib/aws/record/model/attributes.rb, lib/aws/record/model/finder_methods.rb,
  lib/aws/record/model/scope.rb, lib/aws/record/naming.rb,
  lib/aws/record/scope.rb, lib/aws/record/validations.rb,
  lib/aws/record/validator.rb, lib/aws/record/validators/acceptance.rb,
  lib/aws/record/validators/block.rb,
  lib/aws/record/validators/confirmation.rb,
  lib/aws/record/validators/count.rb, lib/aws/record/validators/exclusion.rb,
  lib/aws/record/validators/format.rb, lib/aws/record/validators/length.rb,
  lib/aws/record/validators/method.rb,
  lib/aws/record/validators/numericality.rb,
  lib/aws/record/validators/presence.rb,
  lib/aws/route_53/hosted_zone_collection.rb, lib/aws/s3.rb,
  lib/aws/s3/access_control_list.rb, lib/aws/s3/acl_options.rb,
  lib/aws/s3/bucket_collection.rb, lib/aws/s3/client/xml.rb,
  lib/aws/s3/object_metadata.rb, lib/aws/s3/object_version.rb,
  lib/aws/s3/policy.rb, lib/aws/s3/prefixed_collection.rb,
  lib/aws/s3/presigned_post.rb, lib/aws/s3/s3_object.rb,
  lib/aws/s3/tree/child_collection.rb, lib/aws/s3/tree/leaf_node.rb,
  lib/aws/s3/website_configuration.rb, lib/aws/simple_db.rb,
  lib/aws/simple_db/attribute.rb, lib/aws/simple_db/attribute_collection.rb,
  lib/aws/simple_db/consistent_read_option.rb, lib/aws/simple_db/domain.rb,
  lib/aws/simple_db/domain_collection.rb,
  lib/aws/simple_db/domain_metadata.rb, lib/aws/simple_db/item.rb,
  lib/aws/simple_db/item_collection.rb, lib/aws/simple_db/put_attributes.rb,
  lib/aws/simple_email_service.rb,
  lib/aws/simple_email_service/email_address_collection.rb,
  lib/aws/simple_email_service/identity.rb,
  lib/aws/simple_email_service/quotas.rb, lib/aws/simple_workflow.rb,
  lib/aws/simple_workflow/activity_task.rb,
  lib/aws/simple_workflow/activity_task_collection.rb,
  lib/aws/simple_workflow/activity_type.rb,
  lib/aws/simple_workflow/activity_type_collection.rb,
  lib/aws/simple_workflow/count.rb, lib/aws/simple_workflow/decision_task.rb,
  lib/aws/simple_workflow/decision_task_collection.rb,
  lib/aws/simple_workflow/domain.rb,
  lib/aws/simple_workflow/domain_collection.rb,
  lib/aws/simple_workflow/history_event.rb,
  lib/aws/simple_workflow/history_event_collection.rb,
  lib/aws/simple_workflow/option_formatters.rb,
  lib/aws/simple_workflow/request.rb, lib/aws/simple_workflow/resource.rb,
  lib/aws/simple_workflow/type.rb, lib/aws/simple_workflow/type_collection.rb,
  lib/aws/simple_workflow/workflow_execution.rb,
  lib/aws/simple_workflow/workflow_execution_collection.rb,
  lib/aws/simple_workflow/workflow_type.rb,
  lib/aws/simple_workflow/workflow_type_collection.rb, lib/aws/sns.rb,
  lib/aws/sns/policy.rb, lib/aws/sns/subscription.rb, lib/aws/sns/topic.rb,
  lib/aws/sns/topic_collection.rb, lib/aws/sqs/queue.rb,
  lib/aws/sqs/queue_collection.rb, lib/aws/sqs/received_message.rb,
  lib/aws/sts/client.rb, lib/net/http/connection_pool/connection.rb,
  spec/aws/auto_scaling/activity_collection_spec.rb,
  spec/aws/auto_scaling/group_collection_spec.rb,
  spec/aws/auto_scaling/group_spec.rb,
  spec/aws/auto_scaling/instance_collection_spec.rb,
  spec/aws/auto_scaling/instance_spec.rb,
  spec/aws/auto_scaling/launch_configuration_collection_spec.rb,
  spec/aws/auto_scaling/launch_configuration_spec.rb,
  spec/aws/auto_scaling/notification_configuration_collection_spec.rb,
  spec/aws/auto_scaling/notification_configuration_spec.rb,
  spec/aws/auto_scaling/request_spec.rb,
  spec/aws/auto_scaling/scaling_policy_colletion_spec.rb,
  spec/aws/auto_scaling/scaling_policy_spec.rb,
  spec/aws/auto_scaling/scheduled_action_collection_spec.rb,
  spec/aws/auto_scaling/scheduled_action_spec.rb,
  spec/aws/cloud_formation/request_spec.rb,
  spec/aws/cloud_formation/stack_spec.rb,
  spec/aws/cloud_formation/stack_summary_collection_spec.rb,
  spec/aws/cloud_formation_spec.rb,
  spec/aws/cloud_watch/alarm_collection_spec.rb,
  spec/aws/cloud_watch/alarm_history_item_collection_spec.rb,
  spec/aws/cloud_watch/alarm_history_item_spec.rb,
  spec/aws/cloud_watch/metric_alarm_collection_spec.rb,
  spec/aws/config_spec.rb, spec/aws/core/cacheable_spec.rb,
  spec/aws/core/collection/simple_spec.rb,
  spec/aws/core/collection/with_next_token_spec.rb,
  spec/aws/core/configuration_spec.rb,
  spec/aws/core/credential_providers_spec.rb,
  spec/aws/core/http/request_param_spec.rb,
  spec/aws/core/http/request_spec.rb, spec/aws/core/http/response_spec.rb,
  spec/aws/core/indifferent_hash_spec.rb, spec/aws/core/log_formatter_spec.rb,
  spec/aws/core/policy_spec.rb, spec/aws/dynamo_db/batch_write_spec.rb,
  spec/aws/dynamo_db/request_spec.rb, spec/aws/dynamo_db/table_spec.rb,
  spec/aws/ec2/attachment_spec.rb, spec/aws/ec2/client/xml_spec.rb,
  spec/aws/ec2/client_spec.rb,
  spec/aws/ec2/customer_gateway_collection_spec.rb,
  spec/aws/ec2/customer_gateway_spec.rb,
  spec/aws/ec2/dhcp_options_collection_spec.rb,
  spec/aws/ec2/dhcp_options_spec.rb, spec/aws/ec2/elastic_ip_spec.rb,
  spec/aws/ec2/export_task_spec.rb, spec/aws/ec2/image_spec.rb,
  spec/aws/ec2/instance_collection_spec.rb,
  spec/aws/ec2/internet_gateway_collection_spec.rb,
  spec/aws/ec2/internet_gateway_spec.rb, spec/aws/ec2/key_pair_spec.rb,
  spec/aws/ec2/network_acl_collection_spec.rb,
  spec/aws/ec2/network_acl_spec.rb, spec/aws/ec2/network_interface_spec.rb,
  spec/aws/ec2/request_spec.rb,
  spec/aws/ec2/reserved_instances_offering_spec.rb,
  spec/aws/ec2/route_table_collection_spec.rb,
  spec/aws/ec2/route_table_spec.rb,
  spec/aws/ec2/security_group/egress_ip_permission_collection_spec.rb,
  spec/aws/ec2/security_group/ip_permission_collection_spec.rb,
  spec/aws/ec2/security_group/ip_permission_spec.rb,
  spec/aws/ec2/security_group_spec.rb, spec/aws/ec2/subnet_collection_spec.rb,
  spec/aws/ec2/subnet_spec.rb, spec/aws/ec2/tag_collection_spec.rb,
  spec/aws/ec2/tag_spec.rb, spec/aws/ec2/vpc_spec.rb,
  spec/aws/ec2/vpn_connection_collection_spec.rb,
  spec/aws/ec2/vpn_connection_spec.rb, spec/aws/ec2/vpn_gateway_spec.rb,
  spec/aws/elb/availability_zone_collection_spec.rb,
  spec/aws/elb/backend_server_policy_collection_spec.rb,
  spec/aws/elb/instance_collection_spec.rb,
  spec/aws/elb/listener_collection_spec.rb,
  spec/aws/elb/load_balancer_policy_collection_spec.rb,
  spec/aws/elb/load_balancer_policy_spec.rb,
  spec/aws/elb/load_balancer_spec.rb, spec/aws/elb_spec.rb,
  spec/aws/errors_spec.rb, spec/aws/iam/access_key_collection_spec.rb,
  spec/aws/iam/access_key_spec.rb, spec/aws/iam/mfa_device_collection_spec.rb,
  spec/aws/iam/mfa_device_spec.rb, spec/aws/iam/request_spec.rb,
  spec/aws/iam/server_certificate_collection_spec.rb,
  spec/aws/iam/server_certificate_spec.rb,
  spec/aws/iam/signing_certificate_collection_spec.rb,
  spec/aws/iam/signing_certificate_spec.rb, spec/aws/iam/user_policy_spec.rb,
  spec/aws/iam/user_spec.rb,
  spec/aws/iam/virtual_mfa_device_collection_spec.rb,
  spec/aws/iam/virtual_mfa_device_spec.rb, spec/aws/rails_spec.rb,
  spec/aws/record/attributes_spec.rb,
  spec/aws/record/hash_model/class_methods_spec.rb,
  spec/aws/record/model/attribute_deletion_spec.rb,
  spec/aws/record/model/class_methods_spec.rb,
  spec/aws/record/model/dirty_tracking_spec.rb,
  spec/aws/record/model/empty_records_spec.rb,
  spec/aws/record/model/errors_spec.rb,
  spec/aws/record/model/instance_methods_spec.rb,
  spec/aws/record/model/optimistic_locking_spec.rb,
  spec/aws/record/model/scope_spec.rb,
  spec/aws/record/model/timestamps_spec.rb,
  spec/aws/record/validations/acceptance_spec.rb,
  spec/aws/record/validations/confirmation_spec.rb,
  spec/aws/record/validations/count_spec.rb,
  spec/aws/record/validations/exclusion_spec.rb,
  spec/aws/record/validations/format_spec.rb,
  spec/aws/record/validations/inclusion_spec.rb,
  spec/aws/record/validations/length_spec.rb,
  spec/aws/record/validations/numericality_spec.rb,
  spec/aws/route_53/client_spec.rb, spec/aws/s3/bucket_collection_spec.rb,
  spec/aws/s3/bucket_version_collection_spec.rb,
  spec/aws/s3/client/xml_spec.rb, spec/aws/s3/object_collection_spec.rb,
  spec/aws/s3/object_metadata_spec.rb,
  spec/aws/s3/object_version_collection_spec.rb,
  spec/aws/s3/object_version_spec.rb, spec/aws/s3/policy_spec.rb,
  spec/aws/s3/request_spec.rb, spec/aws/s3_spec.rb,
  spec/aws/simple_db/attribute_collection_spec.rb,
  spec/aws/simple_db/attribute_spec.rb, spec/aws/simple_db/client_spec.rb,
  spec/aws/simple_db/domain_collection_spec.rb,
  spec/aws/simple_db/domain_metadata_spec.rb,
  spec/aws/simple_db/domain_spec.rb, spec/aws/simple_db/errors_spec.rb,
  spec/aws/simple_db/item_collection_spec.rb,
  spec/aws/simple_db/item_data_spec.rb, spec/aws/simple_db/item_spec.rb,
  spec/aws/simple_db/request_spec.rb, spec/aws/simple_db_spec.rb,
  spec/aws/simple_email_service/email_address_collection_spec.rb,
  spec/aws/simple_email_service/identity_collection_spec.rb,
  spec/aws/simple_email_service/quotas_spec.rb,
  spec/aws/simple_email_service/request_spec.rb,
  spec/aws/simple_email_service_spec.rb,
  spec/aws/simple_workflow/activity_task_collection_spec.rb,
  spec/aws/simple_workflow/activity_task_spec.rb,
  spec/aws/simple_workflow/activity_type_collection_spec.rb,
  spec/aws/simple_workflow/activity_type_spec.rb,
  spec/aws/simple_workflow/count_spec.rb,
  spec/aws/simple_workflow/decision_task_collection_spec.rb,
  spec/aws/simple_workflow/decision_task_spec.rb,
  spec/aws/simple_workflow/domain_collection_spec.rb,
  spec/aws/simple_workflow/domain_spec.rb,
  spec/aws/simple_workflow/history_event_collection_spec.rb,
  spec/aws/simple_workflow/history_event_spec.rb,
  spec/aws/simple_workflow/workflow_execution_collection_spec.rb,
  spec/aws/simple_workflow/workflow_execution_spec.rb,
  spec/aws/simple_workflow/workflow_type_collection_spec.rb,
  spec/aws/simple_workflow/workflow_type_spec.rb,
  spec/aws/simple_workflow_spec.rb, spec/aws/sns/subscription_spec.rb,
  spec/aws/sns/topic_spec.rb, spec/aws/sns_spec.rb,
  spec/aws/sqs/queue_collection_spec.rb, spec/aws/sqs/queue_spec.rb,
  spec/aws/sqs/received_message_spec.rb,
  spec/aws/sqs/received_sns_message_spec.rb, spec/aws/sts/client_spec.rb,
  spec/aws_spec.rb, spec/dummy_server.rb, spec/mock_ec2_metadata_server.rb,
  spec/net/http/connection_pool/connection_spec.rb,
  spec/net/http/connection_pool/live_tests_spec.rb,
  spec/net/http/connection_pool_spec.rb, spec/shared/aws_record_examples.rb,
  spec/shared/ec2/describe_call_attribute_examples.rb,
  spec/shared/ec2/fitlered_collection_examples.rb,
  spec/shared/ec2/model_object_examples.rb,
  spec/shared/ec2/tagged_collection_examples.rb,
  spec/shared/ec2/tagged_item_examples.rb, spec/shared/policy_examples.rb,
  spec/shared/record/abstract_base_examples.rb,
  spec/shared/record/optimistic_lockable_examples.rb,
  spec/shared/record/shardable_examples.rb,
  spec/shared/record/validation_examples.rb,
  spec/shared/s3/model_object_examples.rb,
  spec/shared/signature/version_4_examples.rb,
  spec/shared/simple_db/accepts_consistent_read_option_examples.rb,
  spec/shared/simple_db/model_object_examples.rb,
  spec/shared/simple_workflow/type_collection_examples.rb,
  spec/shared/simple_workflow/type_examples.rb,
  spec/shared/sns/has_delivery_policy_examples.rb,
  spec/shared/sqs/model_object_examples.rb: Removed trailing whitespace from
  the end of lines.

  * lib/aws/record.rb, lib/aws/record/abstract_base.rb,
  lib/aws/record/hash_model.rb, lib/aws/record/hash_model/attributes.rb,
  lib/aws/record/model.rb, lib/aws/record/model/attributes.rb,
  lib/aws/record/validations.rb, lib/aws/record/validators/acceptance.rb,
  lib/aws/record/validators/block.rb,
  lib/aws/record/validators/confirmation.rb,
  lib/aws/record/validators/count.rb, lib/aws/record/validators/exclusion.rb,
  lib/aws/record/validators/format.rb, lib/aws/record/validators/inclusion.rb,
  lib/aws/record/validators/length.rb, lib/aws/record/validators/method.rb,
  lib/aws/record/validators/numericality.rb,
  lib/aws/record/validators/presence.rb: Updated AWS::Record to use autoload
  instead of explicit require statements to support eager autoloading.

  * lib/aws/rails.rb: add to_s method, because Rails.version of edge rails is
  Gem::Version object

2013-03-29 James Miller <bensie@gmail.com>

  * lib/aws/elb/load_balancer_collection.rb: Spelling error in
  load_balancer_collection.rb
2013-03-22 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core/autoloader.rb: Removed the legacy autoloader module.

  * lib/aws-sdk.rb, lib/aws/auto_scaling.rb, lib/aws/cloud_formation.rb,
  lib/aws/cloud_front.rb, lib/aws/cloud_search.rb, lib/aws/cloud_watch.rb,
  lib/aws/core.rb, lib/aws/core/collection.rb, lib/aws/data_pipeline.rb,
  lib/aws/dynamo_db.rb, lib/aws/ec2.rb, lib/aws/ec2/security_group.rb,
  lib/aws/elastic_beanstalk.rb, lib/aws/elastic_transcoder.rb,
  lib/aws/elasticache.rb, lib/aws/elb.rb, lib/aws/emr.rb, lib/aws/glacier.rb,
  lib/aws/iam.rb, lib/aws/iam/collection.rb, lib/aws/import_export.rb,
  lib/aws/ops_works.rb, lib/aws/rds.rb, lib/aws/record.rb,
  lib/aws/redshift.rb, lib/aws/route_53.rb, lib/aws/s3.rb,
  lib/aws/s3/client.rb, lib/aws/s3/tree.rb, lib/aws/simple_db.rb,
  lib/aws/simple_email_service.rb, lib/aws/simple_workflow.rb, lib/aws/sns.rb,
  lib/aws/sqs.rb, lib/aws/storage_gateway.rb, lib/aws/sts.rb: Removed the
  usage of AWS.register_autoloads, now using vanilla autoload.

  * lib/aws/core.rb: Replaced the AWS.eager_autoload! implementation.

  This implementation no longer relies on the AWS.register_autoloads
  hook, runs faster and is simpler.

2013-03-23 ebargtuo <ebargtuo@gmx.it>

  * lib/aws/s3/client.rb, spec/aws/s3/client_spec.rb: Added additional header
  (expires) returned by AWS::S3::Client#head_object and #get_object

2013-03-21 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/s3/bucket.rb: No longer catching all 400-level errors when calling
  Bucket#exists?

  Fixes #205

  * lib/aws/core/configuration.rb: Resolved a thready-safety issue with
  AWS::Core::Configuration.

  References #90

2013-03-20 Loren Segal <lsegal@amazon.com>

  * features/support/common.rb: Only load config file if it exists

  * spec/aws/cloud_formation_spec.rb: Update CloudFormation specs to reflect
  new API

2013-03-19 Patrick Cheng <patrick@mellmo.com>

  * lib/aws/cloud_formation.rb: parameters was not being passed

  * lib/aws/sqs/queue.rb: Corrected typo in SQS::Queue documentation.

2013-03-18 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/auto_scaling.rb, lib/aws/auto_scaling/group.rb,
  lib/aws/auto_scaling/group_collection.rb, lib/aws/core/log_formatter.rb,
  lib/aws/ec2/attachment.rb, lib/aws/ec2/availability_zone.rb,
  lib/aws/ec2/region.rb, lib/aws/ec2/region_collection.rb,
  lib/aws/ec2/volume.rb, lib/aws/ec2/volume_collection.rb,
  lib/aws/elb/availability_zone_collection.rb, lib/aws/elb/load_balancer.rb,
  lib/aws/elb/load_balancer_collection.rb, lib/aws/sns/topic.rb,
  lib/aws/sns/topic_collection.rb, lib/aws/sqs/queue_collection.rb: Now using
  us-west-2 as the default sample region for documentation.

2013-03-15 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/rds/db_instance.rb, spec/aws/rds/db_instance_spec.rb: Added
  #vpc_id and #vpc methods to AWS::RDS::DbInstance.

  Fixes #188

  * lib/aws/cloud_formation/client.rb, lib/aws/cloud_front/client.rb,
  lib/aws/cloud_search/client.rb, lib/aws/data_pipeline/client.rb,
  lib/aws/dynamo_db/client.rb, lib/aws/ec2/client.rb,
  lib/aws/elastic_beanstalk/client.rb, lib/aws/elasticache/client.rb,
  lib/aws/emr/client.rb, lib/aws/glacier/client.rb, lib/aws/iam/client.rb,
  lib/aws/import_export/client.rb, lib/aws/ops_works/client.rb,
  lib/aws/rds/client.rb, lib/aws/redshift/client.rb,
  lib/aws/route_53/client.rb, lib/aws/simple_email_service/client.rb,
  lib/aws/simple_workflow/client.rb, lib/aws/storage_gateway/client.rb: Added
  valid values to the documentation for each service client.

  * lib/aws/api_config/OpsWorks-2013-02-18.yml: Resolved an issue with the
  OpsWorks API configuration.

  One of the input params was incorrectly inflected.

2013-03-14 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core/xml/grammar.rb: Added a rule to ignore enum traits.

  * lib/aws/cloud_watch/client.rb: Added documentation for for
  AWS::CloudWatch::Client operations.

2013-03-13 Trevor Rowe <trevorrowe@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.8.5

  * lib/aws/core.rb, lib/aws/core/configuration.rb: Changed String to Boolean
  with type of:dynamo_db_retry_throughput_errors

2013-03-12 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/api_config/EC2-2013-02-01.yml, lib/aws/ec2/client.rb: Fixed an
  issue with DescribeVpcAttribute.

  * spec/net/http/connection_pool/live_tests_spec.rb: Marked a fragile test as
  pending until it can be refactored.

  * lib/aws/api_config/RDS-2013-02-12.yml, lib/aws/rds/client.rb: Updated RDS
  client to the latest API version (2013-02-12).

  * lib/aws/ec2/snapshot_collection.rb,
  spec/aws/ec2/snapshot_collection_spec.rb: EC2::SnapshotCollection now
  populates snapshots when enumerating.

  * lib/aws/s3/s3_object.rb: Added missing documentation for the :expires
  option to S3Object#write.

2013-03-11 Trevor Rowe <trevorrowe@gmail.com>

  * features/dynamo_db/step_definitions/dynamo_db.rb: Removed and unecessary
  service call from DynamoDB features.

  * ChangeLog, lib/aws/version.rb: Bump version to 1.8.4

  * lib/aws/ec2/client.rb: Bumped AWS::EC2::Client api version.

  * lib/aws/api_config/EC2-2012-12-01.yml,
  lib/aws/api_config/EC2-2013-02-01.yml, lib/aws/ec2/client.rb: Updated the
  EC2 API configuration to the 2013-02-01 API version.

2013-03-10 Mike Ferrier <mferrier@gmail.com>

  * lib/aws/s3/cors_rule_collection.rb: Better fix for the delete_if bug

  Actually, this works better since #set checks for [[]].
  * lib/aws/s3/cors_rule_collection.rb: CORSRuleCollection delete_if can
  delete all rules

  If CORSRuleCollection#delete_if matched all the rules, you'd get:

    ArgumentError - expected one or more rules:
      (gem) aws-sdk-1.8.3.1/lib/aws/s3/cors_rule_collection.rb:101:in `set'

  So if all the rules are deleted, call #clear instead.
2013-03-09 Mike Vastola <Mike@Vasto.la>

  * lib/aws/s3/bucket.rb: Fixed typo in docs citing non-existent method..

  Specifically, S3::Bucket#disable_versioning.
  In reality, it's #suspend_versioning.

2013-03-08 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/api_config/CloudFormation-2010-05-15.yml,
  lib/aws/cloud_formation/client.rb: Added support for #cancel_stack_update to
  AWS::CloudFormation::Client.

2013-03-04 Trevor Rowe <trevorrowe@gmail.com>

  * features/s3/low_level/redirects.feature,
  features/s3/low_level/step_definitions/buckets.rb, lib/aws/core/client.rb:
  Added support for following 307 temporary redirects.

  Fixes #133
  References #172

  * ca-bundle.crt: Updated bundled ca-bundle.crt file.

2013-03-02 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/dynamo_db.rb: Removed old and no longer valid documentation about
  using session tokens with DynamoDB.

2013-02-28 Carl Parker <carljparker@gmail.com>

  * lib/aws/core.rb: fix endpoint in docs for elastictranscoder

  * features/auto_scaling/step_definitions/groups.rb: Fixed broken auto
  scaling feature.

  * spec/aws/auto_scaling/scaling_policy_colletion_spec.rb,
  spec/aws/auto_scaling/scaling_policy_spec.rb: Tests for the
  :min_adjustment_step option

  * lib/aws/auto_scaling/scaling_policy.rb,
  lib/aws/auto_scaling/scaling_policy_options.rb: Add :min_adjustment_step
  option for AutoScaling policies

2013-02-27 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/sqs/request.rb: Updated SQS region logic to fail gracefully when
  the QueueUrl is not valid.

  * features/sqs/queues.feature, features/sqs/step_definitions/messages.rb,
  features/sqs/step_definitions/queues.rb, lib/aws/record/abstract_base.rb,
  lib/aws/sqs/request.rb: Now extracting the region from the QueueUrl param
  when signing SQS requests.

  Fixes #179

  * .yardopts, Gemfile, doc-src/templates/default/layout/html/footer.erb: Add
  analytics script tags for documentation

  * lib/aws/auto_scaling.rb, lib/aws/cloud_formation.rb,
  lib/aws/cloud_front.rb, lib/aws/cloud_search.rb, lib/aws/cloud_watch.rb,
  lib/aws/data_pipeline.rb, lib/aws/dynamo_db.rb, lib/aws/ec2.rb,
  lib/aws/elastic_beanstalk.rb, lib/aws/elasticache.rb, lib/aws/elb.rb,
  lib/aws/emr.rb, lib/aws/glacier.rb, lib/aws/iam.rb,
  lib/aws/import_export.rb, lib/aws/rds.rb, lib/aws/route_53.rb,
  lib/aws/simple_db.rb, lib/aws/simple_email_service.rb,
  lib/aws/simple_workflow.rb, lib/aws/sns.rb, lib/aws/sqs.rb,
  lib/aws/storage_gateway.rb, lib/aws/sts.rb: Document client attributes on
  service classes

2013-02-26 Andy Brody <andy@stripe.com>

  * lib/aws/route_53/resource_record_set.rb: Don't include resource_records if
  it's empty.

  This fixes a bug where attempting to delete an alias record set would
  fail because resource records was passed as the empty list.

  * lib/aws/route_53/hosted_zone.rb: s/recoed/record/

  * lib/aws/route_53/resource_record_set.rb: Memoize list calls in resource
  record set updates.

  * lib/aws/route_53/resource_record_set.rb: Fix typo.

  * Gemfile: Locked rspec dependency to 2.12 for now.

  * lib/aws/s3/client.rb, spec/aws/s3/client_spec.rb: Added 3 addition headers
  returned by AWS::S3::Client#head_object and #get_object.

  Fixes #86

2013-02-25 Loren Segal <lsegal@amazon.com>

  * .travis.yml: Add Ruby 2.0 to build matrix on Travis CI

  * spec/aws/core/data_spec.rb: Fix test for Ruby 2.0 support

2013-02-22 Trevor Rowe <trevorrowe@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.8.3.1

  * lib/aws/ec2/image.rb, spec/aws/ec2/image_spec.rb: Fixed a regression in
  AWS::EC2::Image#block_device_mappings.

  This method would raise when an image has ephemeral volumes.
  Fixes #170

2013-02-20 Loren Segal <lsegal@amazon.com>

  * Gemfile: Grab dependency list from gemspec to avoid duplication

  * lib/aws/core.rb: Corrected the documentation for specifying the endpoint
  for AWS::SimpleWorkflow.

2013-02-18 Loren Segal <lsegal@amazon.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.8.3

  * features/opsworks/client.feature,
  features/opsworks/step_definitions/client.rb,
  features/opsworks/step_definitions/ops_works.rb: Added basic integrations
  for AWS::OpsWorks.

  * spec/aws/route_53/client_spec.rb: Updated AWS::Route53::Client specs to
  use new api version.

  * lib/aws/dynamo_db.rb, spec/aws/dynamo_db_spec.rb: Fixed a bug in
  AWS::DynamoDB#batch_get

  Added missing tests and corrected a bug.
  Fixes #161

  * lib/aws/route_53/client.rb: Updated Route 53 client to use the new
  2012-12-12 API configuration.

  * lib/aws/api_config/Route53-2012-12-12.yml, lib/aws/route_53/client.rb:
  Added support for Route53 health check operations.

  * lib/aws/ec2/instance.rb: Added a mutable #ebs_optimized attribute to
  AWS::EC2::Instance.

  * lib/aws/ec2/instance.rb, spec/aws/ec2/instance_spec.rb: Resolved an issue
  with Instance#block_device_mappings and ephemeral volumes.

  AWS::EC2::Instance#block_device_mappings was raising runtime errors if the
  instance had any ephemeral volumes.  These are now filtered.  The method has
  also be renamed to Instance#attachments (aliased to the old name).

  Added Instance#block_devices which now returns all of the block devices
  as a simple array of hashes.

  * lib/aws/dynamo_db/attribute_collection.rb,
  spec/aws/dynamo_db/attribute_collection_spec.rb: Renamed
  AWS::DynamoDB::AttributeCollection#to_h to #to_hash.

  Aliased to #to_h for backwards compatability.
  Fixes #165

  * lib/aws/core/options/validator.rb,
  spec/aws/core/options/validator_spec.rb: Added support for validating maps
  via AWS::Core::Options::Validator

  Fixes #166

  * lib/aws/record/model.rb: Corrected spelling error in AWS::Record::Model
  documentation.

  Fixes #167

2013-02-12 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws-sdk.rb, lib/aws/api_config/OpsWorks-2013-02-18.yml,
  lib/aws/core.rb, lib/aws/core/configuration.rb, lib/aws/ops_works.rb,
  lib/aws/ops_works/client.rb, lib/aws/ops_works/config.rb,
  lib/aws/ops_works/errors.rb, lib/aws/ops_works/request.rb,
  lib/aws/s3/client.rb, lib/aws/s3/website_configuration.rb: Added support for
  AWS OpsWorks.

  * lib/aws/api_config/ElastiCache-2012-11-15.yml,
  lib/aws/elasticache/client.rb: Updated ElastiCache client to the 2012-11-15
  API version.

  * lib/aws/core/client.rb, lib/aws/core/response.rb,
  spec/aws/core/response_spec.rb: Updated Client code for detecting throttling
  errors.

  Previously SimpleWorkflow throttled requeqests were not getting
  retried as the throtting error check assumed XML resposnes.

  * lib/aws/auto_scaling.rb, lib/aws/auto_scaling/activity_collection.rb,
  lib/aws/auto_scaling/group_options.rb,
  lib/aws/auto_scaling/scaling_policy_options.rb,
  lib/aws/auto_scaling/scheduled_action_collection.rb,
  lib/aws/cloud_search/client.rb, lib/aws/cloud_watch.rb,
  lib/aws/cloud_watch/alarm.rb, lib/aws/cloud_watch/metric_collection.rb,
  lib/aws/core.rb, lib/aws/core/client.rb, lib/aws/core/configuration.rb,
  lib/aws/dynamo_db.rb, lib/aws/elastic_beanstalk.rb, lib/aws/rails.rb,
  lib/aws/simple_db.rb, lib/aws/simple_db/attribute_collection.rb,
  lib/aws/simple_db/item_collection.rb, lib/aws/simple_email_service.rb,
  lib/aws/simple_email_service/client.rb,
  lib/aws/simple_email_service/email_address_collection.rb,
  lib/aws/simple_workflow.rb, lib/aws/simple_workflow/activity_task.rb,
  lib/aws/simple_workflow/decision_task.rb,
  lib/aws/simple_workflow/decision_task_collection.rb,
  lib/aws/simple_workflow/domain_collection.rb,
  lib/aws/simple_workflow/history_event_collection.rb,
  lib/aws/simple_workflow/workflow_execution.rb,
  lib/aws/simple_workflow/workflow_execution_collection.rb,
  lib/aws/simple_workflow/workflow_type.rb: fix typos and spellings

2013-02-15 Trevor Rowe <trevorrowe@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.8.2

  * spec/aws/core/inflection_spec.rb: Marked a test as pending for the
  Core::Inflector -- hoping to remove edge cases.

2013-02-14 Trevor Rowe <trevorrowe@gmail.com>

  * features/rds/step_definitions/client.rb,
  features/rds/step_definitions/rds.rb, features/redshift/client.feature,
  features/redshift/step_definitions/client.rb,
  features/redshift/step_definitions/redshift.rb, features/support/common.rb,
  lib/aws-sdk.rb, lib/aws/api_config/Redshift-2012-12-01.yml, lib/aws/core.rb,
  lib/aws/core/configuration.rb, lib/aws/core/inflection.rb,
  lib/aws/redshift.rb, lib/aws/redshift/client.rb, lib/aws/redshift/config.rb,
  lib/aws/redshift/errors.rb, lib/aws/redshift/request.rb,
  spec/aws/core/inflection_spec.rb: Added support for Amazon Redshift.

  * lib/aws/record/abstract_base.rb: attributes => attr

2013-02-11 Trevor Rowe <trevorrowe@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.8.1.3

  * lib/aws/s3/client.rb: Removed a debugging statement.

  * lib/aws/s3/client.rb, lib/aws/s3/client/xml.rb,
  lib/aws/s3/website_configuration.rb,
  spec/aws/s3/website_configuration_spec.rb: Added support for bucket website
  redirection rules.

  * spec/aws/sqs/request_spec.rb: Updated SQS request specs to tests for sigv4
  signing.

  * lib/aws/sqs/request.rb: Moved AWS::SQS to signature version 4.

  * lib/aws/elastic_beanstalk/request.rb: Moved AWS::ElasticBeanstalk to
  signature version 4.

  * lib/aws/cloud_front/request.rb, lib/aws/core/signature/version_3.rb,
  lib/aws/core/signature/version_3_https.rb, lib/aws/s3/request.rb,
  spec/aws/s3/request_spec.rb, spec/shared/request_examples.rb: Replaced calls
  to Time#rfc822 with Time#httpdate.

  Fixes #154

  * lib/aws/api_config/EMR-2009-03-31.yml, lib/aws/emr/client.rb: Added
  support for IAM roles when creating EMR job flows.

  Fixes #119

  * lib/aws/api_config/CloudFront-2012-05-05.yml,
  lib/aws/cloud_front/client.rb: Removed the API version from the Cloud Front
  operations.

  Fixes #157

2013-02-10 Enis Konuk <enis@cloudvlab.com>

  * lib/aws/api_config/CloudFront-2012-05-05.yml: Fix for Issues #156 -
  DeleteDistribution and DeleteStreamingDistribution - CloudFront

2013-02-08 Andy Brody <andy@stripe.com>

  * lib/aws/route_53/resource_record_set.rb: Add some documentation.

  * lib/aws/route_53/resource_record_set.rb: Factor out ChangeRequest creation
  into methods.

  This makes it easier to create more complex change batches that
  encompass the deletion or update of multiple resource record sets.

  Also, in update(), don't clear out @create_options until after the
  change batch is actually called. Otherwise the object's state will be
  mutated even if the batch raises for some reason.

2013-02-07 Andy Choi <chunkerchunker@gmail.com>

  * lib/aws/s3/client.rb: Patch for missing obj restore expiry date in s3 head
  response

2013-02-06 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/cloud_formation/stack.rb: Corrected the documentation on the
  return type of AWS::CloudFormation::Stack#status.

  Fixes #141

  * lib/aws/s3/s3_object.rb, spec/aws/s3/s3_object_spec.rb:
  AWS::S3::S3Object#read now returns the extra response in block mode.

  You can now get the object contents AND the object metadata in a single
  call to S3Object#read.

      obj = s3.buckets['foo'].objects['bar']

      resp = obj.read do |chunk|
        # write the data somewhere
        file.write(chunk)
      end

      resp[:etag] #=> '...'
      resp[:meta] #=> a hash of object metadata

2013-02-05 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core/http/curb_handler.rb: Added support to the CurbHandler for
  streaming reads.

  The AWS::Core::Http::CurbHandler is a drop-in replacement for the
  net/http based default handler.  The curb-based handler did not
  previously support a block for streading response data from the
  response directly.  Instead it was buffering the entire response
  into memory (and emitting a warning).

2013-02-01 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/s3/s3_object.rb, spec/aws/s3/s3_object_encrypt_spec.rb: Fixed a
  bug reading client-side encrypted object versions.

  * lib/aws/ec2/security_group.rb, spec/aws/ec2/security_group_spec.rb: Added
  a SecurityGroup#instances method.

  * lib/aws/api_config/STS-2011-06-15.yml, lib/aws/sts.rb,
  lib/aws/sts/client.rb: Added support for STS assume role.

  * lib/aws/simple_db/domain_collection.rb: Fix max domains per account
  documentation
2013-01-31 Trevor Rowe <trevorrowe@gmail.com>

  * spec/shared/aws_client_examples.rb: Reworked a test that was broken in
  Ruby 1.8.7.

  * ChangeLog, lib/aws/version.rb: Bump version to 1.8.1.2

2013-01-30 Jonathan Gold <jgold@bitgirder.com>

  * lib/aws/s3/s3_object.rb: Adding doc for content_md5

  * spec/aws/s3/s3_object_spec.rb, spec/shared/aws_client_examples.rb: Updated
  specs to reflect the client now raises the actual error instead of a
  NetworkError.

  * lib/aws/core/client.rb, lib/aws/s3/client.rb,
  spec/aws/s3/multipart_upload_spec.rb: Fixed an issue with the stubbed
  responses for S3::Client#complete_multipart_upload.

  A number of tests that should have failed were passing because the
  simulate response for #complete_multipart upload was puttin in a nil
  value for :version_id.  The version id actually should only be present
  when not-nil.

  * lib/aws/s3/multipart_upload.rb: Fix undefined method 'version_id' during
  multipart upload

  * lib/aws/core/credential_providers.rb,
  spec/aws/core/credential_providers_spec.rb: Fix bug: default credential
  provider hides sub credential provider's fetching
  credentials error.

  The default credential provider will try to rescue sub provider's
  MissingCredentialsError for looking up the right credential provider.
  However, the way using 'rescue' keyword is not correct, and it
  actually rescued all the StandardError raised from sub provider's
  credentials method.

  * lib/aws/core/credential_providers.rb: missing require time lib for
  Time.parse is used in EC2Provider, the test passed because there is an
  example required the time lib

2013-01-21 Trevor Rowe <trevorrowe@gmail.com>

  * Gemfile, lib/aws/core.rb, lib/aws/core/http/httparty_handler.rb,
  spec/aws/core/http/httparty_handler_spec.rb: Removed gem dependency on
  HTTParty.

  The AWS::Core::Http::HTTPartyHandler has long since been replaced
  as the default handler.  This commit removes the gem dependency
  on HTTParty and removes the handler.

  * features/ec2/step_definitions/customer_gateways.rb,
  features/ec2/step_definitions/errors.rb,
  features/ec2/step_definitions/instance_attributes.rb,
  features/ec2/step_definitions/instances.rb,
  features/ec2/step_definitions/key_pairs.rb,
  features/ec2/step_definitions/security_groups.rb,
  features/ec2/step_definitions/snapshot_attributes.rb,
  features/ec2/step_definitions/snapshots.rb,
  features/ec2/step_definitions/tagging.rb,
  features/ec2/step_definitions/vpc.rb,
  features/iam/step_definitions/groups.rb,
  features/iam/step_definitions/server_certificates.rb,
  features/iam/step_definitions/signing_certificates.rb,
  features/route_53/step_definitions/client.rb,
  features/s3/high_level/step_definitions.rb,
  features/s3/high_level/step_definitions/bucket_acls.rb,
  features/s3/high_level/step_definitions/buckets.rb,
  features/s3/high_level/step_definitions/object_acls.rb,
  features/s3/low_level/step_definitions/object_acls.rb,
  features/s3/low_level/step_definitions/versions.rb,
  features/sqs/step_definitions/queues.rb, features/step_definitions.rb:
  Removing deprecated usage of nested Given/When/Then from features.

  * Gemfile, features/support/common.rb: Removed a few un-needed test
  dependencies and updated others.

  * lib/aws/core/http/net_http_handler.rb: Fixed spec broken by NetHttpHandler
  update for network errors.

  Ruby 1.8 extends Timeout::Errors from SingalError instead of StandardError.
  A recent commit (bcd98dbc579e9d520dadffe9911c64743a4ce082) caused
  SignalErrors to get passed through.  We are now catching Timeout::Error
  before this, so they can be treated as network errors and retried.

  * lib/aws/core/http/net_http_handler.rb, lib/aws/core/http/response.rb,
  spec/aws/core/http/net_http_handler_spec.rb:
  AWS::Core::Http::Response#network_error now returns the error instead of a
  boolean.

  The #network_error? method still returns true/false values, but
  the #network_error method now returns the raised error object or nil.

  * lib/aws/core/http/net_http_handler.rb,
  spec/aws/core/http/net_http_handler_spec.rb: Increased the number of Errors
  retried by the NetHttpHandler.

  Previously, only a short white-list of errors were trapped and
  retried as networking errors.  This has been expanded to be
  all errors raised from the handler (and Net::HTTP) except for
  those on a pass-through list.  This should minimize the number of
  un-enuemrated errors that don't get retried (like open ssl socket
  errors).

  * lib/aws/dynamo_db/item_collection.rb: Corrected documentation on
  AWS::DynamoDB::ItemCollection#select on how to :limit

2013-01-25 Trevor Rowe <trevorrowe@gmail.com>

  * failing_scenarios.txt, lib/aws-sdk.rb,
  lib/aws/api_config/ElasticTranscoder-2012-09-25.yml, lib/aws/core.rb,
  lib/aws/core/configuration.rb, lib/aws/elastic_transcoder.rb,
  lib/aws/elastic_transcoder/client.rb, lib/aws/elastic_transcoder/config.rb,
  lib/aws/elastic_transcoder/errors.rb, lib/aws/elastic_transcoder/request.rb:
  Added a basic Elastic Transcoder client.

2013-01-24 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/cloud_front.rb: Fixed documentation for AWS::CloudFront (incorrect
  example).

  * features/auto_scaling/step_definitions/launch_configurations.rb,
  lib/aws/auto_scaling/group.rb,
  lib/aws/auto_scaling/launch_configuration_collection.rb,
  lib/aws/glacier/vault.rb, spec/aws/auto_scaling/group_spec.rb,
  spec/aws/auto_scaling_spec.rb, spec/shared/core_resource_examples.rb: Fixed
  "configuraiton" mispelling everywhere

2013-01-22 Sean Blakey <sblakey@amazon.com>

  * spec/aws/simple_workflow/decision_task_spec.rb: Spec for allowing
  workflow_id parameters to some decider methods

  * lib/aws/simple_workflow/decision_task.rb: Allow
  signal_external_workflow_execution and
  request_cancel_external_workflow_execution to accept a String workflow id as
  the first parameter. This is consistent with the current documentation.

  * lib/aws/iam/resource.rb: Removed @private doc tag from AWS::IAM::Resource.

  This will cause the #exists? method to appear in the docs
  for the various IAM resource classes.

  Fixes #128.

2013-01-16 Jeremy Green <jeremy@octolabs.com>

  * lib/aws/record/abstract_base.rb, lib/aws/record/exceptions.rb,
  spec/shared/record/abstract_base_examples.rb: Added #create and #create!
  methods to AWS::Record::AbstractBase

  * lib/aws/s3/client.rb, lib/aws/s3/s3_object.rb, spec/aws/s3/client_spec.rb:
  Added support for website redirect location to S3 client.

  Also DRY'd up parsing responses for s3 object methods,
  created a single method that extracts s3 object information
  from the http response headers.  Simplified parsing responses
  for a number of object methods (GET, HEAD, PUT, etc).

  * lib/aws/core/rest_response_parser.rb, spec/aws/glacier/client_spec.rb:
  Added support for Glacier::Client#get_job_output.

  * lib/aws/glacier/archive_collection.rb: fixed description option for
  Glacier::ArchiveCollection.create

2013-01-18 Jamis Buck <jamis@37signals.com>

  * lib/aws/s3/client.rb, spec/aws/s3/client_spec.rb: don't look for
  expiry-date when parsing headers of object with in-progress restore

2013-01-17 Trevor Rowe <trevorrowe@gmail.com>

  * spec/aws/core/options/validator_spec.rb: Trimmed trailing whitespaces.

  * lib/aws/core/options/xml_serializer.rb,
  lib/aws/core/rest_request_builder.rb, lib/aws/route_53/change_batch.rb,
  lib/aws/route_53/hosted_zone.rb, lib/aws/route_53/hosted_zone_collection.rb,
  lib/aws/route_53/resource_record_set.rb,
  lib/aws/route_53/resource_record_set_collection.rb, lib/aws/s3/bucket.rb:
  YARD documentation fixes.

  * features/s3/high_level/buckets.feature,
  features/s3/high_level/step_definitions/buckets.rb, lib/aws/s3.rb,
  lib/aws/s3/bucket.rb, lib/aws/s3/request.rb, lib/aws/s3/s3_object.rb,
  lib/aws/s3/website_configuration.rb, spec/aws/s3/bucket_spec.rb,
  spec/aws/s3/website_configuration_spec.rb: Added high-level bucket website
  configuration.

2012-11-21 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/s3/client.rb, lib/aws/s3/client/xml.rb, lib/aws/s3/s3_object.rb,
  spec/aws/s3/s3_object_spec.rb: Added support for Amazon S3 website hosting
  to AWS::S3::Client.

2013-01-15 Trevor Rowe <trevorrowe@gmail.com>

  * features/glacier/archives.feature,
  features/glacier/step_definitions/archives.rb,
  features/glacier/step_definitions/glacier.rb,
  features/glacier/step_definitions/vaults.rb,
  features/glacier/vaults.feature: Added some integration tests to glacer
  (CRUD vaults, and uploading an archive).

  * lib/aws/glacier/vault.rb: Added an #exists? method to Glacier::Vault.

  * lib/aws/glacier/archive.rb,
  lib/aws/glacier/vault_notification_configuration.rb: Added a few helpful
  aliases to Glacier objects.

  * lib/aws/api_config/Glacier-2012-06-01.yml: Corrected the output definition
  for Glacier::Client#get_vault_notification_configuration.

  * lib/aws/record/validations.rb, lib/aws/record/validator.rb,
  lib/aws/record/validators/acceptance.rb, lib/aws/record/validators/block.rb,
  lib/aws/record/validators/exclusion.rb, lib/aws/record/validators/format.rb,
  lib/aws/record/validators/inclusion.rb, lib/aws/record/validators/length.rb,
  lib/aws/record/validators/numericality.rb,
  lib/aws/record/validators/presence.rb,
  spec/aws/record/validations/acceptance_spec.rb,
  spec/aws/record/validations/confirmation_spec.rb,
  spec/aws/record/validations/count_spec.rb,
  spec/aws/record/validations/exclusion_spec.rb,
  spec/aws/record/validations/length_spec.rb,
  spec/aws/record/validations/numericality_spec.rb,
  spec/shared/record/validation_examples.rb: Add the :allow_blank option to
  validations that can support it.

  * lib/aws/glacier/archive_collection.rb: glacier tree digest fix

2013-01-14 Jeremy Green <jeremy@octolabs.com>

  * lib/aws/record/abstract_base.rb,
  spec/aws/record/model/instance_methods_spec.rb: Added the ability to skip
  validations when saving AWS::Record::Model instances.

2013-01-10 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/s3/client.rb, spec/aws/s3/errors_spec.rb: Added support for
  modeled 400 errors from Amazon S3 where the http response body is empty.

2013-01-09 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/ec2/instance_collection.rb: Updated example in
  EC2::InstanceCollection to use a less agressive polling interval when
  describing instances.

2013-01-08 Loren Segal <lsegal@amazon.com>

  * .travis.yml: Re-enable Travis for 1.9.3

  * lib/aws/ec2/region.rb, spec/aws/ec2/availability_zone_spec.rb,
  spec/aws/ec2/region_collection_spec.rb, spec/aws/ec2/region_spec.rb,
  spec/shared/ec2/collection_array_access_examples.rb,
  spec/shared/ec2/collection_examples.rb: Fixed a bug in AWS::EC2::Region
  where #client had a miss-configured ec2 endpoint.

  EC2 regions provide access to resources in other regions, e.g.

    ec2.regions['us-west-2'].instances.map(&:id)

  There was an issue where all EC2 service methods were correctly proxied
  to the new region *except* for the #client.  Here is a demonstration of
  that bug:

    ec2.regions['us-west-2'].client.config.ec2_endpoint
    #=> 'ec2.amazonaws.com'

  This should have returned 'ec2.us-west-2.amazonaws.com'.  This patch
  resolves this issue and updates a few incorrect tests.

  * samples/ec2/run_instance.rb: Updated EC2 example to use a less-aggressive
  polling delay for instance state change.

2013-01-07 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/cloud_formation/stack.rb,
  lib/aws/cloud_formation/stack_collection.rb,
  spec/aws/cloud_formation/stack_collection_spec.rb: Updated
  AWS::CloudFormation::StackCollection to use :next_token for paging.

  * spec/aws/auto_scaling/group_collection_spec.rb: Removed test for require
  availability zones when creating auto scaling groups.

  The latest API update makes this param optional when using subnets.

  * lib/aws/api_config/CloudFormation-2010-05-15.yml,
  lib/aws/cloud_formation/client.rb: Updated AWS::CloudFormation::Client to
  support tags and next token.

  The DescribeStacks operation now paginates stacks after 20.  Updated the
  client to accept the new :next_token param.

  * lib/aws/elb/request.rb: Updated ELB to signature version 4.

  * lib/aws/api_config/AutoScaling-2011-01-01.yml,
  lib/aws/auto_scaling/client.rb: Updated Auto Scaling model to support
  termination policies and EBS optimized.

2013-01-04 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/route_53/hosted_zone_collection.rb,
  spec/aws/route_53/hosted_zone_collection_spec.rb: Fixed a few tests for
  Route53::HostedZoneCollection#create.

  * lib/aws/ec2/client.rb: Added missing documentation on recent EC2::Client
  updates.

  * lib/aws/api_config/RDS-2012-09-17.yml, lib/aws/rds/client.rb: Add the
  remaining of API configuration updates for RDS 2012-09-17.

  * lib/aws/api_config/EC2-2012-12-01.yml: Added status attributes to describe
  and create spot instance requests.

  * lib/aws/api_config/EC2-2012-12-01.yml: Added next token support to
  AWS::EC2::Client#describe_reserved_instances_offerings.

  * lib/aws/api_config/EC2-2012-12-01.yml: Added support for
  EC2::Client#copy_snapshot.

  * lib/aws/api_config/EMR-2009-03-31.yml: Removed duplicate definition of
  SetVisibleToAllUsers operation in EMR api config.

2012-10-05 Neville Kadwa <neville@kadwa.com>

  * lib/aws/api_config/EMR-2009-03-31.yml: EMR added set_visible_to_all_users
  call, expose this through client

  * lib/aws/api_config/EMR-2009-03-31.yml, lib/aws/emr/job_flow.rb,
  spec/aws/emr/job_flow_spec.rb: EMR added set_visible_to_all_users call,
  expose this through client

  * lib/aws.rb, lib/aws/core.rb, lib/aws/core/configuration.rb: Documented
  Cloud Search configurations and added autoloading hooks.

  * lib/aws/cloud_search/client.rb: Documented AWS::CloudSearch::Client
  control plane operations.

  * lib/aws/cloud_search.rb, lib/aws/cloud_search/client.rb,
  lib/aws/cloud_search/config.rb, lib/aws/cloud_search/errors.rb,
  lib/aws/cloud_search/request.rb: Added Cloud Search control plane API
  classes.

  * lib/aws/api_config/CloudSearch-2011-02-01.yml: Added Cloud Search API
  configuration file.

  * lib/aws/ec2/reserved_instances.rb,
  lib/aws/ec2/reserved_instances_offering.rb,
  spec/shared/ec2/reserved_instances_attributes_examples.rb: Added new
  attributes to reserved_instances(_offerings)

  recurring_charges and offering_type

2013-01-03 xli <xli@thoughtworks.com>

  * lib/aws/core/credential_providers.rb,
  spec/aws/core/credential_providers_spec.rb: Do not cache credentials inside
  DefaultProvider as EC2Provider may
  refresh the credentials before security token is expired.

  * lib/aws/record/scope.rb: Remove warning, Enumerator.new without a blokc is
  deprecated

  use Object#to_enum

2013-01-02 Andy Brody <andy@stripe.com>

  * lib/aws/ec2/security_group.rb: Don't munge port ranges in
  (e/in)gress_opts, either.

  * .travis.yml: Disabling ruby 1.9.3 due to bug in latest patch level.

  * lib/aws/ec2/security_group/ip_permission.rb: Don't munge port ranges that
  are already Ranges.

  For ranges with first > last, Array(range) yields [], causing port_range
  to be set to 0..0. The API returns IpPermission objects with port_range
  set to things like 0..-1 or 8..-1 for specific ICMP packet types. These
  were previously impossible to create using IpPermission::new.

  It was also rather silly to be creating and immediately garbage
  collecting two arrays (e.g. for 0..65535) when we really want the range.

  * lib/aws/core/credential_providers.rb,
  spec/aws/core/credential_providers_spec.rb: refresh ec2 credentials if it
  will be expired in 5 min

  * lib/aws/s3/s3_object.rb: Fixed a broken S3Object spec.

  * lib/aws/core/credential_providers.rb,
  spec/aws/core/credential_providers_spec.rb: refresh ec2 credentials when it
  is expired

  * .gitignore: Added samples configuration file to .gitignore

  * samples/sqs/add_queue_message.rb: Reformated SQS sample and removed
  deprecated option usage from same sample.

  * lib/aws/sqs/queue.rb: Fixed typo in AWS::SQS::Queue#poll documentation.

  * samples/cloud_watch/alarm_with_custom_metrics.rb,
  samples/cloud_watch/create_delete_alarm.rb, samples/sns/publish.rb: Updated
  the attribution on a few samples.

  * features/support/common.rb: FIXED: Integration tests failed to load
  configuration file when credentials exist in ENV.

  * lib/aws/s3/client.rb, lib/aws/s3/s3_object.rb: Added :expires option to
  S3Object copy operations and S3Client#copy_object.

  Fixes #112

  * Gemfile, LICENSE.txt, Rakefile, features/auto_scaling/activities.feature,
  features/auto_scaling/groups.feature,
  features/auto_scaling/instances.feature,
  features/auto_scaling/launch_configurations.feature,
  features/auto_scaling/notification_configurations.feature,
  features/auto_scaling/scaling_policies.feature,
  features/auto_scaling/scheduled_actions.feature,
  features/auto_scaling/step_definitions/activities.rb,
  features/auto_scaling/step_definitions/auto_scaling.rb,
  features/auto_scaling/step_definitions/groups.rb,
  features/auto_scaling/step_definitions/instances.rb,
  features/auto_scaling/step_definitions/launch_configurations.rb,
  features/auto_scaling/step_definitions/notification_configurations.rb,
  features/auto_scaling/step_definitions/scaling_policies.rb,
  features/auto_scaling/step_definitions/scheduled_actions.rb,
  features/cloud_formation/stacks.feature,
  features/cloud_formation/step_definitions/cloud_formation.rb,
  features/cloud_formation/step_definitions/stacks.rb,
  features/cloud_formation/step_definitions/templates.rb,
  features/cloud_formation/templates.feature,
  features/cloud_front/client.feature,
  features/cloud_front/step_definitions/client.rb,
  features/cloud_front/step_definitions/cloud_front.rb,
  features/cloud_watch/alarms.feature, features/cloud_watch/metrics.feature,
  features/cloud_watch/step_definitions/alarms.rb,
  features/cloud_watch/step_definitions/cloud_watch.rb,
  features/cloud_watch/step_definitions/metrics.rb,
  features/data_pipeline/pipelines.feature,
  features/data_pipeline/step_definitions/data_pipeline.rb,
  features/data_pipeline/step_definitions/pipelines.rb,
  features/dynamo_db/batch_get.feature,
  features/dynamo_db/batch_write.feature, features/dynamo_db/crc32.feature,
  features/dynamo_db/errors.feature, features/dynamo_db/items.feature,
  features/dynamo_db/query.feature, features/dynamo_db/scan.feature,
  features/dynamo_db/step_definitions/batch_get.rb,
  features/dynamo_db/step_definitions/batch_write.rb,
  features/dynamo_db/step_definitions/crc32.rb,
  features/dynamo_db/step_definitions/dynamo_db.rb,
  features/dynamo_db/step_definitions/items.rb,
  features/dynamo_db/step_definitions/query.rb,
  features/dynamo_db/step_definitions/scan.rb,
  features/dynamo_db/step_definitions/tables.rb,
  features/dynamo_db/tables.feature, features/dynamo_db/updates.feature,
  features/ec2/combined.feature, features/ec2/customer_gateways.feature,
  features/ec2/dhcp_options.feature, features/ec2/elastic_ips.feature,
  features/ec2/errors.feature, features/ec2/image_attributes.feature,
  features/ec2/images.feature, features/ec2/instance_attributes.feature,
  features/ec2/instances.feature, features/ec2/internet_gateways.feature,
  features/ec2/key_pairs.feature, features/ec2/network_interfaces.feature,
  features/ec2/regions.feature, features/ec2/reserved_instances.feature,
  features/ec2/route_tables.feature, features/ec2/security_groups.feature,
  features/ec2/snapshot_attributes.feature, features/ec2/snapshots.feature,
  features/ec2/step_definitions/combined.rb,
  features/ec2/step_definitions/customer_gateways.rb,
  features/ec2/step_definitions/dhcp_options.rb,
  features/ec2/step_definitions/ec2.rb,
  features/ec2/step_definitions/elasic_ips.rb,
  features/ec2/step_definitions/errors.rb,
  features/ec2/step_definitions/image_attributes.rb,
  features/ec2/step_definitions/images.rb,
  features/ec2/step_definitions/instance_attributes.rb,
  features/ec2/step_definitions/instances.rb,
  features/ec2/step_definitions/internet_gateways.rb,
  features/ec2/step_definitions/key_pairs.rb,
  features/ec2/step_definitions/network_interfaces.rb,
  features/ec2/step_definitions/regions.rb,
  features/ec2/step_definitions/reserved_instances.rb,
  features/ec2/step_definitions/route_tables.rb,
  features/ec2/step_definitions/security_groups.rb,
  features/ec2/step_definitions/snapshot_attributes.rb,
  features/ec2/step_definitions/snapshots.rb,
  features/ec2/step_definitions/subnets.rb,
  features/ec2/step_definitions/tagging.rb,
  features/ec2/step_definitions/volume_attributes.rb,
  features/ec2/step_definitions/volumes.rb,
  features/ec2/step_definitions/vpc.rb,
  features/ec2/step_definitions/vpn_connections.rb,
  features/ec2/step_definitions/vpn_gateways.rb,
  features/ec2/step_definitions/zones.rb, features/ec2/subnets.feature,
  features/ec2/tagging.feature, features/ec2/volume_attributes.feature,
  features/ec2/volumes.feature, features/ec2/vpc.feature,
  features/ec2/vpn_connections.feature, features/ec2/vpn_gateways.feature,
  features/ec2/zones.feature, features/elb/availability_zones.feature,
  features/elb/backend_server_policies.feature,
  features/elb/instances.feature, features/elb/listeners.feature,
  features/elb/load_balancers.feature, features/elb/policies.feature,
  features/elb/step_definitions/availability_zones.rb,
  features/elb/step_definitions/backend_server_policies.rb,
  features/elb/step_definitions/elb.rb,
  features/elb/step_definitions/instances.rb,
  features/elb/step_definitions/listeners.rb,
  features/elb/step_definitions/load_balancers.rb,
  features/elb/step_definitions/policies.rb, features/emr/job_flows.feature,
  features/emr/step_definitions/emr.rb,
  features/emr/step_definitions/job_flows.rb,
  features/iam/access_keys.feature, features/iam/account_aliases.feature,
  features/iam/account_summary.feature, features/iam/groups.feature,
  features/iam/login_profiles.feature, features/iam/passwords.feature,
  features/iam/server_certificates.feature,
  features/iam/signing_certificates.feature,
  features/iam/step_definitions/access_keys.rb,
  features/iam/step_definitions/account_aliases.rb,
  features/iam/step_definitions/account_summary.rb,
  features/iam/step_definitions/groups.rb,
  features/iam/step_definitions/iam.rb,
  features/iam/step_definitions/login_profiles.rb,
  features/iam/step_definitions/mfa.rb,
  features/iam/step_definitions/password_policy.rb,
  features/iam/step_definitions/server_certificates.rb,
  features/iam/step_definitions/signing_certificates.rb,
  features/iam/step_definitions/users.rb, features/iam/user_policies.feature,
  features/iam/users.feature, features/iam/virtual_mfa.feature,
  features/import_export/client.feature,
  features/import_export/step_definitions/client.rb,
  features/import_export/step_definitions/import_export.rb,
  features/proxy.feature, features/rds/client.feature,
  features/rds/step_definitions/client.rb,
  features/rds/step_definitions/rds.rb, features/record/count.feature,
  features/record/dirty_tracking.feature, features/record/find.feature,
  features/record/hash_model.feature,
  features/record/optimistic_locking.feature, features/record/scope.feature,
  features/record/step_definitions/count.rb,
  features/record/step_definitions/dirty_tracking.rb,
  features/record/step_definitions/hash_model.rb,
  features/record/step_definitions/optimistic_locking.rb,
  features/record/step_definitions/orm.rb,
  features/record/step_definitions/validations.rb,
  features/record/validations.feature, features/route_53/client.feature,
  features/route_53/route_53.rb, features/route_53/step_definitions/client.rb,
  features/s3/async_buckets.feature,
  features/s3/high_level/bucket_acls.feature,
  features/s3/high_level/buckets.feature,
  features/s3/high_level/client_side_encryption.feature,
  features/s3/high_level/errors.feature,
  features/s3/high_level/lifecycle_configuration.feature,
  features/s3/high_level/object_acls.feature,
  features/s3/high_level/objects.feature,
  features/s3/high_level/policies.feature,
  features/s3/high_level/post.feature,
  features/s3/high_level/server_side_encryption.feature,
  features/s3/high_level/step_definitions.rb,
  features/s3/high_level/step_definitions/bucket_acls.rb,
  features/s3/high_level/step_definitions/buckets.rb,
  features/s3/high_level/step_definitions/client_side_encryption.rb,
  features/s3/high_level/step_definitions/errors.rb,
  features/s3/high_level/step_definitions/lifecycle_configuration.rb,
  features/s3/high_level/step_definitions/object_acls.rb,
  features/s3/high_level/step_definitions/objects.rb,
  features/s3/high_level/step_definitions/policies.rb,
  features/s3/high_level/step_definitions/post.rb,
  features/s3/high_level/step_definitions/server_side_encryption.rb,
  features/s3/high_level/step_definitions/tree.rb,
  features/s3/high_level/step_definitions/uploads.rb,
  features/s3/high_level/step_definitions/urls.rb,
  features/s3/high_level/step_definitions/versions.rb,
  features/s3/high_level/tree.feature, features/s3/high_level/uploads.feature,
  features/s3/high_level/urls.feature,
  features/s3/high_level/versions.feature,
  features/s3/low_level/bucket_acls.feature,
  features/s3/low_level/buckets.feature,
  features/s3/low_level/object_acls.feature,
  features/s3/low_level/policies.feature,
  features/s3/low_level/step_definitions/acls.rb,
  features/s3/low_level/step_definitions/buckets.rb,
  features/s3/low_level/step_definitions/endpoints.rb,
  features/s3/low_level/step_definitions/lifecycle_configuration.rb,
  features/s3/low_level/step_definitions/object_acls.rb,
  features/s3/low_level/step_definitions/objects.rb,
  features/s3/low_level/step_definitions/policies.rb,
  features/s3/low_level/step_definitions/uploads.rb,
  features/s3/low_level/step_definitions/versions.rb,
  features/s3/low_level/uploads.feature,
  features/s3/low_level/versions.feature,
  features/s3/step_definitions/async_buckets.rb,
  features/simple_db/high_level/count.feature,
  features/simple_db/high_level/domains.feature,
  features/simple_db/high_level/errors.feature,
  features/simple_db/high_level/items.feature,
  features/simple_db/high_level/select.feature,
  features/simple_db/high_level/step_definitions/count.rb,
  features/simple_db/high_level/step_definitions/domains.rb,
  features/simple_db/high_level/step_definitions/items.rb,
  features/simple_db/high_level/step_definitions/select.rb,
  features/simple_db/low_level/domains.feature,
  features/simple_db/low_level/items.feature,
  features/simple_db/low_level/step_definitions/domains.rb,
  features/simple_db/low_level/step_definitions/items.rb,
  features/simple_email_service/email_addresses.feature,
  features/simple_email_service/errors.feature,
  features/simple_email_service/identities.feature,
  features/simple_email_service/quotas.feature,
  features/simple_email_service/send.feature,
  features/simple_email_service/statistics.feature,
  features/simple_email_service/step_definitions/email_addresses.rb,
  features/simple_email_service/step_definitions/identities.rb,
  features/simple_email_service/step_definitions/quotas.rb,
  features/simple_email_service/step_definitions/send.rb,
  features/simple_email_service/step_definitions/ses.rb,
  features/simple_email_service/step_definitions/statistics.rb,
  features/simple_workflow/activity_types.feature,
  features/simple_workflow/decision_tasks.feature,
  features/simple_workflow/domains.feature,
  features/simple_workflow/step_definitions/activity_types.rb,
  features/simple_workflow/step_definitions/decision_tasks.rb,
  features/simple_workflow/step_definitions/domains.rb,
  features/simple_workflow/step_definitions/swf.rb,
  features/simple_workflow/step_definitions/workflow_executions.rb,
  features/simple_workflow/step_definitions/workflow_types.rb,
  features/simple_workflow/workflow_executions.feature,
  features/simple_workflow/workflow_types.feature,
  features/sns/errors.feature, features/sns/step_definitions/sns.rb,
  features/sns/step_definitions/subscriptions.rb,
  features/sns/step_definitions/topics.rb, features/sns/subscriptions.feature,
  features/sns/topics.feature, features/sqs/messages.feature,
  features/sqs/policies.feature, features/sqs/queues.feature,
  features/sqs/step_definitions/messages.rb,
  features/sqs/step_definitions/policies.rb,
  features/sqs/step_definitions/queues.rb,
  features/sqs/step_definitions/sqs.rb, features/step_definitions.rb,
  features/storage_gateway/client.feature,
  features/storage_gateway/step_definitions/client.rb,
  features/storage_gateway/step_definitions/storage_gateway.rb,
  features/sts/sessions.feature, features/sts/step_definitions/sessions.rb,
  features/sts/step_definitions/sts.rb, features/support/common.rb,
  lib/aws-sdk.rb, lib/aws.rb, lib/aws/api_config/AutoScaling-2011-01-01.yml,
  lib/aws/api_config/CloudFormation-2010-05-15.yml,
  lib/aws/api_config/CloudFront-2012-05-05.yml,
  lib/aws/api_config/CloudSearch-2011-02-01.yml,
  lib/aws/api_config/CloudWatch-2010-08-01.yml,
  lib/aws/api_config/DataPipeline-2012-10-29.yml,
  lib/aws/api_config/DynamoDB-2011-12-05.yml,
  lib/aws/api_config/EC2-2012-07-20.yml,
  lib/aws/api_config/ELB-2012-06-01.yml,
  lib/aws/api_config/EMR-2009-03-31.yml,
  lib/aws/api_config/ElastiCache-2012-03-09.yml,
  lib/aws/api_config/ElasticBeanstalk-2010-12-01.yml,
  lib/aws/api_config/Glacier-2012-06-01.yml,
  lib/aws/api_config/IAM-2010-05-08.yml,
  lib/aws/api_config/ImportExport-2010-06-01.yml,
  lib/aws/api_config/RDS-2012-07-31.yml,
  lib/aws/api_config/Route53-2012-02-29.yml,
  lib/aws/api_config/SNS-2010-03-31.yml,
  lib/aws/api_config/SQS-2012-11-05.yml,
  lib/aws/api_config/STS-2011-06-15.yml,
  lib/aws/api_config/SimpleDB-2009-04-15.yml,
  lib/aws/api_config/SimpleEmailService-2010-12-01.yml,
  lib/aws/api_config/SimpleWorkflow-2012-01-25.yml,
  lib/aws/api_config/StorageGateway-2012-06-30.yml, lib/aws/auto_scaling.rb,
  lib/aws/auto_scaling/activity.rb,
  lib/aws/auto_scaling/activity_collection.rb, lib/aws/auto_scaling/client.rb,
  lib/aws/auto_scaling/config.rb, lib/aws/auto_scaling/errors.rb,
  lib/aws/auto_scaling/group.rb, lib/aws/auto_scaling/group_collection.rb,
  lib/aws/auto_scaling/group_options.rb, lib/aws/auto_scaling/instance.rb,
  lib/aws/auto_scaling/instance_collection.rb,
  lib/aws/auto_scaling/launch_configuration.rb,
  lib/aws/auto_scaling/launch_configuration_collection.rb,
  lib/aws/auto_scaling/notification_configuration.rb,
  lib/aws/auto_scaling/notification_configuration_collection.rb,
  lib/aws/auto_scaling/request.rb, lib/aws/auto_scaling/scaling_policy.rb,
  lib/aws/auto_scaling/scaling_policy_collection.rb,
  lib/aws/auto_scaling/scaling_policy_options.rb,
  lib/aws/auto_scaling/scheduled_action.rb,
  lib/aws/auto_scaling/scheduled_action_collection.rb,
  lib/aws/auto_scaling/tag.rb, lib/aws/auto_scaling/tag_collection.rb,
  lib/aws/cloud_formation.rb, lib/aws/cloud_formation/client.rb,
  lib/aws/cloud_formation/config.rb, lib/aws/cloud_formation/errors.rb,
  lib/aws/cloud_formation/request.rb, lib/aws/cloud_formation/stack.rb,
  lib/aws/cloud_formation/stack_collection.rb,
  lib/aws/cloud_formation/stack_event.rb,
  lib/aws/cloud_formation/stack_event_collection.rb,
  lib/aws/cloud_formation/stack_options.rb,
  lib/aws/cloud_formation/stack_output.rb,
  lib/aws/cloud_formation/stack_resource.rb,
  lib/aws/cloud_formation/stack_resource_collection.rb,
  lib/aws/cloud_formation/stack_resource_summary_collection.rb,
  lib/aws/cloud_formation/stack_summary_collection.rb, lib/aws/cloud_front.rb,
  lib/aws/cloud_front/client.rb, lib/aws/cloud_front/config.rb,
  lib/aws/cloud_front/errors.rb, lib/aws/cloud_front/request.rb,
  lib/aws/cloud_search.rb, lib/aws/cloud_search/client.rb,
  lib/aws/cloud_search/config.rb, lib/aws/cloud_search/errors.rb,
  lib/aws/cloud_search/request.rb, lib/aws/cloud_watch.rb,
  lib/aws/cloud_watch/alarm.rb, lib/aws/cloud_watch/alarm_collection.rb,
  lib/aws/cloud_watch/alarm_history_item.rb,
  lib/aws/cloud_watch/alarm_history_item_collection.rb,
  lib/aws/cloud_watch/client.rb, lib/aws/cloud_watch/config.rb,
  lib/aws/cloud_watch/errors.rb, lib/aws/cloud_watch/metric.rb,
  lib/aws/cloud_watch/metric_alarm_collection.rb,
  lib/aws/cloud_watch/metric_collection.rb,
  lib/aws/cloud_watch/metric_statistics.rb, lib/aws/cloud_watch/request.rb,
  lib/aws/core.rb, lib/aws/core/async_handle.rb, lib/aws/core/autoloader.rb,
  lib/aws/core/cacheable.rb, lib/aws/core/client.rb,
  lib/aws/core/collection.rb, lib/aws/core/collection/simple.rb,
  lib/aws/core/collection/with_limit_and_next_token.rb,
  lib/aws/core/collection/with_next_token.rb, lib/aws/core/configuration.rb,
  lib/aws/core/credential_providers.rb, lib/aws/core/data.rb,
  lib/aws/core/http/curb_handler.rb, lib/aws/core/http/handler.rb,
  lib/aws/core/http/httparty_handler.rb,
  lib/aws/core/http/net_http_handler.rb, lib/aws/core/http/request.rb,
  lib/aws/core/http/response.rb, lib/aws/core/indifferent_hash.rb,
  lib/aws/core/inflection.rb, lib/aws/core/json_client.rb,
  lib/aws/core/json_parser.rb, lib/aws/core/json_request_builder.rb,
  lib/aws/core/json_response_parser.rb, lib/aws/core/lazy_error_classes.rb,
  lib/aws/core/log_formatter.rb, lib/aws/core/managed_file.rb,
  lib/aws/core/meta_utils.rb, lib/aws/core/model.rb, lib/aws/core/naming.rb,
  lib/aws/core/option_grammar.rb, lib/aws/core/options/json_serializer.rb,
  lib/aws/core/options/validator.rb, lib/aws/core/options/xml_serializer.rb,
  lib/aws/core/page_result.rb, lib/aws/core/policy.rb,
  lib/aws/core/query_client.rb, lib/aws/core/query_error_parser.rb,
  lib/aws/core/query_request_builder.rb,
  lib/aws/core/query_response_parser.rb, lib/aws/core/resource.rb,
  lib/aws/core/resource_cache.rb, lib/aws/core/response.rb,
  lib/aws/core/response_cache.rb, lib/aws/core/rest_error_parser.rb,
  lib/aws/core/rest_json_client.rb, lib/aws/core/rest_request_builder.rb,
  lib/aws/core/rest_response_parser.rb, lib/aws/core/rest_xml_client.rb,
  lib/aws/core/service_interface.rb, lib/aws/core/signature/version_2.rb,
  lib/aws/core/signature/version_3.rb,
  lib/aws/core/signature/version_3_https.rb,
  lib/aws/core/signature/version_4.rb, lib/aws/core/signer.rb,
  lib/aws/core/uri_escape.rb, lib/aws/core/xml/frame.rb,
  lib/aws/core/xml/frame_stack.rb, lib/aws/core/xml/grammar.rb,
  lib/aws/core/xml/parser.rb, lib/aws/core/xml/root_frame.rb,
  lib/aws/core/xml/sax_handlers/libxml.rb,
  lib/aws/core/xml/sax_handlers/nokogiri.rb,
  lib/aws/core/xml/sax_handlers/ox.rb, lib/aws/core/xml/sax_handlers/rexml.rb,
  lib/aws/core/xml/stub.rb, lib/aws/data_pipeline.rb,
  lib/aws/data_pipeline/client.rb, lib/aws/data_pipeline/config.rb,
  lib/aws/data_pipeline/errors.rb, lib/aws/data_pipeline/request.rb,
  lib/aws/dynamo_db.rb, lib/aws/dynamo_db/attribute_collection.rb,
  lib/aws/dynamo_db/batch_get.rb, lib/aws/dynamo_db/batch_write.rb,
  lib/aws/dynamo_db/binary.rb, lib/aws/dynamo_db/client.rb,
  lib/aws/dynamo_db/config.rb, lib/aws/dynamo_db/errors.rb,
  lib/aws/dynamo_db/expectations.rb, lib/aws/dynamo_db/item.rb,
  lib/aws/dynamo_db/item_collection.rb, lib/aws/dynamo_db/item_data.rb,
  lib/aws/dynamo_db/keys.rb, lib/aws/dynamo_db/primary_key_element.rb,
  lib/aws/dynamo_db/request.rb, lib/aws/dynamo_db/resource.rb,
  lib/aws/dynamo_db/table.rb, lib/aws/dynamo_db/table_collection.rb,
  lib/aws/dynamo_db/types.rb, lib/aws/ec2.rb, lib/aws/ec2/attachment.rb,
  lib/aws/ec2/attachment_collection.rb, lib/aws/ec2/availability_zone.rb,
  lib/aws/ec2/availability_zone_collection.rb,
  lib/aws/ec2/block_device_mappings.rb, lib/aws/ec2/client.rb,
  lib/aws/ec2/collection.rb, lib/aws/ec2/config.rb,
  lib/aws/ec2/config_transform.rb, lib/aws/ec2/customer_gateway.rb,
  lib/aws/ec2/customer_gateway_collection.rb, lib/aws/ec2/dhcp_options.rb,
  lib/aws/ec2/dhcp_options_collection.rb, lib/aws/ec2/elastic_ip.rb,
  lib/aws/ec2/elastic_ip_collection.rb, lib/aws/ec2/errors.rb,
  lib/aws/ec2/export_task.rb, lib/aws/ec2/export_task_collection.rb,
  lib/aws/ec2/filtered_collection.rb, lib/aws/ec2/has_permissions.rb,
  lib/aws/ec2/image.rb, lib/aws/ec2/image_collection.rb,
  lib/aws/ec2/instance.rb, lib/aws/ec2/instance_collection.rb,
  lib/aws/ec2/internet_gateway.rb, lib/aws/ec2/internet_gateway/attachment.rb,
  lib/aws/ec2/internet_gateway_collection.rb, lib/aws/ec2/key_pair.rb,
  lib/aws/ec2/key_pair_collection.rb, lib/aws/ec2/network_acl.rb,
  lib/aws/ec2/network_acl/association.rb, lib/aws/ec2/network_acl/entry.rb,
  lib/aws/ec2/network_acl_collection.rb, lib/aws/ec2/network_interface.rb,
  lib/aws/ec2/network_interface/attachment.rb,
  lib/aws/ec2/network_interface_collection.rb,
  lib/aws/ec2/permission_collection.rb, lib/aws/ec2/region.rb,
  lib/aws/ec2/region_collection.rb, lib/aws/ec2/request.rb,
  lib/aws/ec2/reserved_instances.rb,
  lib/aws/ec2/reserved_instances_collection.rb,
  lib/aws/ec2/reserved_instances_offering.rb,
  lib/aws/ec2/reserved_instances_offering_collection.rb,
  lib/aws/ec2/resource.rb, lib/aws/ec2/resource_tag_collection.rb,
  lib/aws/ec2/route_table.rb, lib/aws/ec2/route_table/association.rb,
  lib/aws/ec2/route_table/route.rb, lib/aws/ec2/route_table_collection.rb,
  lib/aws/ec2/security_group.rb, lib/aws/ec2/security_group/ip_permission.rb,
  lib/aws/ec2/security_group/ip_permission_collection.rb,
  lib/aws/ec2/security_group_collection.rb, lib/aws/ec2/snapshot.rb,
  lib/aws/ec2/snapshot_collection.rb, lib/aws/ec2/subnet.rb,
  lib/aws/ec2/subnet_collection.rb, lib/aws/ec2/tag.rb,
  lib/aws/ec2/tag_collection.rb, lib/aws/ec2/tagged_collection.rb,
  lib/aws/ec2/tagged_item.rb, lib/aws/ec2/volume.rb,
  lib/aws/ec2/volume_collection.rb, lib/aws/ec2/vpc.rb,
  lib/aws/ec2/vpc_collection.rb, lib/aws/ec2/vpn_connection.rb,
  lib/aws/ec2/vpn_connection/telemetry.rb,
  lib/aws/ec2/vpn_connection_collection.rb, lib/aws/ec2/vpn_gateway.rb,
  lib/aws/ec2/vpn_gateway/attachment.rb,
  lib/aws/ec2/vpn_gateway_collection.rb, lib/aws/elastic_beanstalk.rb,
  lib/aws/elastic_beanstalk/client.rb, lib/aws/elastic_beanstalk/config.rb,
  lib/aws/elastic_beanstalk/errors.rb, lib/aws/elastic_beanstalk/request.rb,
  lib/aws/elasticache.rb, lib/aws/elasticache/client.rb,
  lib/aws/elasticache/config.rb, lib/aws/elasticache/errors.rb,
  lib/aws/elasticache/request.rb, lib/aws/elb.rb,
  lib/aws/elb/availability_zone_collection.rb,
  lib/aws/elb/backend_server_policy_collection.rb, lib/aws/elb/client.rb,
  lib/aws/elb/config.rb, lib/aws/elb/errors.rb,
  lib/aws/elb/instance_collection.rb, lib/aws/elb/listener.rb,
  lib/aws/elb/listener_collection.rb, lib/aws/elb/listener_opts.rb,
  lib/aws/elb/load_balancer.rb, lib/aws/elb/load_balancer_collection.rb,
  lib/aws/elb/load_balancer_policy.rb,
  lib/aws/elb/load_balancer_policy_collection.rb, lib/aws/elb/request.rb,
  lib/aws/emr.rb, lib/aws/emr/client.rb, lib/aws/emr/config.rb,
  lib/aws/emr/errors.rb, lib/aws/emr/instance_group.rb,
  lib/aws/emr/instance_group_collection.rb, lib/aws/emr/job_flow.rb,
  lib/aws/emr/job_flow_collection.rb, lib/aws/emr/request.rb,
  lib/aws/errors.rb, lib/aws/glacier.rb, lib/aws/glacier/archive.rb,
  lib/aws/glacier/archive_collection.rb, lib/aws/glacier/client.rb,
  lib/aws/glacier/config.rb, lib/aws/glacier/errors.rb,
  lib/aws/glacier/request.rb, lib/aws/glacier/resource.rb,
  lib/aws/glacier/vault.rb, lib/aws/glacier/vault_collection.rb,
  lib/aws/glacier/vault_notification_configuration.rb, lib/aws/iam.rb,
  lib/aws/iam/access_key.rb, lib/aws/iam/access_key_collection.rb,
  lib/aws/iam/account_alias_collection.rb, lib/aws/iam/client.rb,
  lib/aws/iam/collection.rb, lib/aws/iam/config.rb, lib/aws/iam/errors.rb,
  lib/aws/iam/group.rb, lib/aws/iam/group_collection.rb,
  lib/aws/iam/group_policy_collection.rb,
  lib/aws/iam/group_user_collection.rb, lib/aws/iam/login_profile.rb,
  lib/aws/iam/mfa_device.rb, lib/aws/iam/mfa_device_collection.rb,
  lib/aws/iam/policy.rb, lib/aws/iam/policy_collection.rb,
  lib/aws/iam/request.rb, lib/aws/iam/resource.rb,
  lib/aws/iam/server_certificate.rb,
  lib/aws/iam/server_certificate_collection.rb,
  lib/aws/iam/signing_certificate.rb,
  lib/aws/iam/signing_certificate_collection.rb, lib/aws/iam/user.rb,
  lib/aws/iam/user_collection.rb, lib/aws/iam/user_group_collection.rb,
  lib/aws/iam/user_policy.rb, lib/aws/iam/user_policy_collection.rb,
  lib/aws/iam/virtual_mfa_device.rb,
  lib/aws/iam/virtual_mfa_device_collection.rb, lib/aws/import_export.rb,
  lib/aws/import_export/client.rb, lib/aws/import_export/config.rb,
  lib/aws/import_export/errors.rb, lib/aws/import_export/request.rb,
  lib/aws/rails.rb, lib/aws/rds.rb, lib/aws/rds/client.rb,
  lib/aws/rds/config.rb, lib/aws/rds/db_instance.rb,
  lib/aws/rds/db_instance_collection.rb, lib/aws/rds/db_snapshot.rb,
  lib/aws/rds/db_snapshot_collection.rb, lib/aws/rds/errors.rb,
  lib/aws/rds/request.rb, lib/aws/record.rb, lib/aws/record/abstract_base.rb,
  lib/aws/record/attributes.rb, lib/aws/record/conversion.rb,
  lib/aws/record/dirty_tracking.rb, lib/aws/record/errors.rb,
  lib/aws/record/exceptions.rb, lib/aws/record/hash_model.rb,
  lib/aws/record/hash_model/attributes.rb,
  lib/aws/record/hash_model/finder_methods.rb,
  lib/aws/record/hash_model/scope.rb, lib/aws/record/model.rb,
  lib/aws/record/model/attributes.rb, lib/aws/record/model/finder_methods.rb,
  lib/aws/record/model/scope.rb, lib/aws/record/naming.rb,
  lib/aws/record/scope.rb, lib/aws/record/validations.rb,
  lib/aws/record/validator.rb, lib/aws/record/validators/acceptance.rb,
  lib/aws/record/validators/block.rb,
  lib/aws/record/validators/confirmation.rb,
  lib/aws/record/validators/count.rb, lib/aws/record/validators/exclusion.rb,
  lib/aws/record/validators/format.rb, lib/aws/record/validators/inclusion.rb,
  lib/aws/record/validators/length.rb, lib/aws/record/validators/method.rb,
  lib/aws/record/validators/numericality.rb,
  lib/aws/record/validators/presence.rb, lib/aws/route_53.rb,
  lib/aws/route_53/client.rb, lib/aws/route_53/config.rb,
  lib/aws/route_53/errors.rb, lib/aws/route_53/request.rb, lib/aws/s3.rb,
  lib/aws/s3/access_control_list.rb, lib/aws/s3/acl_object.rb,
  lib/aws/s3/acl_options.rb, lib/aws/s3/bucket.rb,
  lib/aws/s3/bucket_collection.rb,
  lib/aws/s3/bucket_lifecycle_configuration.rb,
  lib/aws/s3/bucket_tag_collection.rb,
  lib/aws/s3/bucket_version_collection.rb, lib/aws/s3/cipher_io.rb,
  lib/aws/s3/client.rb, lib/aws/s3/client/xml.rb, lib/aws/s3/config.rb,
  lib/aws/s3/cors_rule.rb, lib/aws/s3/cors_rule_collection.rb,
  lib/aws/s3/data_options.rb, lib/aws/s3/encryption_utils.rb,
  lib/aws/s3/errors.rb, lib/aws/s3/multipart_upload.rb,
  lib/aws/s3/multipart_upload_collection.rb, lib/aws/s3/object_collection.rb,
  lib/aws/s3/object_metadata.rb, lib/aws/s3/object_upload_collection.rb,
  lib/aws/s3/object_version.rb, lib/aws/s3/object_version_collection.rb,
  lib/aws/s3/paginated_collection.rb, lib/aws/s3/policy.rb,
  lib/aws/s3/prefix_and_delimiter_collection.rb,
  lib/aws/s3/prefixed_collection.rb, lib/aws/s3/presigned_post.rb,
  lib/aws/s3/request.rb, lib/aws/s3/s3_object.rb, lib/aws/s3/tree.rb,
  lib/aws/s3/tree/branch_node.rb, lib/aws/s3/tree/child_collection.rb,
  lib/aws/s3/tree/leaf_node.rb, lib/aws/s3/tree/node.rb,
  lib/aws/s3/tree/parent.rb, lib/aws/s3/uploaded_part.rb,
  lib/aws/s3/uploaded_part_collection.rb, lib/aws/simple_db.rb,
  lib/aws/simple_db/attribute.rb, lib/aws/simple_db/attribute_collection.rb,
  lib/aws/simple_db/client.rb, lib/aws/simple_db/config.rb,
  lib/aws/simple_db/consistent_read_option.rb,
  lib/aws/simple_db/delete_attributes.rb, lib/aws/simple_db/domain.rb,
  lib/aws/simple_db/domain_collection.rb,
  lib/aws/simple_db/domain_metadata.rb, lib/aws/simple_db/errors.rb,
  lib/aws/simple_db/expect_condition_option.rb, lib/aws/simple_db/item.rb,
  lib/aws/simple_db/item_collection.rb, lib/aws/simple_db/item_data.rb,
  lib/aws/simple_db/put_attributes.rb, lib/aws/simple_db/request.rb,
  lib/aws/simple_email_service.rb, lib/aws/simple_email_service/client.rb,
  lib/aws/simple_email_service/config.rb,
  lib/aws/simple_email_service/email_address_collection.rb,
  lib/aws/simple_email_service/errors.rb,
  lib/aws/simple_email_service/identity.rb,
  lib/aws/simple_email_service/identity_collection.rb,
  lib/aws/simple_email_service/quotas.rb,
  lib/aws/simple_email_service/request.rb, lib/aws/simple_workflow.rb,
  lib/aws/simple_workflow/activity_task.rb,
  lib/aws/simple_workflow/activity_task_collection.rb,
  lib/aws/simple_workflow/activity_type.rb,
  lib/aws/simple_workflow/activity_type_collection.rb,
  lib/aws/simple_workflow/client.rb, lib/aws/simple_workflow/config.rb,
  lib/aws/simple_workflow/count.rb, lib/aws/simple_workflow/decision_task.rb,
  lib/aws/simple_workflow/decision_task_collection.rb,
  lib/aws/simple_workflow/domain.rb,
  lib/aws/simple_workflow/domain_collection.rb,
  lib/aws/simple_workflow/errors.rb, lib/aws/simple_workflow/history_event.rb,
  lib/aws/simple_workflow/history_event_collection.rb,
  lib/aws/simple_workflow/option_formatters.rb,
  lib/aws/simple_workflow/request.rb, lib/aws/simple_workflow/resource.rb,
  lib/aws/simple_workflow/type.rb, lib/aws/simple_workflow/type_collection.rb,
  lib/aws/simple_workflow/workflow_execution.rb,
  lib/aws/simple_workflow/workflow_execution_collection.rb,
  lib/aws/simple_workflow/workflow_type.rb,
  lib/aws/simple_workflow/workflow_type_collection.rb, lib/aws/sns.rb,
  lib/aws/sns/client.rb, lib/aws/sns/config.rb, lib/aws/sns/errors.rb,
  lib/aws/sns/has_delivery_policy.rb, lib/aws/sns/policy.rb,
  lib/aws/sns/request.rb, lib/aws/sns/subscription.rb,
  lib/aws/sns/subscription_collection.rb, lib/aws/sns/topic.rb,
  lib/aws/sns/topic_collection.rb,
  lib/aws/sns/topic_subscription_collection.rb, lib/aws/sqs.rb,
  lib/aws/sqs/client.rb, lib/aws/sqs/config.rb, lib/aws/sqs/errors.rb,
  lib/aws/sqs/policy.rb, lib/aws/sqs/queue.rb,
  lib/aws/sqs/queue_collection.rb, lib/aws/sqs/received_message.rb,
  lib/aws/sqs/received_sns_message.rb, lib/aws/sqs/request.rb,
  lib/aws/storage_gateway.rb, lib/aws/storage_gateway/client.rb,
  lib/aws/storage_gateway/config.rb, lib/aws/storage_gateway/errors.rb,
  lib/aws/storage_gateway/request.rb, lib/aws/sts.rb, lib/aws/sts/client.rb,
  lib/aws/sts/config.rb, lib/aws/sts/errors.rb,
  lib/aws/sts/federated_session.rb, lib/aws/sts/policy.rb,
  lib/aws/sts/request.rb, lib/aws/sts/session.rb, lib/aws/version.rb,
  lib/net/http/connection_pool.rb, lib/net/http/connection_pool/connection.rb,
  lib/net/http/connection_pool/session.rb, rails/init.rb,
  samples/ec2/run_instance.rb, samples/s3/upload_file.rb,
  samples/samples_config.rb,
  spec/aws/auto_scaling/activity_collection_spec.rb,
  spec/aws/auto_scaling/activity_spec.rb,
  spec/aws/auto_scaling/group_collection_spec.rb,
  spec/aws/auto_scaling/group_spec.rb,
  spec/aws/auto_scaling/instance_collection_spec.rb,
  spec/aws/auto_scaling/instance_spec.rb,
  spec/aws/auto_scaling/launch_configuration_collection_spec.rb,
  spec/aws/auto_scaling/launch_configuration_spec.rb,
  spec/aws/auto_scaling/notification_configuration_collection_spec.rb,
  spec/aws/auto_scaling/notification_configuration_spec.rb,
  spec/aws/auto_scaling/request_spec.rb,
  spec/aws/auto_scaling/scaling_policy_colletion_spec.rb,
  spec/aws/auto_scaling/scaling_policy_spec.rb,
  spec/aws/auto_scaling/scheduled_action_collection_spec.rb,
  spec/aws/auto_scaling/scheduled_action_spec.rb,
  spec/aws/auto_scaling/tag_collection_spec.rb, spec/aws/auto_scaling_spec.rb,
  spec/aws/cloud_formation/request_spec.rb,
  spec/aws/cloud_formation/stack_collection_spec.rb,
  spec/aws/cloud_formation/stack_event_collection_spec.rb,
  spec/aws/cloud_formation/stack_options_spec.rb,
  spec/aws/cloud_formation/stack_resource_collection_spec.rb,
  spec/aws/cloud_formation/stack_resource_spec.rb,
  spec/aws/cloud_formation/stack_resource_summary_collection_spec.rb,
  spec/aws/cloud_formation/stack_spec.rb,
  spec/aws/cloud_formation/stack_summary_collection_spec.rb,
  spec/aws/cloud_formation_spec.rb,
  spec/aws/cloud_watch/alarm_collection_spec.rb,
  spec/aws/cloud_watch/alarm_history_item_collection_spec.rb,
  spec/aws/cloud_watch/alarm_history_item_spec.rb,
  spec/aws/cloud_watch/alarm_spec.rb,
  spec/aws/cloud_watch/metric_alarm_collection_spec.rb,
  spec/aws/cloud_watch/metric_collection_spec.rb,
  spec/aws/cloud_watch/metric_spec.rb, spec/aws/cloud_watch_spec.rb,
  spec/aws/config_spec.rb, spec/aws/core/async_handle_spec.rb,
  spec/aws/core/cacheable_spec.rb, spec/aws/core/client_spec.rb,
  spec/aws/core/collection/simple_spec.rb,
  spec/aws/core/collection/with_next_token_spec.rb,
  spec/aws/core/configuration_spec.rb,
  spec/aws/core/credential_providers_spec.rb, spec/aws/core/data_spec.rb,
  spec/aws/core/http/handler_spec.rb,
  spec/aws/core/http/httparty_handler_spec.rb,
  spec/aws/core/http/net_http_handler_spec.rb,
  spec/aws/core/http/request_param_spec.rb,
  spec/aws/core/http/request_spec.rb, spec/aws/core/http/response_spec.rb,
  spec/aws/core/indifferent_hash_spec.rb, spec/aws/core/inflection_spec.rb,
  spec/aws/core/lazy_error_classes_spec.rb,
  spec/aws/core/log_formatter_spec.rb, spec/aws/core/meta_utils_spec.rb,
  spec/aws/core/option_grammar_spec.rb,
  spec/aws/core/options/validator_spec.rb,
  spec/aws/core/options/xml_serializer_spec.rb, spec/aws/core/policy_spec.rb,
  spec/aws/core/resource_cache_spec.rb, spec/aws/core/response_cache_spec.rb,
  spec/aws/core/response_spec.rb, spec/aws/core/rest_request_builder_spec.rb,
  spec/aws/core/xml/parser_spec.rb,
  spec/aws/dynamo_db/attribute_collection_spec.rb,
  spec/aws/dynamo_db/batch_get_spec.rb,
  spec/aws/dynamo_db/batch_write_spec.rb, spec/aws/dynamo_db/client_spec.rb,
  spec/aws/dynamo_db/errors_spec.rb,
  spec/aws/dynamo_db/item_collection_spec.rb,
  spec/aws/dynamo_db/item_data_spec.rb, spec/aws/dynamo_db/item_spec.rb,
  spec/aws/dynamo_db/request_spec.rb,
  spec/aws/dynamo_db/table_collection_spec.rb,
  spec/aws/dynamo_db/table_spec.rb, spec/aws/dynamo_db/types_spec.rb,
  spec/aws/dynamo_db_spec.rb, spec/aws/ec2/attachment_collection_spec.rb,
  spec/aws/ec2/attachment_spec.rb,
  spec/aws/ec2/availability_zone_collection_spec.rb,
  spec/aws/ec2/availability_zone_spec.rb, spec/aws/ec2/client/xml_spec.rb,
  spec/aws/ec2/client_spec.rb,
  spec/aws/ec2/customer_gateway_collection_spec.rb,
  spec/aws/ec2/customer_gateway_spec.rb,
  spec/aws/ec2/dhcp_options_collection_spec.rb,
  spec/aws/ec2/dhcp_options_spec.rb,
  spec/aws/ec2/elastic_ip_collection_spec.rb, spec/aws/ec2/elastic_ip_spec.rb,
  spec/aws/ec2/export_task_collection_spec.rb,
  spec/aws/ec2/export_task_spec.rb, spec/aws/ec2/image_collection_spec.rb,
  spec/aws/ec2/image_spec.rb, spec/aws/ec2/instance_collection_spec.rb,
  spec/aws/ec2/instance_spec.rb,
  spec/aws/ec2/internet_gateway_collection_spec.rb,
  spec/aws/ec2/internet_gateway_spec.rb,
  spec/aws/ec2/key_pair_collection_spec.rb, spec/aws/ec2/key_pair_spec.rb,
  spec/aws/ec2/network_acl_collection_spec.rb,
  spec/aws/ec2/network_acl_spec.rb,
  spec/aws/ec2/network_interface_collection_spec.rb,
  spec/aws/ec2/network_interface_spec.rb,
  spec/aws/ec2/permission_collection_spec.rb,
  spec/aws/ec2/region_collection_spec.rb, spec/aws/ec2/region_spec.rb,
  spec/aws/ec2/request_spec.rb,
  spec/aws/ec2/reserved_instances_collection_spec.rb,
  spec/aws/ec2/reserved_instances_offering_collection_spec.rb,
  spec/aws/ec2/reserved_instances_offering_spec.rb,
  spec/aws/ec2/reserved_instances_spec.rb,
  spec/aws/ec2/resource_tag_collection_spec.rb,
  spec/aws/ec2/route_table_collection_spec.rb,
  spec/aws/ec2/route_table_spec.rb,
  spec/aws/ec2/security_group/egress_ip_permission_collection_spec.rb,
  spec/aws/ec2/security_group/ip_permission_collection_spec.rb,
  spec/aws/ec2/security_group/ip_permission_spec.rb,
  spec/aws/ec2/security_group_collection_spec.rb,
  spec/aws/ec2/security_group_spec.rb,
  spec/aws/ec2/snapshot_collection_spec.rb, spec/aws/ec2/snapshot_spec.rb,
  spec/aws/ec2/subnet_collection_spec.rb, spec/aws/ec2/subnet_spec.rb,
  spec/aws/ec2/tag_collection_spec.rb, spec/aws/ec2/tag_spec.rb,
  spec/aws/ec2/volume_collection_spec.rb, spec/aws/ec2/volume_spec.rb,
  spec/aws/ec2/vpc_collection_spec.rb, spec/aws/ec2/vpc_spec.rb,
  spec/aws/ec2/vpn_connection_collection_spec.rb,
  spec/aws/ec2/vpn_connection_spec.rb,
  spec/aws/ec2/vpn_gateway_collection_spec.rb,
  spec/aws/ec2/vpn_gateway_spec.rb, spec/aws/ec2_spec.rb,
  spec/aws/elb/availability_zone_collection_spec.rb,
  spec/aws/elb/backend_server_policy_collection_spec.rb,
  spec/aws/elb/instance_collection_spec.rb,
  spec/aws/elb/listener_collection_spec.rb, spec/aws/elb/listener_spec.rb,
  spec/aws/elb/load_balancer_collection_spec.rb,
  spec/aws/elb/load_balancer_policy_collection_spec.rb,
  spec/aws/elb/load_balancer_policy_spec.rb,
  spec/aws/elb/load_balancer_spec.rb, spec/aws/elb_spec.rb,
  spec/aws/emr/instance_group_collection_spec.rb,
  spec/aws/emr/instance_group_spec.rb,
  spec/aws/emr/job_flow_collection_spec.rb, spec/aws/emr/job_flow_spec.rb,
  spec/aws/emr_spec.rb, spec/aws/errors_spec.rb,
  spec/aws/iam/access_key_collection_spec.rb, spec/aws/iam/access_key_spec.rb,
  spec/aws/iam/account_alias_collection_spec.rb, spec/aws/iam/client_spec.rb,
  spec/aws/iam/group_collection_spec.rb,
  spec/aws/iam/group_policy_collection_spec.rb, spec/aws/iam/group_spec.rb,
  spec/aws/iam/group_user_collection_spec.rb,
  spec/aws/iam/login_profile_spec.rb,
  spec/aws/iam/mfa_device_collection_spec.rb, spec/aws/iam/mfa_device_spec.rb,
  spec/aws/iam/policy_spec.rb, spec/aws/iam/request_spec.rb,
  spec/aws/iam/server_certificate_collection_spec.rb,
  spec/aws/iam/server_certificate_spec.rb,
  spec/aws/iam/signing_certificate_collection_spec.rb,
  spec/aws/iam/signing_certificate_spec.rb,
  spec/aws/iam/user_collection_spec.rb,
  spec/aws/iam/user_group_collection_spec.rb,
  spec/aws/iam/user_policy_collection_spec.rb,
  spec/aws/iam/user_policy_spec.rb, spec/aws/iam/user_spec.rb,
  spec/aws/iam/virtual_mfa_device_collection_spec.rb,
  spec/aws/iam/virtual_mfa_device_spec.rb, spec/aws/iam_spec.rb,
  spec/aws/rails_spec.rb, spec/aws/rds/client_spec.rb,
  spec/aws/rds/db_instance_collection_spec.rb,
  spec/aws/rds/db_instance_spec.rb,
  spec/aws/rds/db_snapshot_collection_spec.rb,
  spec/aws/rds/db_snapshot_spec.rb, spec/aws/record/attributes_spec.rb,
  spec/aws/record/hash_model/class_methods_spec.rb,
  spec/aws/record/hash_model/instance_methods_spec.rb,
  spec/aws/record/hash_model_spec.rb,
  spec/aws/record/model/attribute_deletion_spec.rb,
  spec/aws/record/model/class_methods_spec.rb,
  spec/aws/record/model/dirty_tracking_spec.rb,
  spec/aws/record/model/empty_records_spec.rb,
  spec/aws/record/model/errors_spec.rb,
  spec/aws/record/model/instance_methods_spec.rb,
  spec/aws/record/model/optimistic_locking_spec.rb,
  spec/aws/record/model/scope_spec.rb,
  spec/aws/record/model/timestamps_spec.rb, spec/aws/record/model_spec.rb,
  spec/aws/record/validations/acceptance_spec.rb,
  spec/aws/record/validations/confirmation_spec.rb,
  spec/aws/record/validations/count_spec.rb,
  spec/aws/record/validations/exclusion_spec.rb,
  spec/aws/record/validations/format_spec.rb,
  spec/aws/record/validations/inclusion_spec.rb,
  spec/aws/record/validations/length_spec.rb,
  spec/aws/record/validations/method_spec.rb,
  spec/aws/record/validations/numericality_spec.rb,
  spec/aws/record/validations/presence_spec.rb,
  spec/aws/record/validations/validate_spec.rb, spec/aws/record_spec.rb,
  spec/aws/route_53/client_spec.rb, spec/aws/s3/access_control_list_spec.rb,
  spec/aws/s3/bucket_collection_spec.rb,
  spec/aws/s3/bucket_lifecycle_configuration_spec.rb,
  spec/aws/s3/bucket_spec.rb, spec/aws/s3/bucket_version_collection_spec.rb,
  spec/aws/s3/cipher_io_spec.rb, spec/aws/s3/client/xml_spec.rb,
  spec/aws/s3/client_spec.rb, spec/aws/s3/cors_rule_collection_spec.rb,
  spec/aws/s3/cors_rule_spec.rb, spec/aws/s3/errors_spec.rb,
  spec/aws/s3/multipart_upload_collection_spec.rb,
  spec/aws/s3/multipart_upload_spec.rb, spec/aws/s3/object_collection_spec.rb,
  spec/aws/s3/object_metadata_spec.rb,
  spec/aws/s3/object_upload_collection_spec.rb,
  spec/aws/s3/object_version_collection_spec.rb,
  spec/aws/s3/object_version_spec.rb, spec/aws/s3/policy_spec.rb,
  spec/aws/s3/presigned_post_spec.rb, spec/aws/s3/request_spec.rb,
  spec/aws/s3/s3_object/copy_spec.rb, spec/aws/s3/s3_object_encrypt_spec.rb,
  spec/aws/s3/s3_object_spec.rb, spec/aws/s3/tree/branch_node_spec.rb,
  spec/aws/s3/tree/child_collection_spec.rb,
  spec/aws/s3/tree/leaf_node_spec.rb, spec/aws/s3/tree/node_spec.rb,
  spec/aws/s3/tree_spec.rb, spec/aws/s3/uploaded_part_collection_spec.rb,
  spec/aws/s3/uploaded_part_spec.rb, spec/aws/s3_spec.rb,
  spec/aws/session_signer_spec.rb,
  spec/aws/simple_db/attribute_collection_spec.rb,
  spec/aws/simple_db/attribute_spec.rb, spec/aws/simple_db/client_spec.rb,
  spec/aws/simple_db/domain_collection_spec.rb,
  spec/aws/simple_db/domain_metadata_spec.rb,
  spec/aws/simple_db/domain_spec.rb, spec/aws/simple_db/errors_spec.rb,
  spec/aws/simple_db/item_collection_spec.rb,
  spec/aws/simple_db/item_data_spec.rb, spec/aws/simple_db/item_spec.rb,
  spec/aws/simple_db/request_spec.rb, spec/aws/simple_db_spec.rb,
  spec/aws/simple_email_service/client_spec.rb,
  spec/aws/simple_email_service/email_address_collection_spec.rb,
  spec/aws/simple_email_service/identity_collection_spec.rb,
  spec/aws/simple_email_service/identity_spec.rb,
  spec/aws/simple_email_service/quotas_spec.rb,
  spec/aws/simple_email_service/request_spec.rb,
  spec/aws/simple_email_service_spec.rb,
  spec/aws/simple_workflow/activity_task_collection_spec.rb,
  spec/aws/simple_workflow/activity_task_spec.rb,
  spec/aws/simple_workflow/activity_type_collection_spec.rb,
  spec/aws/simple_workflow/activity_type_spec.rb,
  spec/aws/simple_workflow/count_spec.rb,
  spec/aws/simple_workflow/decision_task_collection_spec.rb,
  spec/aws/simple_workflow/decision_task_spec.rb,
  spec/aws/simple_workflow/domain_collection_spec.rb,
  spec/aws/simple_workflow/domain_spec.rb,
  spec/aws/simple_workflow/history_event_collection_spec.rb,
  spec/aws/simple_workflow/history_event_spec.rb,
  spec/aws/simple_workflow/workflow_execution_collection_spec.rb,
  spec/aws/simple_workflow/workflow_execution_spec.rb,
  spec/aws/simple_workflow/workflow_type_collection_spec.rb,
  spec/aws/simple_workflow/workflow_type_spec.rb,
  spec/aws/simple_workflow_spec.rb,
  spec/aws/simple_workflow_type_collection_spec.rb,
  spec/aws/sns/policy_spec.rb, spec/aws/sns/request_spec.rb,
  spec/aws/sns/subscription_collection_spec.rb,
  spec/aws/sns/subscription_spec.rb, spec/aws/sns/topic_collection_spec.rb,
  spec/aws/sns/topic_spec.rb,
  spec/aws/sns/topic_subscription_collection_spec.rb, spec/aws/sns_spec.rb,
  spec/aws/sqs/client_spec.rb, spec/aws/sqs/policy_spec.rb,
  spec/aws/sqs/queue_collection_spec.rb, spec/aws/sqs/queue_spec.rb,
  spec/aws/sqs/received_message_spec.rb,
  spec/aws/sqs/received_sns_message_spec.rb, spec/aws/sqs/request_spec.rb,
  spec/aws/sqs_spec.rb, spec/aws/sts/client_spec.rb,
  spec/aws/sts/federated_session_spec.rb, spec/aws/sts/policy_spec.rb,
  spec/aws/sts/request_spec.rb, spec/aws/sts/session_spec.rb,
  spec/aws/sts_spec.rb, spec/aws_spec.rb, spec/dummy_server.rb,
  spec/mock_ec2_metadata_server.rb,
  spec/net/http/connection_pool/connection_spec.rb,
  spec/net/http/connection_pool/live_tests_spec.rb,
  spec/net/http/connection_pool/session_spec.rb,
  spec/net/http/connection_pool_spec.rb,
  spec/shared/accepts_configuration_examples.rb,
  spec/shared/aws_client_examples.rb, spec/shared/aws_record_examples.rb,
  spec/shared/blocking_handler_examples.rb,
  spec/shared/class_methods_module_examples.rb,
  spec/shared/collection/core_collection_examples.rb,
  spec/shared/collection/filtered_examples.rb,
  spec/shared/collection/indexed_collection_examples.rb,
  spec/shared/collection/simple_examples.rb,
  spec/shared/collection/with_limit_and_next_token_examples.rb,
  spec/shared/collection/with_next_token_examples.rb,
  spec/shared/collection/yields_models_examples.rb,
  spec/shared/configured_grammars_module_examples.rb,
  spec/shared/core_resource_examples.rb,
  spec/shared/dynamo_db/expectation_examples.rb,
  spec/shared/dynamo_db/item_return_values_examples.rb,
  spec/shared/ec2/collection_array_access_examples.rb,
  spec/shared/ec2/collection_examples.rb,
  spec/shared/ec2/describe_call_attribute_examples.rb,
  spec/shared/ec2/exists_method_examples.rb,
  spec/shared/ec2/fitlered_collection_examples.rb,
  spec/shared/ec2/model_object_examples.rb,
  spec/shared/ec2/public_private_accessor_examples.rb,
  spec/shared/ec2/reserved_instances_attributes_examples.rb,
  spec/shared/ec2/resource_accessor_examples.rb,
  spec/shared/ec2/resource_examples.rb,
  spec/shared/ec2/tagged_collection_examples.rb,
  spec/shared/ec2/tagged_item_examples.rb, spec/shared/enumerable_examples.rb,
  spec/shared/iam/policy_collection_examples.rb,
  spec/shared/iam/prefixed_collection_examples.rb,
  spec/shared/indifferent_access_examples.rb,
  spec/shared/pagination_examples.rb, spec/shared/policy_examples.rb,
  spec/shared/record/abstract_base_examples.rb,
  spec/shared/record/attribute_macro_examples.rb,
  spec/shared/record/class_attributes_examples.rb,
  spec/shared/record/instance_examples.rb,
  spec/shared/record/optimistic_lockable_examples.rb,
  spec/shared/record/shardable_examples.rb,
  spec/shared/record/validation_examples.rb, spec/shared/request_examples.rb,
  spec/shared/resource_examples.rb, spec/shared/s3/acl_examples.rb,
  spec/shared/s3/model_object_examples.rb,
  spec/shared/s3/paginated_collection_examples.rb,
  spec/shared/s3/prefixed_collection_examples.rb,
  spec/shared/s3/tree_like_examples.rb, spec/shared/service_examples.rb,
  spec/shared/signature/version_4_examples.rb,
  spec/shared/simple_db/accepts_consistent_read_option_examples.rb,
  spec/shared/simple_db/expect_condition_examples.rb,
  spec/shared/simple_db/model_object_examples.rb,
  spec/shared/simple_workflow/type_collection_examples.rb,
  spec/shared/simple_workflow/type_examples.rb,
  spec/shared/sns/has_delivery_policy_examples.rb,
  spec/shared/sqs/model_object_examples.rb,
  spec/shared/stub_config_examples.rb,
  spec/shared/uses_cached_responses_examples.rb, spec/spec_helper.rb,
  tasks/cucumber.rake, tasks/docs.rake, tasks/rspec.rake,
  tasks/rvm_tester.rake: Updated attributions. Welcome 2013!

2013-01-01 Drew Blas <drew.blas@gmail.com>

  * lib/aws/s3.rb: Fix S3 doc example

  There was a duplicate each in L101 that caused this code example to break.
2012-12-29 Alessandro Diaferia <alediaferia@gmail.com>

  * lib/aws/core/policy.rb: fix typo

  * lib/aws/core/policy.rb: fix json generation

  * lib/aws/core/policy.rb: fix alias

  * lib/aws/core/policy.rb: fix NotResource case

  * lib/aws/core/policy.rb: add support for excluded resources

2012-12-21 Trevor Rowe <trevrowe@amazon.com>

  * lib/aws/data_pipeline/client.rb: Updated data pipeline documentation to
  show the correct return value hash keys.

  * lib/aws/cloud_search.rb, lib/aws/cloud_watch.rb: Added minor documentation
  to AWS::CloudSearch and AWS::CloudWatch.

  * lib/aws/auto_scaling/client.rb, lib/aws/cloud_formation/client.rb,
  lib/aws/cloud_front/client.rb, lib/aws/cloud_search/client.rb,
  lib/aws/cloud_watch/client.rb, lib/aws/data_pipeline/client.rb,
  lib/aws/dynamo_db/client.rb, lib/aws/ec2/client.rb,
  lib/aws/elastic_beanstalk/client.rb, lib/aws/elasticache/client.rb,
  lib/aws/elb/client.rb, lib/aws/emr/client.rb, lib/aws/glacier/client.rb,
  lib/aws/iam/client.rb, lib/aws/import_export/client.rb,
  lib/aws/rds/client.rb, lib/aws/route_53/client.rb,
  lib/aws/simple_db/client.rb, lib/aws/simple_email_service/client.rb,
  lib/aws/simple_workflow/client.rb, lib/aws/sns/client.rb,
  lib/aws/sqs/client.rb, lib/aws/storage_gateway/client.rb,
  lib/aws/sts/client.rb: Minor changes to fix a yard documentation issue for
  client methods.

2012-12-20 Trevor Rowe <trevrowe@amazon.com>

  * lib/aws/data_pipeline.rb, lib/aws/data_pipeline/client.rb,
  lib/aws/glacier.rb: Added minimal documentation for Glacier and Data
  Pipeline.

  * ChangeLog, lib/aws/version.rb: Bump version to 1.8.0

  * lib/aws-sdk.rb: Add missing require call to aws-sdk.rb

  * lib/aws/api_config/Glacier-2012-06-01.yml: Update attributions for Amazon
  Glacier

  * lib/aws.rb: Add missing newline to aws.rb

  * lib/aws-sdk.rb, lib/aws.rb: Flip aws.rb and aws-sdk.rb

  Makes it possible to workaround #37 by adding `-raws` to the Ruby
  process, ie.,

    ruby -raws <file.rb>

  or,

    bundle exec ruby -raws <file.rb>

  * Rakefile, tasks/cucumber.rake, tasks/docs.rake, tasks/rspec.rake,
  tasks/rvm_tester.rake: Update Rakefile and tasks

  * lib/aws/core/options/validator.rb, lib/aws/core/rest_request_builder.rb,
  spec/aws/core/rest_request_builder_spec.rb,
  spec/aws/route_53/client_spec.rb,
  spec/shared/signature/version_4_examples.rb: Resolved some broken specs from
  recently merged branches.

  * lib/aws/cloud_front/client.rb, lib/aws/core.rb,
  lib/aws/core/rest_xml_client.rb, lib/aws/route_53/client.rb: Re-add
  deprecated RESTClient constant, update references

  * lib/aws/sqs/queue.rb: Update @since tags on new methods

  * lib/aws/core.rb, lib/aws/core/client.rb, lib/aws/core/managed_file.rb,
  lib/aws/s3/data_options.rb: Fixed a bug where files opened by the S3 and
  Glacier clients where not getting closed.

  * README.rdoc, features/support/common.rb,
  recipebook/config/initializers/aws.rb, spec/spec_helper.rb: Require
  'aws-sdk' instead of 'aws'

  References #37

  * lib/aws/sqs/received_sns_message.rb: *lib/aws/sqs/received_sns_message.rb
  - new method "body_message_as_h" - Returns the decoded message body as a
  hash.

  * lib/aws/glacier.rb, lib/aws/glacier/archive.rb,
  lib/aws/glacier/archive_collection.rb, lib/aws/glacier/resource.rb,
  lib/aws/glacier/vault.rb, lib/aws/glacier/vault_collection.rb,
  lib/aws/glacier/vault_notification_configuration.rb: Added a few higher
  level abstractions to AWS::Glacier.

  * lib/aws/core/options/json_serializer.rb,
  lib/aws/core/rest_request_builder.rb: Updated the JSON serializer to work
  with request payload rules.

  * lib/aws.rb, lib/aws/api_config/Glacier-2012-06-01.yml, lib/aws/core.rb,
  lib/aws/core/configuration.rb, lib/aws/glacier.rb,
  lib/aws/glacier/client.rb, lib/aws/glacier/config.rb,
  lib/aws/glacier/errors.rb, lib/aws/glacier/request.rb: Added Glacier client
  and api configuration.

  * lib/aws/core/options/validator.rb: Added a blob handler to the request
  option validator.

  * lib/aws/core/signature/version_4.rb: Improved sigv4 implementation,
  possible fewer checksums calculated.

  This is especially important for glacier support where the sigv4
  body checksum is the same as the content sha256 hash header required
  for streaming uploads.

  * lib/aws/core.rb, lib/aws/core/json_parser.rb,
  lib/aws/core/options/json_serializer.rb, lib/aws/core/rest_client.rb,
  lib/aws/core/rest_json_client.rb, lib/aws/core/rest_request_builder.rb,
  lib/aws/core/rest_response_parser.rb, lib/aws/core/rest_xml_client.rb: Split
  Core::RESTClient and associated classes into RESTJSONClient and
  RESTXMLClient.

2012-12-18 Loren Segal <lsegal@amazon.com>

  * lib/aws/s3/bucket_lifecycle_configuration.rb: More example updates in
  BucketLifecycleConfiguration docs

  * lib/aws/s3/bucket_lifecycle_configuration.rb: Update documentation for
  BucketLifecycleConfiguration and Rule

  * lib/aws/core/client.rb, spec/aws/sqs/client_spec.rb: fix
  expired_credentials? expired token error code name: at least sqs service
  response different error code causing auto refreshing iam temp credentials
  does not work

  * lib/aws/ec2/route_table/route.rb: beautifying and removal of unused code

  * ChangeLog, lib/aws/api_config/EC2-2012-07-20.yml,
  lib/aws/api_config/EC2-2012-12-01.yml, lib/aws/ec2/client.rb,
  lib/aws/ec2/route_table/route.rb, spec/aws/ec2/route_table_spec.rb: Added
  support for route origin, version bump to EC2-2012-12-01

  * lib/aws/rds/client.rb, lib/aws/rds/db_instance.rb,
  spec/aws/rds/db_instance_spec.rb: Added Iops support to the db instances
  with added documentation and test updates
2012-12-14 Loren Segal <lsegal@amazon.com>

  * features/s3/high_level/lifecycle_configuration.feature,
  features/s3/high_level/step_definitions/lifecycle_configuration.rb,
  lib/aws/s3/bucket_lifecycle_configuration.rb,
  spec/aws/s3/bucket_lifecycle_configuration_spec.rb: Fix lifecycle
  configuration Date support in 1.8.x

  Also ensures that date values are always expressed at midnight GMT,
  as per the lifecycle configuration specification.

  * features/s3/high_level/objects.feature,
  features/s3/high_level/step_definitions/objects.rb, lib/aws/s3/client.rb,
  lib/aws/s3/request.rb, lib/aws/s3/s3_object.rb, spec/aws/s3/client_spec.rb,
  spec/aws/s3/s3_object_spec.rb: Implement S3 restore operation

  * Adds S3::Client#restore_object to send restore operation
  * Modifies S3::Client#head_object to support x-amz-restore response header
  * Adds S3Object#restore for high level client
  * Adds S3Object#restore_in_progress? to report on status of restore
  operation
  * Adds S3Object#restore_expiration_date to report on expiration date of
    the restored object
  * Adds S3Object#restored_object? to return whether the object is a restored
    object.

  * features/s3/high_level/lifecycle_configuration.feature,
  features/s3/high_level/step_definitions/lifecycle_configuration.rb,
  lib/aws/s3/bucket_lifecycle_configuration.rb, lib/aws/s3/client/xml.rb,
  spec/aws/s3/bucket_lifecycle_configuration_spec.rb,
  spec/aws/s3/bucket_spec.rb: Add Transition and Date support to lifecycle
  rules

  * lib/aws/core/options/xml_serializer.rb,
  spec/aws/core/options/xml_serializer_spec.rb: Added missing spec file
  changes from previous commit.

  * features/cloud_front/client.feature,
  features/cloud_front/step_definitions/client.rb,
  lib/aws/api_config/CloudFront-2012-05-05.yml,
  lib/aws/core/options/xml_serializer.rb,
  lib/aws/core/rest_request_builder.rb: Resolved an issue with AWS::CloudFront
  where request payload rules were ignored when serializing requests.

  * lib/aws/api_config/EC2-2012-07-20.yml: Resolved in issue where
  AWS::EC2::SecurityGroup::IpPermission would incorrectly return :1 as the
  value for protocol instead of :any.

  * lib/aws/ec2/security_group.rb: Fixed an issue where revoking an ip
  permission would fail when protocol is :any.

  * lib/aws/ec2/security_group.rb,
  lib/aws/ec2/security_group/egress_ip_permission_collection.rb,
  lib/aws/ec2/security_group/ingress_ip_permission_collection.rb,
  lib/aws/ec2/security_group/ip_permission_collection.rb: DRY'd up EC2 ingress
  and egress ip permission collections.

2012-12-19 Loren Segal <lsegal@amazon.com>

  * features/data_pipeline/pipelines.feature,
  features/data_pipeline/step_definitions/data_pipeline.rb,
  features/data_pipeline/step_definitions/pipelines.rb: Add integration tests
  for DataPipeline service

  * lib/aws/api_config/DataPipeline-2012-10-29.yml,
  lib/aws/data_pipeline/client.rb: Update DataPipeline model and client

2012-12-12 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws.rb: Added autoloading hooks for DataPipeline.

  * lib/aws/api_config/DataPipeline-2012-10-29.yml, lib/aws/data_pipeline.rb,
  lib/aws/data_pipeline/client.rb, lib/aws/data_pipeline/config.rb,
  lib/aws/data_pipeline/errors.rb, lib/aws/data_pipeline/request.rb: Added
  bootstraping classes for DataPipeline.

  * lib/aws/core/data.rb, spec/aws/core/data_spec.rb: Fixed a bug in
  AWS::Core::Data and AWS::Core::Data::list #dup behavior.

  * lib/aws/core/data.rb: Removed trailing whitespace.

  * lib/aws/ec2/instance_collection.rb,
  spec/aws/ec2/instance_collection_spec.rb: AWS::EC2::Instances#create now
  returns a vanilla Array when running multiple instances.

  * features/import_export/client.feature,
  features/import_export/step_definitions/client.rb,
  features/import_export/step_definitions/import_export.rb: Added basic
  integration test for AWS::ImportExport.

  * lib/aws/api_config/ImportExport-2010-06-01.yml,
  lib/aws/import_export/client.rb: Added API configuration and documentation
  for AWS::ImportExport.

  * lib/aws/core.rb, lib/aws/core/configuration.rb: Documented configuration
  options for AWS::ImportExport.

  * lib/aws.rb, lib/aws/import_export.rb, lib/aws/import_export/client.rb,
  lib/aws/import_export/config.rb, lib/aws/import_export/errors.rb,
  lib/aws/import_export/request.rb: Added bootstrap classes for AWS
  Import/Export.

  * features/cloud_front/client.feature,
  features/cloud_front/step_definitions/client.rb,
  features/cloud_front/step_definitions/cloud_front.rb: Added basic
  integration test for AWS::CloudFront (listing distributions)

  * lib/aws/api_config/CloudFront-2012-05-05.yml,
  lib/aws/cloud_front/client.rb: Updated AWS::CloudFront api configuration,
  removed wrapping elements from responses.

  * lib/aws/cloud_front/config.rb, lib/aws/core.rb,
  lib/aws/core/configuration.rb: Added AWS::CloudFront configuration options.

  * lib/aws/cloud_front/request.rb: Added require time to CloudFront::Request,
  as it needs Time#rfc822.

  * lib/aws.rb: Added autoloading hooks for AWS::CloudFront.

  * lib/aws/cloud_front/error.rb, lib/aws/cloud_front/errors.rb: Moved
  CloudFront::Error source file to fix autoloading.

  * lib/aws/cloud_front/client.rb: Added documentation for client methods.

  * lib/aws/cloud_front.rb: Updated CloudFront example snippet.

  * lib/aws/cloud_front.rb, lib/aws/cloud_front/client.rb,
  lib/aws/cloud_front/error.rb, lib/aws/cloud_front/request.rb: Added
  bootstrap classes for Amazon CloudFront support.

2012-12-17 Chris Mckenzie <chris.mckenzie@rightscale.com>

  * lib/aws/api_config/RDS-2012-07-31.yml,
  lib/aws/api_config/RDS-2012-09-17.yml, lib/aws/rds/client.rb,
  spec/aws/rds/client_spec.rb: Added Iops support to the db instances
  * lib/aws/rds/db_instance.rb: Added Iops support to the db instances
  * lib/aws/rds/db_instance.rb: Added Iops support to the db instances
  * lib/aws/api_config/RDS-2012-07-31.yml: Added Iops support to the db
  instances
2012-12-15 sanemat <o.gata.ken@gmail.com>

  * lib/aws/core/collection.rb: Use Object#to_enum instead of Enumerator.new
  without a block

  Fix warning
  warning: Enumerator.new without a block is deprecated; use Object#to_enum

2012-12-13 Trevor Rowe <trevorrowe@gmail.com>

  * features/storage_gateway/client.feature,
  features/storage_gateway/step_definitions/client.rb: DRY'd up a feature for
  storage gateway, now testing error case using a shared step definition.

  * features/cloud_front/client.feature,
  features/cloud_front/step_definitions/client.rb,
  features/import_export/client.feature,
  features/import_export/step_definitions/client.rb,
  features/step_definitions.rb: Added integration tests to test error parsing.

  * lib/aws/storage_gateway.rb: Corrected a sample given in the documentation
  for AWS::StorageGateway.

  * features/storage_gateway/client.feature,
  features/storage_gateway/step_definitions/client.rb,
  features/storage_gateway/step_definitions/storage_gateway.rb: Added a few
  integration tests for storage gateway.

  * lib/aws/api_config/StorageGateway-2012-06-30.yml: Added api configuration
  for storage gateway.

  * lib/aws/core/json_client.rb, lib/aws/core/json_request_builder.rb,
  lib/aws/core/json_response_parser.rb: Updated JSON client classes to work
  with json v1.1 protocol.

  * lib/aws/core.rb, lib/aws/core/configuration.rb: Documented storage gateway
  configuration options.

  * lib/aws/storage_gateway/client.rb: Documented client API operations for
  AWS::StorageGateway.

  * lib/aws.rb, lib/aws/storage_gateway.rb, lib/aws/storage_gateway/client.rb,
  lib/aws/storage_gateway/config.rb, lib/aws/storage_gateway/errors.rb,
  lib/aws/storage_gateway/request.rb: Added bootstrap classes for AWS
  StorageGateway.

2012-12-11 Loren Segal <lsegal@amazon.com>

  * features/sqs/messages.feature, features/sqs/queues.feature,
  features/sqs/step_definitions/messages.rb, lib/aws/sqs/queue.rb,
  spec/aws/sqs/queue_spec.rb: Implement SQS long polling

  Changes within AWS::SQS:

  * Queue#poll now accept a :wait_time_seconds parameter which sets the
    maximum amount of time that SQS should long poll for.
    Defaults to 15 seconds. To use the default set for all messages
    on the queue, pass in nil.
  * The :wait_time_seconds default does not apply to
    Queue#receive_message. For this method, you must pass the option
    directly, or set the global Queue#wait_time_seconds long polling
    value.
  * Added Queue#wait_time_seconds attribute to set the queue-wide
    long poll timeout value. This setting applies to all calls to
    Queue#receive_message or Queue#poll
  * Deprecates the Queue::DEFAULT_POLL_INTERVAL constant
  * Queue#poll no longer uses :poll_interval; use :wait_time_seconds
    instead.

2012-12-10 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/s3/s3_object.rb, spec/aws/s3/s3_object_spec.rb: S3Object#url_for
  now accepts objects that respond to #to_int as the :expires option.

  * lib/aws/sqs/client.rb: Update Amazon SQS client documentation

  * lib/aws/api_config/SQS-2011-10-01.yml,
  lib/aws/api_config/SQS-2012-11-05.yml, lib/aws/sqs/client.rb: Update Amazon
  SQS api_version and client methods

  * lib/aws/api_config/SQS-2011-10-01.yml: Update SQS with WaitTimeSeconds
  input

  * lib/aws/s3/bucket_lifecycle_configuration.rb: Resolved an issue where
  AWS::S3::BucketLifecycleConfiguration::Rule documentation was not getting
  generated (was behind private).

2012-12-08 Sean Laurent <organicveggie@gmail.com>

  * lib/aws/ec2/instance_collection.rb: Added documentation to
  AWS::EC2::InstanceCollection.create() to describe support for launching
  ebs_optimized instances.

2012-12-06 Loren Segal <lsegal@amazon.com>

  * features/dynamo_db/crc32.feature,
  features/dynamo_db/step_definitions/crc32.rb,
  features/dynamo_db/step_definitions/items.rb: Add DynamoDB CRC steps for
  manipulating large items (gzip validation)

  * features/support/common.rb: Allow loading test credentials from
  environment

2012-11-29 Loren Segal <lsegal@amazon.com>

  * lib/aws/s3/cors_rule_collection.rb: Fix doc for incorrectly named param
  tag

  * spec/aws/sns/originators/from_auto_scaling_spec.rb: revert to ruby 1.8.x
  hash-syntax

  (CI runs tests using ree-1.8.7)

2012-11-15 Loren Segal <lsegal@amazon.com>

  * README.rdoc: Update getting started with samples command

  References #85

  * README.rdoc: Update README to point to new GitHub repository

  Fixes #85

2012-11-07 Trevor Rowe <trevorrowe@gmail.com>

  * ChangeLog, lib/aws/version.rb: Bump version to 1.7.1

2012-11-06 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/core/signature/version_3_https.rb: Added x-amz-security-token
  header for signature version 3 https requests when a session token is
  provided.

2012-11-02 Trevor Rowe <trevorrowe@gmail.com>

  * CONTRIBUTORS.txt: Added a contributors file.

  * ChangeLog, lib/aws/version.rb: Bump version to 1.7.0

2012-10-29 Trevor Rowe <trevorrowe@gmail.com>

  * features/dynamo_db/batch_get.feature,
  features/dynamo_db/step_definitions/batch_get.rb,
  features/dynamo_db/step_definitions/batch_write.rb,
  lib/aws/dynamo_db/batch_get.rb, lib/aws/dynamo_db/table.rb,
  spec/aws/dynamo_db/batch_get_spec.rb, spec/aws/dynamo_db/table_spec.rb:
  Added support for consistent reads to AWS::DynamoDB::BatchGet.

  * features/dynamo_db/batch_write.feature,
  features/dynamo_db/step_definitions/batch_write.rb,
  features/dynamo_db/step_definitions/dynamo_db.rb: Sped up a few of the
  DynamoDB batch write integration tests.

  * lib/aws/api_config/DynamoDB-2011-12-05.yml, lib/aws/dynamo_db/client.rb:
  Added consistent read to AWS::DynamoDB::Client#batch_get input and outputs.

  * lib/aws/rds/event_collection.rb: Removed the empty file for
  AWS::RDS::EventCollection.

  * lib/aws/core.rb: Corrected the documentation on
  AWS.config.dynamo_db_big_decimals.

  * lib/aws/rds/config.rb: Corrected the default RDS endpoint, now
  'rds.us-east-1.amazonaws.com'.

  * lib/aws/rds/client.rb: Documented AWS::RDS::Client API operation methods.

  * lib/aws/rds.rb: Added basic documentation for the AWS::RDS service
  interface.

  * lib/aws/api_config/RDS-2012-07-31.yml, lib/aws/rds/db_instance.rb,
  lib/aws/rds/db_instance_collection.rb, lib/aws/rds/db_snapshot.rb,
  lib/aws/rds/db_snapshot_collection.rb, lib/aws/rds/event_collection.rb:
  Added missing attribution comment blocks to a few scripts.

  * lib/aws/api_config/RDS-2012-07-31.yml: Revert "Added api configuration for
  RDS."

  This reverts commit c6beb0537b7bbe84190e6aeed1e73e19aaff2ea4.

  * lib/aws/rds.rb, lib/aws/rds/client.rb, lib/aws/rds/config.rb,
  lib/aws/rds/errors.rb, lib/aws/rds/request.rb: Revert "Wired up a basic RDS
  client."

  This reverts commit cdabb8967b6c20cb4e2458d406688b47228d3c70.

  * lib/aws/rds/client.rb: Revert "Documented the RDS API operations in
  AWS::RDS::Client."

  This reverts commit 5db2951ab8a24004631ef4b3fc25e3979bdfc89a.

  * lib/aws/dynamo_db/item_collection.rb: Corrected documentation on
  AWS::DynamoDB::ItemCollection on how to limit items returned.

2012-10-26 Loren Segal <lsegal@amazon.com>

  * features/dynamo_db/crc32.feature,
  features/dynamo_db/step_definitions/crc32.rb,
  features/dynamo_db/step_definitions/dynamo_db.rb,
  lib/aws/dynamo_db/client.rb, lib/aws/dynamo_db/config.rb,
  spec/aws/dynamo_db/client_spec.rb: Add CRC32 integrity checking to DynamoDB

  * features/support/common.rb: Only run SimpleCov on cucumber when COVERAGE
  is set

  * features/dynamo_db/step_definitions/dynamo_db.rb: Remove extra whitespace
  in a test

2012-11-01 Trevor Rowe <trevorrowe@gmail.com>

  * features/rds/client.feature, features/rds/step_definitions/client.rb:
  Shortened the feature/scenario table for RDS::Client#describe_events.

  * features/rds/client.feature, features/rds/step_definitions/client.rb:
  Added a basic integration test for the RDS client.

  * features/rds/client.feature, features/rds/step_definitions/rds.rb,
  lib/aws/rds/db_instance.rb: AWS::RDS::DBInstance#snapshots now uses the
  correct filter.

  * lib/aws/api_config/RDS-2012-07-31.yml, spec/aws/rds/client_spec.rb: Fixed
  a bug in the api_config for RDS where EVERY element was wrapped, when not
  all are.

  * lib/aws/rds/db_snapshot.rb, spec/aws/rds/db_snapshot_spec.rb: Added unit
  tests for AWS::RDS::DBSnapshot.

  * lib/aws/rds/db_snapshot_collection.rb,
  spec/aws/rds/db_snapshot_collection_spec.rb: Added unit tests for
  RDS::DBSnapshotCollection.

  * lib/aws/rds/db_instance.rb, lib/aws/rds/db_instance_collection.rb,
  spec/aws/rds/db_instance_collection_spec.rb,
  spec/shared/collection/with_limit_and_next_token_examples.rb: Added unit
  tests for AWS::RDS::DBInstanceCollection.

  * lib/aws/rds/db_instance.rb, lib/aws/rds/db_snapshot.rb,
  spec/aws/rds/client_spec.rb, spec/aws/rds/db_instance_spec.rb: Added unit
  tests for AWS::RDS::DBInstance.

  * spec/aws/core/xml/parser_spec.rb, spec/aws/rds/client_spec.rb: Added unit
  test for nested ignore rules to the XML parser.

  * lib/aws/api_config/RDS-2012-07-31.yml: Added wrapping elements to the RDS
  output shapes so the XML can be correctly parsed.

2012-10-31 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/rds.rb, lib/aws/rds/client.rb, lib/aws/rds/db_instance.rb,
  lib/aws/rds/db_instance_collection.rb, lib/aws/rds/db_snapshot.rb,
  lib/aws/rds/db_snapshot_collection.rb: Documented a large number of
  methods/attributes, added additional attirbutes to the RDS interfaces.

  * lib/aws/s3/request.rb, lib/aws/s3/s3_object.rb: AWS::S3::S3Object #url_for
  and #public_url now share the same default behavior.

  Previously, #url_for would check config.use_ssl for the default
  http/https mode.  #public_url instead always defaulted to https,
  ignoring config.use_ssl.  They both now default to the mode specified
  in config.use_ssl.

  Also, they both now work with alternative ports for testing against
  local endpoints at non-standard ports (outside of 443 and 80).

  * features/s3/high_level/objects.feature, lib/aws/s3/request.rb: Fixed an S3
  signing bug where the canonicalized amz header values were not trimmed of
  whitespace.

  * features/s3/high_level/objects.feature,
  features/s3/high_level/step_definitions/objects.rb,
  features/sts/step_definitions/sessions.rb, lib/aws/s3/s3_object.rb: Fixed a
  bug in generating presigned GET requests for S3.

2012-09-20 Neville Kadwa <neville@kadwa.com>

  * lib/aws/api_config/RDS-2012-07-31.yml, lib/aws/rds.rb,
  lib/aws/rds/db_instance.rb, lib/aws/rds/db_instance_collection.rb,
  lib/aws/rds/db_snapshot.rb, lib/aws/rds/db_snapshot_collection.rb,
  lib/aws/rds/event_collection.rb: add snapshot modeling

2012-09-18 Neville Kadwa <neville@kadwa.com>

  * lib/aws/rds.rb, lib/aws/rds/db_instance_collection.rb: cleanup

  * lib/aws/api_config/RDS-2012-07-31.yml, lib/aws/rds.rb,
  lib/aws/rds/db_instance.rb, lib/aws/rds/db_instance_collection.rb: add
  db_instance collection and instance funcitonality

2012-09-17 Neville Kadwa <neville@kadwa.com>

  * lib/aws/api_config/RDS-2012-07-31.yml: needed methods working

  * lib/aws/api_config/RDS-2012-07-31.yml, lib/aws/rds.rb,
  lib/aws/rds/client.rb, lib/aws/rds/config.rb, lib/aws/rds/errors.rb,
  lib/aws/rds/request.rb: base rds implementation

2012-10-30 Nate Mueller <nate@nearbuysystems.com>

  * lib/aws/ec2/reserved_instances.rb: Added state attribute to
  reserved_instances

2012-10-24 Marco Carvalho <marco@ebehavior.com.br>

  * lib/aws/cloud_watch/metric.rb: Fixed: Wrong param name: expected
  metric_name and metric_item was set

2012-10-23 walmc <walmc@amazon.com>

  * samples/cloud_watch/alarm_with_custom_metrics.rb: CloudWatch Alarm
  changing state via custom metric sample

  * samples/cloud_watch/create_delete_alarm.rb: simple create/delete/set_state
  CloudWatch Alarms sample

2012-10-20 Oliver Hookins <oliver@soundcloud.com>

  * lib/aws/s3/client.rb, lib/aws/s3/object_collection.rb,
  spec/aws/s3/client_spec.rb, spec/aws/s3/object_collection_spec.rb: Add MFA
  authentication to S3 multiple object deletions.

2012-10-19 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/cloud_watch/alarm.rb: Corrected documentation on
  AWS::CloudWatch::Alarm#alarm_actions.

  * lib/aws/s3/bucket_tag_collection.rb: Corrected a yard doc tag (typo in tag
  name).

2012-10-16 carljparker <carljparker@gmail.com>

  * lib/aws/s3/s3_object.rb: Update lib/aws/s3/s3_object.rb

  Fix typo: server_size_encryption should be server_side_encryption
2012-10-15 Jamis Buck <jamis@37signals.com>

  * lib/aws/s3/s3_object.rb, spec/aws/s3/s3_object_spec.rb: endpoint, port,
  and force_path_style should be inherited from config

2012-10-12 Loren Segal <lsegal@amazon.com>

  * .travis.yml, README.rdoc: Only run Travis on master branch

2012-10-11 Loren Segal <lsegal@amazon.com>

  * README.rdoc: Update README with Travis build status

  * .travis.yml, tasks/rvm_tester.rake: Don't test jruby on Travis (running
  out of memory)

  * tasks/rspec.rake: Don't need specdoc output for RSpec

  * spec/aws/rails_spec.rb: Reset Config after Rails tests

  * spec/aws/core/options/xml_serializer_spec.rb: Fix XML serializer tests
  matcher usage

  * spec/shared/signature/version_4_examples.rb: Fix broken tests that were
  hashed for GMT-8

  * spec/aws/record/hash_model/class_methods_spec.rb: Cleanup after modifying
  AWS.config in test

2012-10-10 Loren Segal <lsegal@amazon.com>

  * tasks/scan.rake, tasks/secret_scanner.rb: Secret scanner rake task no
  longer used

  * Rakefile: Load vendor Rakefiles into rake tasks

  * .gitignore: Ignore vendor from git

  * lib/aws/s3/errors.rb: Removed a @private documentation tag from the
  AWS::S3::Errors module.

2012-10-09 Loren Segal <lsegal@amazon.com>

  * .travis.yml, Gemfile, tasks/rspec.rake, tasks/rvm_tester.rake: Add RVM
  tester and Travis CI support

  * spec/net/http/connection_pool/live_tests_spec.rb: Make
  Net::HTTP::ConnectionPool tests more reliable

  * Gemfile, spec/aws/config_spec.rb,
  spec/aws/core/options/xml_serializer_spec.rb,
  spec/aws/route_53/client_spec.rb,
  spec/aws/s3/bucket_lifecycle_configuration_spec.rb,
  spec/aws/s3/client_spec.rb, spec/aws/s3/s3_object_encrypt_spec.rb,
  spec/spec_helper.rb: Fix tests in JRuby

  * spec/shared/s3/paginated_collection_examples.rb: Fix broken spec

  * Gemfile, Rakefile: Reorder Gemfile to use standard group names

  * tasks/rcov.rake, tasks/rspec.rake: Remove rcov rake task, spec task takes
  COVERAGE env var

  * spec/aws/core/option_grammar_spec.rb, spec/aws/ec2/instance_spec.rb,
  spec/aws/simple_db/errors_spec.rb, spec/shared/record/shardable_examples.rb:
  Remove some pending tests and comment out EC2 instance tests for now

  * Gemfile: Update Gemfile with newer versions of RSpec, remove debug group

  * Gemfile: CI reporter library no longer used.

  * Gemfile: Remove autotest group from Gemfile

  * spec/aws/core/credential_providers_spec.rb: Stub out environment variables
  in DefaultProvider specs

  Avoids test failure if user has access keys provided in env.

  * lib/aws/api_config/EMR-2009-03-31.yml, lib/aws/emr/client.rb: Documented
  set_visible_to_all_users method on EMR client and alphabetized the api
  configuration.

  * lib/aws/api_config/EMR-2009-03-31.yml, lib/aws/emr/client.rb: Added
  VisibleToAllUser attributes to the EMR api configuration and documented them
  in the client.

2012-10-04 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws.rb, lib/aws/core.rb, lib/aws/core/configuration.rb: Added endpoint
  documentation and autoloading for RDS.

  * lib/aws/rds/client.rb: Documented the RDS API operations in
  AWS::RDS::Client.

  * lib/aws/rds.rb, lib/aws/rds/client.rb, lib/aws/rds/config.rb,
  lib/aws/rds/errors.rb, lib/aws/rds/request.rb: Wired up a basic RDS client.

  * lib/aws/api_config/RDS-2012-07-31.yml: Added api configuration for RDS.

  * lib/aws.rb, lib/aws/core.rb, lib/aws/core/configuration.rb: Added
  AWS::ElasticBeanstalk configuration documentation and autoloading hoooks.

  * lib/aws/api_config/ElasticBeanstalk-2010-12-01.yml,
  lib/aws/elastic_beanstalk.rb, lib/aws/elastic_beanstalk/client.rb,
  lib/aws/elastic_beanstalk/config.rb, lib/aws/elastic_beanstalk/errors.rb,
  lib/aws/elastic_beanstalk/request.rb: Added basic support for AWS Elastic
  Beanstalk.

  * lib/aws/core/inflection.rb, lib/aws/core/service_interface.rb: Provided a
  better inflection for ElastiCache (elasticache instead of elasti_cache).

  * lib/aws.rb, lib/aws/core.rb, lib/aws/core/configuration.rb: Documented
  ElastiCache endpoints and added autoloading hooks.

  * lib/aws/elasticache/client.rb: Documented ElastiCache client methods.

  * lib/aws/elasticache.rb, lib/aws/elasticache/client.rb,
  lib/aws/elasticache/config.rb, lib/aws/elasticache/errors.rb,
  lib/aws/elasticache/request.rb: Added basic ElastiCache classes.

  * lib/aws/api_config/ElastiCache-2012-03-09.yml: Added API configuration for
  ElastiCache.

  * features/dynamo_db/items.feature,
  features/dynamo_db/step_definitions/img.jpg,
  features/dynamo_db/step_definitions/items.rb: Added an integration test that
  uploads a small image as a DynamoDB attribute.

  * ChangeLog: Updated changelog.

  * lib/aws/version.rb: Bump version to 1.6.9

  * .yardopts, aws-sdk.gemspec: Removed NOTICE.txt from gem specification and
  yardopts.

  * lib/aws/api_config/EC2-2012-07-20.yml, lib/aws/ec2/client.rb: Resolved an
  issue with specifying security groups while requesting spot instances with
  AWS::EC2::Client.

  * lib/aws/s3/client.rb, lib/aws/s3/object_version.rb,
  lib/aws/s3/s3_object.rb, spec/aws/s3/client_spec.rb,
  spec/aws/s3/object_version_spec.rb: Add MFA credential support to S3 object
  version delete methods.

2012-10-08 Trevor Rowe <trevorrowe@gmail.com>

  * lib/aws/s3/object_collection.rb: Removed trailing whitespace from
  AWS::S3::ObjectCollection class file.

2012-10-03 Loren Segal <lsegal@amazon.com>

  * ChangeLog: Add ChangeLog

  * LICENSE.txt, NOTICE.txt: Remove NOTICE.txt; only LICENSE.txt is needed.

  Apache License 2.0 is still being used.

  * tasks/secret_scanner.rb: Make secret scanning configurable

2012-10-02 Loren Segal <lsegal@amazon.com>

  * Rakefile: Set default rake task to unit tests

  * tasks/gems.rake: Gems tasks no longer necessary

  * lib/aws/core.rb, lib/aws/version.rb: Move AWS::VERSION to separate file

  * .gitignore: Ignore .gem files from repository

  * spec/spec_helper.rb: Only use simplecov if COVERAGE env is set

  * aws-sdk.gemspec: Fix gemspec

  * aws-sdk.gemspec: Add gemspec

  * tasks/scan.rake: Exit with nonzero status if scan finds matches

  * .gitignore: Add .gitignore

  * tasks/scan.rake: Name secret scanner task

2012-10-01 Diego Elio Pettenò <flameeyes@flameeyes.eu>

  * spec/aws/s3/client_spec.rb: spec: do not compare data that can be
  differently sorter on Ruby 1.8

  * lib/aws/core/option_grammar.rb: Replace Ruby 1.9-specific syntax with
  syntax working for 1.8 as well.

  While it's less arcane, the 1.9-specific syntax break compatibility
  for nothing more than a function name.

2012-07-31 Yamashita Yuu <yamashita@geishatokyo.com>

  * lib/aws/core/rest_client/output_handler.rb, lib/aws/route_53.rb,
  lib/aws/route_53/change_batch.rb, lib/aws/route_53/change_info.rb,
  lib/aws/route_53/hosted_zone.rb, lib/aws/route_53/hosted_zone_collection.rb,
  lib/aws/route_53/resource_record_set.rb,
  lib/aws/route_53/resource_record_set_collection.rb,
  spec/aws/route_53/change_batch_spec.rb,
  spec/aws/route_53/change_info_spec.rb,
  spec/aws/route_53/hosted_zone_collection_spec.rb,
  spec/aws/route_53/hosted_zone_spec.rb,
  spec/aws/route_53/resource_record_set_collection_spec.rb,
  spec/aws/route_53/resource_record_set_spec.rb, spec/aws/route_53_spec.rb:
  added higher-level abstractions for Route53

2012-07-26 Peter Mounce <pete@neverrunwithscissors.com>

  * lib/aws/sns/message.rb, lib/aws/sns/originators/from_auto_scaling.rb,
  spec/aws/sns/originators/from_auto_scaling_spec.rb,
  spec/aws/sns/support/sns_as_instance_launch.json,
  spec/aws/sns/support/sns_as_instance_terminate.json: Add support for Message
  finding out its own origin.

  Introduce the concept of a message's origin, and introduce a partial
  implementation of
  an AutoScaling originator (partial, in that there's not coverage for all of
  the data that
  auto-scaling will include in the SNS' body).

  The origin-selection currently works simply; there's only one originator at
  present, so
  it's checked in-line in Message's initializer, rather than that iterating
  through the
  available originator modules.

  * lib/aws/sns.rb, lib/aws/sns/message.rb, spec/aws/sns/message_spec.rb,
  spec/aws/sns/support/sns_manually_sent.json: Add AWS::SNS::Message and
  build-in authenticity-checking.

  AWS::SNS::Message#authentic? will return true if the message is
  cryptographically authenticated
  (see
  http://docs.amazonwebservices.com/sns/latest/gsg/SendMessageToHttp.verify.si
  gnature.html).
  To-do:
  * support subscription-confirmation and unsubscribe messages; this just
  supports
  notifications.  Should just mean changes to canonical_string method.
  * decide whether it's really OK to return false in the event of the check
  throwing an error (for
  example, if the cert-download fails too often or times out).  Might be best
  to leave that up to
  the caller?

2011-11-10 Anthony Scotti <anthony.m.scotti@gmail.com>

  * samples/sns/publish.rb: Added a sample for SNS that publishes a message to
  a topic

2011-09-16 Duy Lam <duylam@kms-technology.com>

  * samples/simpledb/create_item_in_domain.rb: add sample for simpledb

  * samples/sqs/add_queue_message.rb: show friendly message on invalid queue
  name

  * samples/sqs/add_queue_message.rb: add sample for simple queue
